/*-----------------------------------------------------------------
	 Special version of FFT.H
	 Copyright (c) Quinn-Curtis, 1992

	 Filename:  FFT.H
	 Revision:  8.01    LAB
	 Date:      4/1/92

	 Description: -Fourier Analysis & Digital Filtering
-----------------------------------------------------------------*/


#include "reeltype.h" // Special version of realtype.h for realtype=float

#ifndef RECTANG
#define RECTANG 0
#define PARZEN  1
#define HANNING 2
#define WELCH   3
#define HAMMING 4
#define EXACTB  5
#endif


void WindowData(realtype *x,int numdat,int window);
void WindowFFTData(realtype *xreal,realtype *yimag, int numdat,int window);
void fft(realtype *xreal, realtype *yimag, int numdat, int flag);
void PowerSpectrumCalc(realtype *xreal, realtype *yimag,int numdat,realtype delta);
void fft2 (realtype *aa, realtype *bb, int n, int m, int ks);
void reorder (realtype *aa, realtype *bb, int n, int m, int ks, int reel);

// Added 07/16/08
void RealFFT2 ( realtype *x, realtype *sinc, int n, int inverse);
void rfft2 ( realtype *x, realtype *y, int n, int m, int ks);
void trans (realtype *x, realtype *y, int n, int eval);
realtype FFTMagnitude(realtype *xr, realtype *yi, int n, int i);
