/* hamdefs.tc1 -- standard definitions for THE HAMMER Library's C-routines
*                  See HAMDEFS.DOC for full description of HAMMER definitions
*
*   BORLAND's TURBO C Version 1.00
*
*            :::::  The HAMMER Library  Version 2.20  :::::
*            ::::: (C) Copyright 1987  O.E.S. Systems :::::
*/
/* Indicate C compiler in use: TURBO C V1.00
**      Same code as for Microsoft V4, except:
**              1. Microsoft's strcmpi() is stricmp() under Turbo C
**              2. Turbo C using register structure with one more field
**                 then Microsoft's: flags.
**      So we'll define MSC4 to use Microsoft code.
*/
#define TURBOC          1
#define MSC4            1

/* Microsoft C Compiler Version 4.00 */
#ifdef MSC4
#define MSC3  1         /* for conditionals in C source files */
#define EOS   '\0'
#define VOID  void
#define BOOL  int
#define BYTE  char
#define UCHAR unsigned char
#define ULONG unsigned long

#if(0)
/* #define min(a,b) (((a)<(b)) ? (a) : (b))  Removed */
/* #define max(a,b) (((a)>(b)) ? (a) : (b))  Conflicting Definitions */
/* #define abs(a) (((a)<0) ? (-(a)) : (a))   WJR 12/08/90 */
#endif

#endif

/* A few things for everybody */

/* some fundamentals */
#define TRUE  1
#define FALSE 0
#define YES 1
#define NO 0

/* for array look ups */
#define NOTFOUND (-1)

/* Command Menu "Home Depth", ESCape menu code, and CTRL-BRK menu code */
#define HOMEDPTH 0
#define ESCMENU (-1)
#define BRKMENU (-2)

/* Command Menu data structure:  Use an array of the following data */
/* structure to specify each menu's possible choices.               */

struct menu_str {
    char *label;	/* label to be displayed in top line menu   */
    char *detail;	/* detailed description of "current" label  */
    };

/* some Data Entry Field stuff */
struct df_str {
    int noflds;         /* number of data fields on screen      */
    int homefld;        /* starting ("home") field this screen  */
    };

/* video display attribute constants to be used with setvattr() */
#define NORMAL      0x07
#define REVERSE     0x70
#define NOECHOBLACK 0x00
#define NOECHOWHITE 0x77
#define ULINE       0x01
#define LOLITE      0x00
#define HILITE      0x08
#define NOBLINK     0x00
#ifndef BLINK
	#define BLINK       0x80     /* IFNDEF TO AVOID CONFLICT WITH CONIO.H */
#endif
#define NOCHANGE    0x22

/* keyboard character definitions for THE HAMMER input routines */
#define CTRLBRK     3
#define BELL        7
#define BS          8
#define LF         10
#define CR         13
#define ENTER      13
#define ESC        27
#define SPACE      0x20

/* THE HAMMER's Extended keyboard code values */
#define HAMKEYBASE 256
#define BACKTAB    271
#define F1         315
#define F2         316
#define HOME       327
#define UP         328
#define PAGEUP     329
#define LEFT       331
#define RIGHT      333
#define END        335
#define DOWN       336
#define PAGEDN     337
#define INS        338
#define DEL        339
#define CTRLLEFT   371
#define CTRLRIGHT  372
#define CTRLEND    373
#define CTRLPGDN   374
#define CTRLHOME   375
#define CTRLPGUP   388
#define HELP       315
#define EDIT       316
#define ENDSCN     324

/* some macro routines */
/* #define sign(a)  ((a)<0 ? (-1) : (1))    commented out to avoid
											conflict with GraphiC
											WJR 7/29/90            */
#define inrange(v,lo,hi) (((lo)<=(v)) && ((v)<=(hi)))

