/*****************************************************************************/
/*                                                                           */
/*                            INDEX.C                                        */
/*                                                                           */
/*		Index of all STABLE_W functions by source file                       */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_A.C                                     */
/*                                                                           */
/* 		Revised FrequenC functions:                                          */
/*                                                                           */
/*      FindMedian()                                                         */
/*      NewCalcFreqModSigma()                                                */
/*      NewCalcLogFreqDrift()                                                */
/*      ConvDomain()                                                         */
/*      CalcDomain()                                                         */
/*      AddSigma()                                                           */
/*      AddPSD()                                                             */
/*		quadratic()                                                          */
/*		hadamardev_f()                                                       */
/*		SpectrunCalc() & related S&E Tools functions                         */
/*		HistoCalc()                                                          */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_D.C                                     */
/*                                                                           */
/*		Dialog box functions:  (1st Group)                                   */
/*                                                                           */
/*		AboutDlgProc()                                                       */
/*      SigmaDlgProc()                                                       */
/*		SigmaControls()                                                      */
/*      AvgDlgProc()                                                         */
/*      NormDlgProc()                                                        */
/*      FillDlgProc()                                                        */
/*      ConvertDlgProc()                                                     */
/*		StatsDlgProc()                                                       */
/*      ScaleDlgProc()                                                       */
/*		CheckDlgProc()                                                       */
/*		GetOutlierData()                                                     */
/*		DriftDlgProc()                                                       */
/*		NoiseDlgProc()                                                       */
/*      CalendarDlgProc()                                                    */
/*      WriteCalendar()                                                      */
/*      DateConvt()                                                          */
/*		ConfigureDlgProc()                                                   */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_E.C                                     */
/*                                                                           */
/*		Editing Dialog Box Functions: (2nd Group)                            */
/*                                                                           */
/*      EditDlgProc()                                                        */
/*      GetRowData()                                                         */
/*      FindDlgProc()                                                        */
/*      ReplaceDlgProc()                                                     */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_F.C                                     */
/*                                                                           */
/* 		File functions:                                                      */
/*                                                                           */
/*      FileInitialize()                                                     */
/*      FileOpenDlg()                                                        */
/*      FileSaveDlg()                                                        */
/*      FileOpenHookProc()                                                   */
/*		FileSaveHookProc()                                                   */
/*      FileLength()                                                         */
/*      DataRead()                                                           */
/*		MulticolumnDataRead()                                                */
/*		MulticolumnDataAdd()                                                 */
/*		FileSize()                                                           */
/*		FileInfo()                                                           */
/*      FileWrite()                                                          */
/*      SigmaRead()                                                          */
/*		ReallocSigmaArrays()                                                 */
/*		DataWrite()                                                          */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_G.C                                     */
/*                                                                           */
/* 		GraphiC Functions:                                                   */
/*                                                                           */
/*      GPCWndProc()                                                         */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_H.C                                     */
/*                                                                           */
/*      Hammer Library date function replacements                            */
/*                                                                           */
/*		BreakDate()		Break Down Gregorian Date                            */
/*      DayOfWeek()		Return Day of Week for Gregorian Date                */
/*		DateToJulian()  Convert Gregorian Date to Julian Day Number          */
/*		JulianToDate()  Convert Julian Day Number to Gregorian Date          */
/* 		MakeDate()		Make Gregorian Date                                  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_M.C                                     */
/*                                                                           */
/*		Dialog Box Functions: (3rd Group)                                    */
/*                                                                           */
/*      TimetagDlgProc()                                                     */
/*      RegularizeDlgProc()                                                  */
/*		ClearDlgProc()                                                       */
/*		MulticolumnDlgProc()                                                 */
/*		DomainDlgProc()                                                      */
/*		RunDlgProc()                                                         */
/*      GetRunData()                                                         */
/*		ReadDlgProc()                                                        */
/*		GetSigmaData()                                                       */
/*		PrintDataDlgProc()                                                   */
/*		AbortProc()                                                          */
/*		PrintDlgProc()                                                       */
/*      PartDlgProc()                                                        */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_N.C                                     */
/*                                                                           */
/* 		Noise generation functions:                                          */
/*                                                                           */
/*      GenerateNoise()                                                      */
/*      f_beta()                                                             */
/*      four1()                                                              */
/*      gasdev()                                                             */
/*      rand1()                                                              */
/*      realft()                                                             */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_P.C                                     */
/*                                                                           */
/*		GraphiC plotting functions:                                          */
/*                                                                           */
/*		FreqPlot()                                                           */
/*      SigmaPlot()                                                          */
/*      PowerSpectrumPlot()                                                  */
/*      PhasePlot()                                                          */
/*      MsgBox()                                                             */
/*      TableBox()                                                           */
/*      HistoPlot()                                                          */
/*		Dateline()                                                           */
/*		PlotDlgProc()                                                        */
/*		TVARLabel()                                                          */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_Q.C                                     */
/*                                                                           */
/*      Misc file processing functions:                                      */
/*                                                                           */
/*      ReadIni()                                                            */
/*      WriteIni()                                                           */
/*		ReadFileInfo()                                                       */
/*		WriteFileInfo()                                                      */
/*		UpdateFileInfo()                                                     */
/*		ReadDataFile()                                                       */
/*		TooBigDlgProc()                                                      */
/*		OpenedDlgProc()                                                      */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_R.C                                     */
/*                                                                           */
/* 		Run functions:                                                       */
/*                                                                           */
/*      NoiseID()                                                            */
/*      EDF()                                                                */
/*      CalcPhaseHadamardDev()                                               */
/*      CalcFreqHadamardDev()                                                */
/*      MedDev()                                                             */
/*      MedDevCompare()                                                      */
/*      TotalFreq()                                                          */
/*      TotalDev()                                                           */
/*      TotalPhase()                                                         */
/*		CalcMTIE()                                                           */
/*		NewCalcInvChiSqr()                                                   */
/*  	CalcFreqOffset()                                                     */
/*  	RemoveFreqOffset()                                                   */
/*		NewRemoveQuadraticDrift()                                            */
/*		ReflectedTotalvarCalc()                                              */
/*		TotalvarBias()                                                       */
/*		NewAverageFreqData()                                                 */
/*		NewAveragePhaseData()                                                */
/*		CalcDiffusionFreqDrift()                                             */
/*		RemoveDiffusionFreqDrift()                                           */
/*		CalcNewPhaseModSigma                                                 */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_T.C                                     */
/*                                                                           */
/* 		Toolbar and edit control subclass functions:                         */
/*                                                                           */
/*		ToolbarWndProc()			Toolbar Window Procedure                 */
/*		RedrawToolbar()             Redraw Toolbar Buttons                   */
/*      WritePromptMessage()        Write Prompt Message in Status Bar       */
/*		InitializeToolbar()         Initialize Toolbar Structures            */
/*		ActivateFunctions()         Activate/Deactivate Data Functions       */
/*      EditProc()                  Subclass Edit Control Procedure          */
/*		WriteMessage()				Write General Message in Status Bar      */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_U.C                                     */
/*                                                                           */
/* 		Utility functions:                                                   */
/*                                                                           */
/*		InvokeDialogBox()		Wrapper Function to Invoke Dialog Box        */
/*		ClearDataArray()        Clear Phase or Frequency Data Array          */
/*      ClearTimetagArray()		Clear Phase or Frequency Timetag Array       */
/* 		CreateStatusBar()		Create Controls for Status Bar               */
/*		MoveStatusBarControls()	Move Status Bar Controls to Screen Position  */
/*      WriteProgressMessage()	Write Progress Message in Status Bar         */
/*      CalcSearchLimit()		Calculate Limits for Data Value Search       */
/*      DrawBitmap()            Draw Bitmap on a Display Surface             */
/*      WriteOutput()			Write Text on a Static Text Control          */
/*      WriteDateMessage()		Write Date on Status Bar                     */
/*		ValidateInteger()		Validate integer input vs allowable limits   */
/*		ValidateFloat()			Validate float input vs allowable limits     */
/*		AllocErrorMessage()		Display memory allocation error message      */
/*		TooFewMessage()         Display too few analysis points error msg    */
/*		IncExtension()			Increment filename extension                 */
/*		CannotBeZero()          Display value cannot be zero error message   */
/*		YieldControl()			Allow Windows to process other messages      */
/*		ClearLines()            Clear all plot lines                         */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_V.C                                     */
/*                                                                           */
/*      Plot initialization functions:                                       */
/*			                                                                 */
/*      InitPhasePlotParams()                     							 */
/*      InitFreqPlotParams()    				                  			 */
/*      InitSigmaPlotParams()    						                 	 */
/*		InitReadPlotParams(}                                                 */
/*	 	CalcSigmaPlotScale()                                                 */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_W.C                                     */
/*                                                                           */
/*      Main module:                                                         */
/*                                                                           */
/*      WinMain()                                                            */
/*		WndProc()                                                            */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                            STABLE_X.C                                     */
/*                                                                           */
/*		Plotting dialog box procedures:                                      */
/*                                                                           */
/*		PhasePlotDlgProc()                                                   */
/*      FreqPlotDlgProc()                                                    */
/*		SigmaPlotDlgProc()                                                   */
/*		SpectrumPlotDlgProc()                                                */
/*		ReadPlotDlgProc()                                                    */
/*      FreqLineDlgProc()                                                    */
/*      PhaseLineDlgProc()                                                   */
/*		SigmaLineDlgProc()                                                   */
/*      FreqNoteDlgProc()                                                    */
/* 		PhaseNoteDlgProc()                                                   */
/*		SigmaNoteDlgProc()                                                   */
/*                                                                           */
/*****************************************************************************/

