// Keycode.h
// Standard ASCII Virtual Keycodes
// Not defined in windows.h
// Are defined in winuser.h
// Created by WJR 04/20/01

// Digits
#define VK_0	0x30	// 0 key 
#define VK_1	0x31	// 1 key 
#define VK_2	0x32	// 2 key 
#define VK_3	0x33	// 3 key 
#define VK_4	0x34	// 4 key 
#define VK_5	0x35	// 5 key 
#define VK_6	0x36	// 6 key 
#define VK_7	0x37	// 7 key 
#define VK_8	0x38	// 8 key 
#define VK_9	0x39	// 9 key 

//	3A-40	Undefined

// Letters 
#define VK_A	0x41	// A key 
#define VK_B	0x42	// B key 
#define VK_C	0x43	// C key 
#define VK_D	0x44	// D key 
#define VK_E	0x45	// E key 
#define VK_F	0x46	// F key 
#define VK_G	0x47	// G key 
#define VK_H	0x48	// H key 
#define VK_I	0x49	// I key 
#define VK_J	0x4A	// J key 
#define VK_K	0x4B	// K key 
#define VK_L	0x4C	// L key 
#define VK_M	0x4D	// M key 
#define VK_N	0x4E	// N key 
#define VK_O	0x4F	// O key 
#define VK_P	0x50	// P key 
#define VK_Q	0x51	// Q key 
#define VK_R	0x52	// R key 
#define VK_S	0x53	// S key 
#define VK_T	0x54	// T key 
#define VK_U	0x55	// U key 
#define VK_V	0x56	// V key 
#define VK_W	0x57	// W key 
#define VK_X	0x58	// X key 
#define VK_Y	0x59	// Y key 
#define VK_Z	0x5A	// Z key

// Actions
#define VK_PRESS	0	// Press key
#define VK_RELEASE	2	// Release key

// The following are an attempt to get the SendInput() function to work
// because winuser.h doesn't seem to have them as it should
// A good reference for all of this is:
// http://msdn.microsoft.com/msdn-files/026/001/212/Tester/TInputHlp/Header%20Files/SendInput_h.htm
// SendInput() is supposed to be in User32.lib but linker can't resolve it
// Without User32.lib can't use SendInput() and the rest of this stuff is useless

#define INPUT_MOUSE     0 
#define INPUT_KEYBOARD  1 
#define INPUT_HARDWARE  2 

typedef struct tagMOUSEINPUT {
  LONG			dx;
  LONG			dy;
  DWORD			mouseData;
  DWORD			dwFlags;
  DWORD			time;
  DWORD			dwExtraInfo;	// Instead of ULONG_PTR
} MOUSEINPUT, *PMOUSEINPUT;

typedef struct tagKEYBDINPUT {
	WORD		wVk;
	WORD		wScan;
	DWORD		dwFlags;
	DWORD		time;
	DWORD		dwExtraInfo;	// Instead of ULONG_PTR

} KEYBDINPUT, *PKEYBDINPUT;

typedef struct tagHARDWAREINPUT {
  DWORD   uMsg;
  WORD    wParamL;
  WORD    wParamH;
} HARDWAREINPUT, *PHARDWAREINPUT;

typedef struct tagINPUT{
	DWORD type;
	union {
		MOUSEINPUT		mi;
		KEYBDINPUT		ki;
		HARDWAREINPUT	hi;
	};
} INPUT, *PINPUT, FAR* LPINPUT;

WINUSERAPI 
UINT 
WINAPI 
SendInput( 
    UINT    cInputs,     // number of input in the array 
    LPINPUT pInputs,      // array of inputs 
    int     cbSize);     // sizeof(INPUT) 
