/***************************************************************************/
/*                                                                         */
/*                       ::::::::::::::::::::::                            */
/*                       :::::: NOISE.H :::::::                            */
/*                       ::::::::::::::::::::::                            */
/*                                                                         */
/*		Header File for STABLE/WIN Clock Noise Generation Functions        */
/*                                                                         */
/*		Revision record:                                                   */
/*			03/31/96		Adapted from STABLE/DOS version                */
/*                                                                         */
/* 		W. Riley   (c) Hamilton Technical Services   All Rights Reserved   */
/*                                                                         */
/***************************************************************************/

// NOTE: EVENTUALLY SHOULD COMBINE THIS WITH STABLE_W.H

/* Include Files: */
#include <math.h>
#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <dos.h>
#if(0)
#include <nr.h>
#endif

/* Defines: */
#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr
#define TRACE_I(flag) printf(#flag "=%d\n", flag);         /* trace an int */
#define TRACE_F(flag) printf(#flag "=%e\n", flag);        /* trace a float */
#define M1 259200L                                       /* made L 2/13/93 */
#define IA1 7141L                                                 /* ditto */
#define IC1 54773L                                                /* ditto */
#define RM1 (1.0/M1)
#define M2 134456L                                                /* ditto */
#define IA2 8121L                                                 /* ditto */
#define IC2 28411L                                                /* ditto */
#define RM2 (1.0/M2)
#define M3 243000L                                                /* ditto */
#define IA3 4561L                                                 /* ditto */
#define IC3 51349L                                                /* ditto */

/* Function Declarations: */
void FAR PASCAL _export GenerateNoise(F_TYPE fSigma[], F_TYPE fOffset,
	F_TYPE fDrift, F_TYPE fTau, int nNum);
void FAR PASCAL _export four1(float huge *data, int nn, int isign);
void FAR PASCAL _export realft(float huge *data, int n, int isign);
float huge *FAR PASCAL _export dvector(int nl, int nh);
void FAR PASCAL _export free_dvector(float huge *v, int nl);
float FAR PASCAL _export ran1(int *idum);
float FAR PASCAL _export gasdev(int *idum);
int FAR PASCAL _export f_beta(int n_pts, float x[], float Q_d, float b,
	int *idum, int add_flag);
void FAR PASCAL _export nrerror(char *);
