/*****************************************************************************/
/*                                                                           */
/*                            STABLE_W.C                                     */
/*                                                                           */
/*		Windows 95/98/NT/2000/XP/Vista/7/8/10 32-bit version of STABLE       */
/*                                                                           */
/*		Operating Environment:		Windows 95 and higher                    */
/*		Windows API					Win32                                    */
/*		Programming Environment:	Microsoft Visual C++ 5.0                 */
/*		Programming Language:		Standard C                               */
/*		Project Directory:			C:\Program Files\DevStudio\MyProjects\   */
/*									Stable32                                 */
/*		Project Name:				Stable32                                 */
/*		Project Files:				STABLE_W.IDE	Project IDE File         */
/*									STABLE_W.DEF	Module Definition File   */
/*									STABLE_W.H      Header File              */
/*						(# Lines)	STABLE_W.RC     Resource File            */
/*		C Source Files:  			STABLE_A.C		Rev FrequenC Functions   */
/*							3794    STABLE_B.C		Automation Functions     */
/*                                  STABLE_C.C		Multitaper PSD Functions */
/*						   17235    STABLE_D.C		Dialog Box Procs         */
/*							4257	STABLE_E.C		Edit Box Functions       */
/*							2887	STABLE_F.C		File Functions           */
/*							1000	STABLE_G.C		GraphiC Functions        */
/*                                  STABLE_H.C		Hammer Library Clones    */
/*                           365    STABLE_I.C		Misc Support Functions   */
/*                                  STABLE_J.C		Not Used                 */
/*                           461    STABLE_K.C		Speed-Optimized Functs   */
/*							2367	STABLE_L.C		Configure Property Sheet */
/*						   17159	STABLE_M.C		Dialog Box Procs         */
/*							 219	STABLE_N.C		Noise Gen Functions      */
/*							5789	STABLE_O.C		Database Functions       */
/*							7024	STABLE_P.C		Plotting Functions       */
/*							4242	STABLE_Q.C		Misc File Functions      */
/*							1744	STABLE_R.C		Run Functions            */
/*                                  STABLE_S.C		Plot Scale Functions     */
/*							1470	STABLE_T.C		Toolbar Functions        */
/*							1931	STABLE_U.C		Utility Functions        */
/*                          1277    STABLE_V.C		Plot Initializations     */
/*							9479	STABLE_W.C		Main Source File         */
/*						   20817	STABLE_X.C		Plot Dlg Box Procs       */
/*                          1978    STABLE_Y.C		Status Bar Functions     */
/*                          2437    STABLE_Z.C		Archive File Functions   */
/*      Total(project)    107941    (As of 08/02/07)                         */
/*                                                                           */
/*      Additional C Files:			STABLE_AA.C     NR Poly Fit (not used)   */
/*                                  STABLE_BB.C     S&E Polynomial Fitting   */
/*                                  STABLE_CC.C     levmar LM fit (not used) */
/*                                  STABLE_DD.C     Function parse/eval      */
/*                                  STABLE_EE.C     NR LM Fit (not used)     */
/*                                  STABLE_FF.C     lmmin Nonlinear Fitting  */
/*                                  STABLE_GG.C     Student's t (not used)   */
/*                                  STABLE_HH.C     Regime Shifts (not used) */
/*                                  STABLE_II.C     Lomb periodogram "       */
/*                                                                           */
/*		Programming Notes:		Stable32 is a SDI Win32 application written  */
/*                              in Standard C w/o C++ or MFC.  It is         */
/*                              structured in a classic MS Windows fashion,  */
/*                              using the GET_WM_COMMAND_ID message cracker  */
/*                              macros.  Two major 3rd party items are used, */
/*                              GraphiC for the plotting functions and       */
/*                              DataTable for the grid controls.  The        */
/*                              FrequenC DLL is used for many analysis       */
/*                              functions, and the License DLL is used to    */
/*                              validate the user to allow free distribution */
/*                              of updates.  A major data feature is the use */
/*                              of phase and frequency data and timetag      */
/*                              arrays.  Several struts are defined in the   */
/*                              STABLE_W.H header file.  Many global         */
/*                              variables are used for easy interfunctional  */
/*                              communications.                              */
/*                                                                           */
/*		Example of call to extended memory allocation error message:         */
/*								AllocErrorMessageEx(__FILE__, __LINE__,      */
/*								(nSize+ARRAY_OFFSET)*sizeof(F_TYPE));        */
/*		where the only variable argument is the last one giving the # bytes  */
/*		requested to be allocated.                                           */
/*															                 */
/*      Functions in this top-level source file:                             */
/*                                                                           */
/*      WinMain()                                                            */
/*		WndProc()                                                            */
/*      ParseCommandLine()                                                   */
/*                                                                           */
/*		Revision record:                                                     */
/*			06/29/97	Use GET_WM_COMMAND_ID, etc. WIN32 compatibility      */
/*						macros to process WM_COMMAND messages:               */
/*						wParam <- GET_WM_COMMAND_ID(wParam, lParam)          */
/*						HIWORD(lParam) <- GET_WM_COMMAND_CMD(wParam, lParam) */
/*			07/13/97	More Win32 compatibility changes                     */
/*			11/30/97	Added provisions for license code                    */
/*			12/24/97	Made changes for AOK BC 32 bit compliation           */
/*			01/25/98	Many changes for enhanced status bar                 */
/*			02/06/98	Replace GHND memory allocation flag macro with       */
/*						MEM_TYPE which S/B GHND for Win16 & GPTR for Win32   */
/*			03/21/98	Many changes made in the way directories handled:    */
/*						Now read working directory from argv[0] at startup.  */
/*						Store that drive, directory & path in globals        */
/*						szDrive, szDirectory & szPath respectively, and      */
/*						use that szPath to set up paths to help & ini files. */
/*						Also add szPath to GPCWIN in the local environment.  */
/*						This doesn't require any installation effort,        */
/*						machine configuration, registry or INI file entries. */
/*						Nor is it subject to user changes.                   */
/*						It simply requires all supporting files to be in the */
/*						same directory as the program.                       */
/*			05/22/99	Added provisions for Lite version                    */
/*			04/22/00	Made changes for Student version                     */
/*			04/28/01	Added automation functions                           */
/*			01/04/03	Removed some lines for commctrl.h and graphic.h      */
/*						Now compiles completely warning-free                 */
/*			03/21/03	Major changes completed for FrequenC DLL V2.0        */
/*			03/24/03	Added provisions for Demo version                    */
/*			11/02/05	Began coding of Ver 1.45.  Objectives are to update  */
/*			thru		variance names, and add masks to stability plots.    */
/*          11/18/05    Defer ability to directly access TSC MMS database    */
/*                      (still in Beta as separate MMSDbase application),    */
/*						and dynamic AVAR function (essentially complete)     */
/*                      until next release.                                  */
/*			11/29/05	Version 1.46 with DAVAR essentially done.  Wait to   */
/*						see how soon it will be released before putting 1.45 */
/*						upgrade on web site.  1.46 may include MMSDbase.     */
/*			12/03/05	Add SQL database dialog boxes to Stable_w.rc         */
/*			05/07/06	Version 1.46c with bReadOK Database logic fix        */
/*			11/16/06	Added file tabs                                      */
/*			12/11/06	Begin preparing Version 1.50                         */
/*						Major changes expected: HTML Help & FrequenC 3.0     */
/*						Start integrating Stable32.chm HTML help file        */
/*			12/31/06	Changed to FrequenC DLL Version 3.0                  */
/*			02/14/07	Added memory leak debug code                         */
/*						Fixed a couple minor leaks - now 100% clean          */
/*			05/03/07	Created student version 1.50                         */
/*			07/22/07	Started work on full version 1.51                    */
/*			07/29/07    Changed to safe string functions                     */
/*						Added audio function                                 */
/*			07/31/07	Added function key commands                          */
/*                      The following change was made to C:\Program Files\   */ 
/*                      DevStudio\VC\INCLUDE\commctrl.h:                     */
/*                      Three defines removed to avoid redefinition conflict */
/*                      #define HDS_HORZ                0x0000               */
/*                      #define HDS_BUTTONS             0x0002               */
/*                      #define HDS_HIDDEN              0x0008               */
/*			01/15/08	Started work on full version 1.53                    */
/*			05/13/08	Started work on full version 1.54                    */
/*          01/28/09	Started work on full version 1.55                    *
/*						Error fixed in median function                       */
/*			04/08/09	Changed User Manual filename in SHIFT-F1 command     */
/*						Added SHIFT-F2 command to launch Handbook            */
/*			04/28/09	Version 1.55 ready for release                       */ 
/*          04/29/09	Built Student version 1.55                           */
/*          07/27/09	Started work on full version 1.56                    */
/*			05/21/10	Version 1.56 complete                                */
/*          05/22/10	Built Student version 1.56                           */
/*          05/23/09	Started work on full version 1.57                    */
/*			07/14/10	Added automatic opening of normalize dialog          */
/*			10/24/10	Version 1.57 ready for release                       */
/*						Started work on full version 1.58 (no changes yet)   */
/*          04/17/11	Built Student version 1.57                           */
/*			09/24/11	Version 1.58 complete                                */
/*			09/26/11	Started work on version 1.59 (no changes yet)        */
/*			11/24/11	Add code for command line automation                 */
/*			03/04/12	Version 1.59 complete                                */
/*          05/08/12	Built Student version 1.59                           */
/*			06/02/13	Version 1.60 complete                                */
/*          05/19/14	Built Student version 1.60                           */
/*          07/23/16	Started work on full version 1.61                    */
/*                      Changes made:                                        */
/*                      1.  Allow 3-cornered hat error bars whenever         */
/*                          possible                                         */
/*						2.  Add ini file item to select octave/decade/all    */
/*                          tau in Run                                       */
/*                      3.  Add integrated phase jitter and residual FM      */
/*                          to Domain function                               */
/*          10/23/16	Rebuilt full version 1.61a with all menu items       */
/*          11/03/17	Version 1.62 (final)                                 */
/*						Revised for free IEEE UFFC distribution              */
/*                      Support and license terms changed                    */
/*                      All rights to be transferred to IEEE UFFC as of      */
/*						01/01/18                                             */
/*                      Disregard copyright notices in all source files      */
/*          11/10/17	Version 1.62 complete                                */
/*                                                                           */
/*  (c) 1996-2017 W. Riley Hamilton Technical Services All Rights Reserved   */
/*                                                                           */
/*****************************************************************************/

#define STRICT 				// For Win32 compatibility
//#define MEM_LEAK_DET		// Define for memory leak detection

#ifdef MEM_LEAK_DET
// Define for memory leak detection
#define _CRTDBG_MAP_ALLOC
#endif

// Include the stable_w header file
#include "stable_w.h"           	// STABLE_W header file

// Status bar control location header file
#include "location.h"				// Status bar control locations

#ifdef MEM_LEAK_DET
// Special debugging header for memory leak detection
#include <crtdbg.h>
#endif

// Define to allow GraphiC
#define GPC_IN

// Windows global variables
extern int __argc;
extern char** __argv;

// Global variables
HANDLE hInst;						// Application instance handle
HWND hwndMain;						// Main window handle
HWND hwndToolbar; 					// Toolbar window handle
HWND hDialog;						// Dialog box handle
HWND hPlot;							// Plot window handle
HWND hGPC;							// GraphiC main window handle
HWND hwndTab;						// Tab control window handle
HWND hPlotBox;						// Plot box handle
int nTimeZone;						// Time zone (hours wrt UTC)
int nDummy;							// To avoid compiler warnings, etc.

// Timing
int nTick;							// For timing
int nTock;							// Ditto

// Font
int nFontHeight=-75;				// logfont.lfHeight font height
int nPointSize=9;					// Text point size for printouts

// Audio
int nSampleRate=11025;				// Audio sampling rate

// Globals to pass data for nonlinear fit evaluation (ugly)
int nGlobalNumParam;		// # function parameters
char *pGlobalExpression;	// pointer to function expression string

// Bitmap handles
HBITMAP hUnsavedBitmap;
HBITMAP hTimetagsBitmap;
HBITMAP hTagSrcBitmap;
HBITMAP hTagMskBitmap;
HBITMAP hTooFewBitmap;
HBITMAP hFewSrcBitmap;
HBITMAP hFewMskBitmap;
HBITMAP hLimitsBitmap;
HBITMAP hLimitSrcBitmap;
HBITMAP hLimitMskBitmap;
HBITMAP hSynchBitmap;
HBITMAP hSynchSrcBitmap;
HBITMAP hSynchMskBitmap;
HBITMAP hUnsynchBitmap;
HBITMAP hSplashBitmap;
HBITMAP hPhaseColorBitmap;
HBITMAP hPhaseMonoBitmap;
HBITMAP hFreqColorBitmap;
HBITMAP hFreqMonoBitmap;

HBRUSH hBrush;
HDC hdc;
HMENU hMenu;						// Handle to main menu
MENUITEMINFO mii;					// Menu item info structure
HCURSOR hWait;						// Handle to hourglass cursor
HCURSOR hArrow;						// Handle to normal cursor
TEXTMETRIC tm;
RECT rc;
PAINTSTRUCT ps;
int txt_len;
char txt_buf[BUFFER_SIZE+1];
char msg_buf[BUFFER_SIZE+1];
int nTagFormat=TAGFORMAT_MJD;		// Timetag display format

// Handles for modeless dialog boxes
HWND hDlgModeless;
HWND hDlgModeless2;

// Automation thread variables
HANDLE hAutoThread;					// Handle to automation thread
DWORD dwAutoThreadID;				// Automation thread ID

// Handle for accelerators
HANDLE hAccel;

// Printing control global variables
BOOL   bUserAbort;
HWND   hDlgPrint;

// Buffer for trace macro
// Don't try to make string bigger - for some reason that doesn't work
// Apparently an undocumented limitation of MessageBox()
// I have old note warning of possible GPF error if string made too big
char szTrace[BUFFER_SIZE+1];

// Buffer for date string
char szDate[BUFFER_SIZE+1];

// Buffer for command line averaging factor
char szCmdAF[BUFFER_SIZE+1];

// Buffer for command line start and end points
char szCmdStart[BUFFER_SIZE+1];
char szCmdEnd[BUFFER_SIZE+1];

// Data file text buffers
char szFirstRaw[BIG_BUFFER_SIZE+1]; 	// Large text buffer for first raw line of data file
char szFirstParse[BIG_BUFFER_SIZE+1]; 	// Large text buffer for first parsed line of data file
char szRaw[BIG_BUFFER_SIZE+1]; 			// Large text buffer for raw input data file
char szParse[BIG_BUFFER_SIZE+1];		// Large text buffer for parsed input data file

	// Buffers for date & time string
char szMDYHM[BUFFER_SIZE+1];
char szMDYHMS[BUFFER_SIZE+1];

// DLL Handles
HMODULE hFCLib;					   	// FrequenC DLL (FREQUEC32.DLL)
HMODULE hDTLib;					   	// DataTable DLL (DTBL32.DLL)
HMODULE hLicense;                   // Stable32 License DLL (LICENS32.DLL)

// Repaint after leaving toolbar flag
BOOL bPaintFlag;

// Define array of toolbar data structures
TOOLBUTTON tb[NUM_TOOLS];

// Filename variables
char *szFile;
char *szFileTitle;
char *szPhaseFile;
char *szPhaseFileTitle;
char *szFreqFile;
char *szFreqFileTitle;
char *szStabFile;
char *szPSDFile;
char *szAutoFile;
char *szStabFileTitle;
char *szPrevStabFile;
char *szPrevStabFileTitle;
char *szCornFileA;
char *szCornFileB;
char *szCornFileC;
char *szPhasePlotInsertFile;
char *szFreqPlotInsertFile;
char *szStabPlotInsertFile;
char *szACFPlotInsertFile;
char *szWaveFilename;			// Wave sound filename
char *szAudioPlayer;		    // Audio player filename

// Drive & path variables
char *szDrive;					// DOS drive name where program started
char *szDirectory;				// DOS directory where program started
char *szPath;					// Path where program started
char *szHelpFile;				// Full path & filename to Stable32 help
char *szIniFile;				// Full path & filename to Stable32 ini
char *szPlayFile;				// Full path & filename to Play/Win
char *szArcIndexFile;			// Full path & filename to archive index file
char *szLogFile;				// Full path & filename for log file
char *sz5110CommFile;			// Full path & fileneme for 5110Comm program

// Command line variables
char *szCommandFile;	    	// Filename from command line
BOOL bAutoload=FALSE;       	// Flag for autoloading command line data
BOOL bCommandFileType;			// Data type from command line
F_TYPE fCommandTau;		    	// Tau value from command line

// Notepad program name
char *szNotepad;

// Dialog Box Title
char *szBoxTitle;

// Arrays of pointers previous full filename strings
char *szPreviousPhaseFilename[NUM_FILENAMES];
char *szPreviousFreqFilename[NUM_FILENAMES];

// Input string buffer (not global)
char szInputStr[BUFFER_SIZE+1];

// Web addresses
char szURL[BUFFER_SIZE+1];		// HTS web site URL
char szEMail[BUFFER_SIZE+1];	// HTS E-Mail address

// Command line buffer (global)
char *szCmdLine;

// Print message string
char *szPrnMsg;

// Global variables for data file reading
int nDataFileSize;		// Size of (possibly large) data file
int nDataFileRejects;   // # rejected data file lines
int nBigAvgFactor=1;	// Avg factor to use when reading large data files
int nMaxSize;			// Max allowable size of data file
int nTooBigOption;
int nComments;						// # UNIX # comment lines in data file
F_TYPE fFileTau;
char *szFileText;
BOOL bCancelDataRead;
BOOL bWarnZeroFreq;				// Warn if 2 adjacent phase points equal
int nTagCol=1;       			// Column # of timetag
int nDatCol=1;       			// Column # of data

// Global current MJD value
long int lnMJD;                    // Current Modified Julian Day #

// Tau value inputs from INI file
F_TYPE fPhaseTauInput=1.0;		// Phase tau value from ini file
F_TYPE fFreqTauInput=1.0; 		// Freq tau value from ini file

// Scaling values from INI file
F_TYPE fPhaseAddend=0.0;		// Offset added to phase data
F_TYPE fFreqAddend=0.0;			// Offset added to freq data
F_TYPE fPhaseScaled=1.0;		// Phase data scaling factor
F_TYPE fFreqScaled=1.0;			// Freq data scaling factor
F_TYPE fPhaseAddendInput=0.0;	// Addend to be added to phase data
F_TYPE fFreqAddendInput=0.0;	// Addend to be added to freq data
F_TYPE fPhaseMultiplierInput=1.0;	// Multiplier factor for phase data
F_TYPE fFreqMultiplierInput=1.0;	// Multiplier factor for freq data
F_TYPE fPhaseTagScale=1.0;		// Mult factor for phase timetag time scale					
F_TYPE fFreqTagScale=1.0;		// Mult factor for freq timetag time scale					
F_TYPE fPhaseTagOffset=0.0;		// Offset value for phase timetag time scale					
F_TYPE fFreqTagOffset=0.0;		// Offset value for freq timetag time scale

// Global variables for data parameters
F_TYPE fPhaseOffsetRemoved=0.0;	 // Avg value removed from phase data
F_TYPE fFreqOffsetRemoved=0.0;   // Avg value removed from freq data
F_TYPE fPhaseSlopeRemoved=0.0;   // Quad freq slope removed from phase data
F_TYPE fFreqSlopeRemoved=0.0;    // Lin freq slope removed from freq data

// Global variables for plot labels
int nPPlotX=0;					// Phase data plot x-axis label #
int nPPlotY=0;					// Phase data plot y-axis label # (not used)
int nFPlotX=0;					// Freq data plot x-axis label #
int nFPlotY=0;					// Freq data plot y-axis label # (not used)
BOOL bFXDefault=TRUE;			// Init freq data plot x-scale to default
BOOL bPXDefault=TRUE;			// Initial phase data plot x-scale to default
BOOL bAXDefault=TRUE;			// Initial auto data plot x-scale to default

// Global variables for slope parameters
F_TYPE fLogA=0.0;				// Calculated log fit a parameter
F_TYPE fLogB=0.0;				// Calculated log fit b parameter
F_TYPE fLogSlope=0.0;			// Calc log fit slope/tau interval at end
F_TYPE fDiffusionSlope=0.0;		// Calculated diffusion fit slope at end
F_TYPE fDiffB=0.0;				// Calculated diffusion fit b parameter
F_TYPE fDiffC=0.0;				// Calculated diffusion fit c parameter
F_TYPE fSlopeSpec=0.0;			// Log drift slope spec value
BOOL bSlopeSpec=FALSE;			// Log drift slope spec flag

// Global value of run calc time limit
float fRunLimit=60;				// Run calc time limit, sec

int nPhaseGapsFilled=0;			// # gaps filled in phase data
int nFreqGapsFilled=0;			// # gaps filled in freq data
int nOutliersRemoved=0;			// # freq outliers removed
int nSigmaSize=1;				// Size of sigma data array
int nSkipChar=0;				// # non-numeric chars to skip in data line
int nManySize=500;				// # points for many tau plot screen

// # File tabs
int nNumFreqTabs=0;				// # active freq tabs
int nNumPhaseTabs=0;			// # active phase tabs
int nTab=0;						// Selected tab #

// Global variables for control preferences
// Used for ini file access - local statics then initialized to these values
int nGlobalSigmaType=0;			// Sigma type
int nGlobalRunType=0;			// Run type
int nGlobalPhaseDriftType=0;	// Phase drift type
int nGlobalFreqDriftType=0;		// Freq drift type
int nFTag=FTAG_FIRST;			// Freq timetag type

// Global variables for main window size & position
int nMainLeft=0;				// Main window left position in pixels
int nMainTop=0;					// Main window top posision in pixels
int nMainRight=0;				// Main window right position in pixels
int nMainBottom=0;				// Main window bottom position in pixels

// Global variable for last configure property sheet page # (zero-based)
int nConfigPage=0;				// Last open config page #

// Edit class procedure
FARPROC lpfnOldEdit;
HWND hwndEdit;

// Function pointer to Edit control subclass
FARPROC lpfnEditProc;

// Data Flags
BOOL bDataType=FREQ_DATA; 		// 0=phase, 1=frequency
BOOL bLastOpened=PHASE_DATA;	// Data type of last file opened
BOOL bPhaseFlag=FALSE;			// Phase data active
BOOL bFreqFlag=TRUE;			// Freq data active
BOOL bPhaseData=FALSE;			// Phase data exists
BOOL bFreqData=FALSE;			// Freq data exists
BOOL bPhaseTimetags=FALSE;     	// Phase timetag data exists
BOOL bFreqTimetags=FALSE;      	// Freq timetag data exists
BOOL bPhaseDataChanged=FALSE;	// Phase data changed since last saved
BOOL bFreqDataChanged=FALSE; 	// Freq data changed since last saved
BOOL bAutoPhaseDataRead=TRUE;	// Phase data read since last Auto opened
BOOL bAutoFreqDataRead=TRUE;	// Freq data read since last Auto opened
BOOL bPhaseScaleChanged=TRUE;  	// Flag=new phase data plot scale needed
BOOL bFreqScaleChanged=TRUE;   	// Flag=new freq data plot scale needed
BOOL bNoiseGenerated=FALSE;		// Flag for noise generated
BOOL bPhaseRedraw=FALSE;		// Flag=phase data plot needs to be redrawn
BOOL bFreqRedraw=FALSE;			// Flag=freq data plot needs to be redrawn
BOOL bArchiveData=FALSE;		// Flag=Archive data selected
BOOL bPhaseTauDefault=TRUE;		// Flag=no phase tau input in INI file
BOOL bFreqTauDefault=TRUE;		// Flag=no freq tau input in INI file
BOOL bNoZeroFreq=TRUE;			// Flag to replace zero freq with 1e-99
BOOL bCommandTau=FALSE;			// Flag that tau entered on cmd line
BOOL bNewInputs=FALSE;			// Flag that inputs changed
BOOL bSQL=TRUE;					// Flag to use SQL database dialog
BOOL bPhaseDataUnsaved=FALSE;	// Flag that phase data is unsaved
BOOL bFreqDataUnsaved=FALSE;	// Flag that freq data is unsaved

// Process Flags
BOOL bOutRem=FALSE;			    // Flag=frequency outliers removed
BOOL bPhaseGapFill=FALSE;		// Flag=phase gaps filled
BOOL bFreqGapFill=FALSE;		// Flag=frequency gaps filled
BOOL bPhaseNorm=FALSE;			// Flag=phase data normalized
BOOL bFreqNorm=FALSE;			// Flag=frequency data normalized
BOOL bLinDriftRem=FALSE;		// Flag=linear drift removed from f data
BOOL bLogDriftRem=FALSE;		// Flag=log drift removed from f data
BOOL bDiffDriftRem=FALSE;		// Flag=diffusion drift removed from f data
BOOL bQuadDriftRem=FALSE;		// Flag=quadratic drift removed from p data
BOOL bFreqOffsetRem=FALSE;		// Flag=freq offset removed from phase data
BOOL bPhaseAddend=FALSE;		// Flag=offset added to phase data
BOOL bFreqAddend=FALSE;			// Flag=offset added to freq data
BOOL bPhaseScaled=FALSE;		// Flag=phase data scaled
BOOL bFreqScaled=FALSE;			// Flag=freq data scaled
BOOL bOpenScale=FALSE;			// Flag to scale data when file opened
BOOL bBusy=FALSE;				// Flag to indicate process underway
BOOL bManyTau=TRUE;				// Flag to use many rather than all tau
BOOL bACFNoiseID=TRUE;			// Flag to use lag 1 ACF noise ID method
BOOL bDoPhasePlotInsert=FALSE;	// Flag to put insert into phase plot
BOOL bDoFreqPlotInsert=FALSE;	// Flag to put insert into frequency plot
BOOL bDoStabPlotInsert=FALSE;	// Flag to put insert into stability plot
BOOL bDoACFPlotInsert=FALSE;	// Flag to put insert into autocorrelation plot
BOOL bAutoRunPlot=FALSE;		// Flag to automatically do stability plot
BOOL bAutoPowerPlot=FALSE;		// Flag to automatically do power spectrum plot
BOOL bAutoACFPlot=FALSE;		// Flag to automatically do autocorr plot
BOOL bAutoHistoPlot=FALSE;		// Flag to automatically do histogram plot
BOOL bZeroPad=TRUE;				// Flag to use zero padding in PSD FFTs
BOOL bNormPhasePlot=FALSE;		// Flag that phase data must be normalized for plot
BOOL bNormFreqPlot=FALSE;		// Flag that freq data must be normalized for plot

// Process values
int nCmdVarianceType=0;			// Command line variance type

// Data file header items
int nDCol=0;					// Column # of data (1 based)
int nTCol=0;					// Column # of timetags (1 based)

// Automation flags
BOOL bAuto=FALSE;				// Flag for automated operation
BOOL bAuto1=FALSE;				// Flag for automation script 1
BOOL bAuto2=FALSE;				// Flag for automation script 2
BOOL bAuto3=FALSE;				// Flag for automation script 3
BOOL bAutoCmd=FALSE;			// Flag that auto script invoked on cmd line

// Trial code 11/19/11
// Function command flags
BOOL bCmdLine=FALSE;			// Flag for any cmd line function
BOOL bCmdA=FALSE;				// Flag for autocorrelation function
BOOL bCmdC=FALSE;				// Flag for convert function 
BOOL bCmdD=FALSE;				// Flag for drift function 
BOOL bCmdH=FALSE;				// Flag for histogram 
BOOL bCmdN=FALSE;				// Flag for normalize function 
BOOL bCmdM=FALSE;				// Flag for copy metafile function 
BOOL bCmdO=FALSE;				// Flag for check function 
BOOL bCmdP=FALSE;				// Flag for data plot function 
BOOL bCmdR=FALSE;				// Flag for run function 
BOOL bCmdS=FALSE;				// Flag for spectrum function 
BOOL bCmdT=FALSE;				// Flag to print plot function
BOOL bCmdV=FALSE;				// Flag for average function 
BOOL bCmdX=FALSE;				// Flag to close plot
BOOL bCmdZ=FALSE;				// Flag to close program 
BOOL bCmdQ=FALSE;				// Flag to display command line help 
BOOL bCmdU=FALSE;				// Flag to select part of data

// Special command line command for diagnostics
// Set here or with -* on command line
BOOL bSpecialCmd=FALSE;			// Flag for special diagnostics 

// Automation values
int nAuto=0;					// Script #
char *szScriptname;				// Script name

// Other Flags
BOOL bDriftDetails=FALSE;		// Use detailed drift dialog box format
BOOL bSigmaDetails=FALSE;		// Use detailed sigma dialog box format
BOOL bCheckDetails=FALSE;		// Use detailed check dialog box format
BOOL bWideEdit=FALSE;           // Use wide edit dialog box format
BOOL bSaveTimetags=FALSE;		// Save timetags along with data
BOOL bUseFreqPlotIni=FALSE;		// Use freq plot params from ini file
BOOL bUsePhasePlotIni=FALSE; 	// Use phase plot params from ini file
BOOL bUseSigmaPlotIni=FALSE;	// Use sigma plot params from ini file
BOOL bUseHistoPlotIni=FALSE; 	// Use histo plot params from ini file
BOOL bUseSpectPlotIni=FALSE;	// Use spect plot params from ini file
BOOL bUseAutoPlotIni=FALSE;		// Use auto plot params from ini file
BOOL bUseDAVARPlotIni=FALSE;	// Use DAVAR plot params from ini file
BOOL bAbort=FALSE;				// Abort flag
BOOL bYield=FALSE;				// Yield flag
BOOL bShowFileOpened=FALSE;		// Show file opened dlg box when file read
BOOL bIncExtension=FALSE;		// Increment filename ext when new data
BOOL bWriteSigmaFile=TRUE;		// Write stability data file to disk
BOOL bAdd=FALSE;				// Flag for data file added
BOOL bRemove=FALSE;				// Run drift remove flag
BOOL bAutoCalc=TRUE;            // Flag for automatic calculation
BOOL bAutoPlot=TRUE;            // Flag for automatic plotting
BOOL bAutoPlotSave=FALSE;		// Flag to save bAutoPlot state
BOOL bAutoExec=TRUE;            // Flag for automatic execution
BOOL bAllTau=FALSE;	 			// All tau increment flag
BOOL bLongLine=FALSE;	 	   	// Multicol data input line>80 chars
BOOL bSynch=FALSE;				// Data synch flag (p & f data equivalent)
BOOL bStatusPlot=TRUE;			// Flag to do status bar data plots
								// Set by user in Config dialog box
BOOL bTest=FALSE;               // General test flag
BOOL bDetailedLog=FALSE;		// Detailed log flag
BOOL bShowWelcome=TRUE;			// Flag to show opening welcome box
BOOL bShowPlot=TRUE;			// Flag to allow display of status plots
								// Set by system according to main window size
BOOL bSplash=TRUE;				// Flag to control display of splash screen
BOOL bGlobalNormFreq=FALSE;		// Global flag for freq norm during conv
BOOL bGlobalXferTags=FALSE;		// Global flag for timetag xfer during conv
BOOL bComma=FALSE;				// Flag for European comma decimal point
BOOL bSmartScale=TRUE;			// Flag for "nice" data plot scales
BOOL b1of2=FALSE;				// Flag=scale variance for 1 of 2 units
BOOL bHeader=FALSE;				// Flag to write header at top of data file
BOOL bSkip=FALSE;				// Flag to skip multicolumn & file opened
								// dialogs when reading data from command line
BOOL bNoGreek=FALSE;			// Don't use Greek characters
BOOL bForceTagTransfer=FALSE;	// Flag to force timetag transfer in Convert
BOOL bUseTags=FALSE;			// Flag to use timetags for tau in convert
BOOL bTabs=FALSE;				// Flag for showing file tabs
BOOL bTabFile=FALSE;			// Flag to create tab if new data file
BOOL bTabChange=FALSE;			// Flag to create tab if changed data file
BOOL bTabNoise=FALSE;			// Flag to create tab if noise data generated
BOOL bTabEdit=FALSE;			// Flag to create tab if data edited
BOOL bWriteAppend=FALSE;		// Flag for appending stability file
BOOL bUnixComment=TRUE;			// Flag for UNIX comment in data file

// Plot style
int nStyle=ORIGINAL_STYLE;		// Plot style

// Data Arrays and handles
HANDLE hFreqData;
HANDLE hPhaseData;
F_TYPE *fData;
F_TYPE *fFreqData;
F_TYPE *fPhaseData;
F_TYPE *fFreqTimetags;
F_TYPE *fPhaseTimetags;
F_TYPE *fTags;
F_TYPE *fNew;
// Note:  Four data arrays are allocated, fPhaseData, fFreqData, fPhaseTimetags
//        and fFreqTimetags, for phase, frequency and timetag data respectively
//        The fData pointer is set to the active phase or freq data array.

// Power Spectrum data arrays (Fourier freq, PSD value, & avg factor)
// Memory for these arrays is allocated and freed in SpectrumPlotDlgProc()
float *fFreq;
float *fPSD;
float *fAF;

// Histogram bins and counts
// Memory for these arrays is allocated and freed in HistoPlotDlgProc()
float *fBins;
float *fHist;

// Autocorrelation data array
// Note: Memory will allocated for this array later
float *fAuto;

// Plot Label Variables
BOOL bPlotLabel;
char *szPlotLabel;

// Arrays of pointers to char arrays for saving user-entered plot title,
// subtitle & message strings of plot option dialog boxes.  These pointers are
// used to dynamically allocate memory for saving these strings between times
// when the phase, freq, sigma, spect & histo plot option dlg boxes are opened.
// There is one set of these arrays, and the data is thus shared between the
// various plots.  The active # of strings is nUserTitles, nUserSubtitles &
// nUserMessages.  All these variables are globals visible to all functions.
// Each used char* points to a char array of max size TITLESIZE+1=29,
// SUBTITLESIZE+1=51 or MESSAGESIZE+1=61.  The ptr arrays are set to sizes
// NUM_TITLES=16, NUM_SUBTITLES=16 or NUM_MESSAGES=16 respectively.  If these
// sizes are 16, then there are 16*3=48 bytes used by these pointers, plus
// 16*3=48 bytes min string allocation.  The space for the actual strings will
// be dynamically reallocated as needed.  For example, to store the ith plot
// title option, allocate memory for it with:
// szPlotTitle[i]=(LPSTR)realloc(szPlotTitle[i], (TITLESIZE+1)*sizeof(char));
// The maximum sizes possible are 16*(29+51+61)=2256 (a reasonable #).

char *szPlotTitle[NUM_TITLES];
char *szPlotSubtitle[NUM_SUBTITLES];
char *szPlotMessage[NUM_MESSAGES];

int nUserTitles=0;       			// # user-entered title strings
int nUserSubtitles=0;   		    // # user-entered subtitle strings
int nUserMessages=0;     			// # user-entered message strings

// PSD auto AF plot parameters
int nPSDAvgSize;
int nPSDAvgMax;
int nPSDLFSkip;

// Arrays of pointers to floats for saving mask sigma & tau points
// Memory is allocated for these arrays with:
// fMaskSigma[i]=(float*)realloc(fMaskSigma[i], (MASKSIZE)*sizeof(float));
// fMaskTau[i]=(float*)realloc(fMaskTau[i], (MASKSIZE)*sizeof(float));
// Points are stored in them by statements like:
// fMaskSigma[i][j]=fSigmaPoint; where i=mask #, j=point #
// fMaskTau[i][j]=fTauPoint; where 1=mask #, j=pont #
// Data is read from them by statements like:
// fSigmaPoint=fMaskSigma[i][j]; where i=mask #, j=point #
// fTauPoint=fMaskTau[i][j]; where i=mask #, j=point #
// These arrays are filled with mask data from disk when sigma plot lines
// are selected, and are then used in sigma plot to plot mask points
// Allocate each element of these arrays to MASKSIZE = 2 floats up front
// They will be reallocated as needed later
// nMaskRows is just simple array to hold # sigma & tau points - no alloc reqd
float *fMaskSigma[SLINE_NUMLINES];
float *fMaskTau[SLINE_NUMLINES];
int nMaskRows[SLINE_NUMLINES];	// # rows of mask data (array size)

// Plotdata structures
// The string arrays of these plotdata structs are dynamically allocated
// They are declared as externs (globals) in STABLE_W.H and defined here
// They are initialized in GPCWndProc() before being used
// in FreqPlot(), PhasePlot(), SigmaPlot(), HistoPlot or PowerSpectrumPlot().
// Their contents are changed in the FreqPlotDlgProc(), PhasePlotDlgProc(),
// SigmaPlotDlgProc(), HistoPlotDlgProc() and PowerPlotDlgProc() dialog procs.
// Ditto for new autocorrelation plot struts

struct plotdata sFPlot;  			// Frequency data plot data
struct plotdata sFPrev;  			// Previous freq data plot data
struct plotdata sPPlot;  			// Phase data plot data
struct plotdata sPPrev;  			// Previous phase data plot data
struct plotdata sSPlot;  			// Sigma plot data
struct plotdata sSPrev;  			// Previous sigma plot data
struct plotdata sHPlot; 			// Histo plot data
struct plotdata sHPrev;  			// Previous histo plot data
struct plotdata sPSPlot; 			// Power spectrum plot data
struct plotdata sPSPrev; 			// Previous power spectrum plot data
struct plotdata sAPlot;  			// Autocorrelation plot data
struct plotdata sAPrev;  			// Previous autocorrelation plot data

// d3plotdata structure
// It is declared as extern (global) in STABLE_W.H and defined here
// The 3 float and 4 string arrays of this struct are dynamiccally allocated
// if and where used in DynamicStabilityDlgProc()
struct d3plotdata sDPlot;  			// Dynamic stability plot data

// Linedata structures
struct linedata sFLine[FLINE_NUMLINES]; // Array of freq plot line data
struct linedata sPLine[PLINE_NUMLINES]; // Array of phase plot line data
struct linedata sSLine[SLINE_NUMLINES]; // Array of sigma plot line data

// Notedata structures
struct notedata sFNote[FNOTE_NUMNOTES]; // Array of freq plot note data
struct notedata sPNote[PNOTE_NUMNOTES]; // Array of phase plot note data
struct notedata sSNote[SNOTE_NUMNOTES]; // Array of sigma plot note data

// Sigmadata structures
struct sigmadata sNormSigData;  	// Normal & overlapping sigma data struct
struct sigmadata sModSigData;   	// Modified & time sigma data struct
struct sigmadata sAllNormSigData;  	// All tau normal & overlap sigma data struct
struct sigmadata sAllModSigData;   	// All tau mod & time sigma data struct

// Corndata structures
struct corndata sCornData;  	    // 3-cornered hat sigma data struct
struct corndata sCornResults;  	    // 3-cornered hat sigma results struct

// Tabdata structures
struct tabdata sFTab[FTAB_NUMTABS];	// Array of freq tab data
struct tabdata sPTab[PTAB_NUMTABS];	// Array of phase tab data

// Spur struct
struct spur sSpur;					// PSD spur data struct

HWND hwndFreqResetButton, hwndPhaseResetButton;

// Handles of phase & freq plot windows
HWND hwndPhasePlot, hwndFreqPlot;

// Handles of phase & freq select buttons
HWND hwndPhaseSelectButton, hwndFreqSelectButton;

// Handles of phase and freq "File: label windows
HWND hwndPhaseFileLabel, hwndFreqFileLabel;

// Handles of phase and freq "Total #: label windows
HWND hwndPhaseNumLabel, hwndFreqNumLabel;

// Handles of phase and freq total # windows
HWND hwndPhaseNum, hwndFreqNum;

// Handles of phase and freq "#: label windows
HWND hwndPhaseLimLabel, hwndFreqLimLabel;

// Handles of phase and freq analysis limit # windows
HWND hwndPhaseLim, hwndFreqLim;

// Handles of phase and freq "Tau: label windows
HWND hwndPhaseTauLabel, hwndFreqTauLabel;

// Handles of phase and freq "Start: label windows
HWND hwndPhaseStartLabel, hwndFreqStartLabel;

// Handles of phase and freq "End: label windows
HWND hwndPhaseEndLabel, hwndFreqEndLabel;

// Handles of filename edit boxes
HWND hwndFreqFilename, hwndPhaseFilename;

// Handles of tau edit boxes
HWND hwndFreqTau, hwndPhaseTau;

// Handles of analysis limit edit boxes
HWND hwndFreqStart, hwndPhaseStart;
HWND hwndFreqEnd, hwndPhaseEnd;

// Screen metrics
int cxChar, cyChar; 				// Character size
int cxIcon, cyIcon; 				// Icon size
int cxMain, cyMain; 				// Main window client size
int cxClient, cyClient;

int i;								// General index

int ToolFlag_1=TOOLBUTTON_OUT;
int ToolFlag_2=TOOLBUTTON_IN;
int ToolFlag_3=TOOLBUTTON_DIM;

int nPlotType=SAMPLE_PLOT;
int nSigmaPlotType=NORMAL_SIGMA;
int nTauIncrement=TAU_OCTAVE;     	// Tau increment type

char szThisAppName[] = "Stable Main";   // Main window classname
char szToolbarName[] = "Toolbar Child";	// Child window classname
char *szExtensionFilter;	// Ptr to string for user-defined filename ext
char *szExternalPattern;	// Ptr to string for external filename pattern

// Start of code
// Windows main entry function
// Returns integer
// Uses PASCAL calling sequence
// HANDLE hInstance is ID # of running program
// HANDLE hPrevInstance is ID # of previous instance of program (if any -
// NULL if no previous instance is still running)
// LPSTR lpszCmdParam is command line argument string - not used
// int nCmdShow is # indicating how window is to be initially shown

/*****************************************************************************/
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
						  LPSTR lpszCmdParam, int nCmdShow)
{
	// Local macros
	#define SPLASH_TIME		1000	// Min splash screen display time in ms
	#define WELCOME_MESSAGE	   1	// Define to show welcome message
	// #define BETA_MESSAGE	   2	// Define to show beta message
	// #define DEMO_MESSAGE	   3	// Define to show demo message

	// Local variables
	MSG msg;						// Message
	WNDCLASS wndclass;				// Window class
	HWND hwndSplash;                // Handle to splash window
    HDC hdcSplash;					// Handle to splash window device context 
	clock_t clkDone;				// Clock time when delay done
	BOOL bAllocError=FALSE;  		// Flag for memory allocation error
	char szEnvironment[FILE_NAME_SIZE+8];

	#ifdef DEMO_VERSION
	int nInstall;					// MJD when demo program installed
	int nCurrent;					// Current MJD
	int nDay;						// Install day
	int nMonth;						// Install month
	int nYear;						// Install year
	char szBuffer[BUFFER_SIZE+1];	// Text buffer
	static int k[]={KEY_0, KEY_1, KEY_2, KEY_3}; // Encryption key
	unsigned int v[2];				// Encryption variable
	#endif

	if((szDrive=(LPSTR)malloc((_MAX_DRIVE+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szDirectory=(LPSTR)malloc((_MAX_DIR+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szIniFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPlayFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPath=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szLogFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sz5110CommFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Announce memory allocation error
	if(bAllocError)
	{
		AllocErrorMessage();
		return 0;
	}

	// Get working directory from arg[0]
	// This is better than using the current working directory
	// because it is always the full path where program started
	// regardless of how the program's working directory is set up
	// or what directory is currently active on the computer

	_splitpath(__argv[0], szDrive, szDirectory, NULL, NULL);
	strlcpy(szPath, szDrive, FILE_NAME_SIZE);
	strlcat(szPath, szDirectory, FILE_NAME_SIZE);

	// Set up the full ini file path & name
	strlcpy(szIniFile, szPath, FILE_NAME_SIZE);
	#ifdef FULL_VER
	strlcat(szIniFile, "STABLE32.INI", FILE_NAME_SIZE);
	#endif
	#ifdef LITE_VER
	strlcat(szIniFile, "STABLE_L.INI", FILE_NAME_SIZE);
	#endif
	#ifdef STUDENT_VER
	// strlcat(szIniFile, "STABLE_S.INI"); // Up to version 1.40
	strlcat(szIniFile, "STABLE32.INI", FILE_NAME_SIZE);
	#endif
	#ifdef VITSAS_VER
	strlcat(szIniFile, "STABLE32.INI", FILE_NAME_SIZE);
	#endif

	// Set up the full log file path & name
	strlcpy(szLogFile, szPath, FILE_NAME_SIZE);
	#ifdef FULL_VER
	strlcat(szLogFile, "STABLE32.LOG", FILE_NAME_SIZE);
	#endif
	#ifdef LITE_VER
	strlcat(szLogFile, "STABLE_L.LOG", FILE_NAME_SIZE);
	#endif
	#ifdef STUDENT_VER
	strlcat(szLogFile, "STABLE32.LOG", FILE_NAME_SIZE);
	#endif
	#ifdef VITSAS_VER
	strlcat(szLogFile, "STABLE32.LOG", FILE_NAME_SIZE);
	#endif

	// Set up the full 5110Comm file path & name
	strlcpy(sz5110CommFile, szPath, FILE_NAME_SIZE);
	strlcat(sz5110CommFile, "5110Comm.exe", FILE_NAME_SIZE);

	#ifdef DEMO_VERSION
	// Check validity of demo version license
	// Read installation date from WIN.ini file.  The install MJD
	// is stored as two encrypted values v0= and v1= in the [Elbats] section
	// (Stable spelled backwards)
	// The installation calendar date is written into the [License] section
	// of Stable32.ini to further obscure the issue (it is not used)
	// After first use, the Stable32.ini file will look like:
	// [Version]
	// Name=Stable32			(fixed text)
	// Type=Demo				(fixed text)
	// Ver=1.40					(fixed text)
	// [License]				
	// License=30 Day			(fixed text)
	// InstallDate=07-24-2003	(written at first use)

	// Get install MJD as encrypted v0 and v1 from [Elbats] section of WIN.INI
	// The defaults correspond to unencrypted v0 and v1 both 0
	// which flags a new installation for which there is no WIN.INI entry
	v[0]=GetProfileInt("Elbats", "v0",	V_ZERO);
	v[1]=GetProfileInt("Elbats", "v1",	V_ONE);

	// Decrypt install MJD
	Decode(v, k);

	// Check validity: v[0] should be 0 - if not, quit
	if(v[0])
	{
		MessageBox(NULL, "Invalid Stable32 Demo Version License",
			"Invalid License", MB_OK | MB_ICONHAND);
		// Program return
		return 0;
	}
	
	// Put v[1] into nInstall
	nInstall=v[1];

	// Get current MJD
	nCurrent=(int)GetMJD();

	// Is nInstall set?
	if(nInstall)
	{
		// Is demo version invalid (i.e. outside 30-day limit)?
		if((nCurrent-nInstall)>30)
		{
			// Display error message
			MessageBox(NULL,
				"The 30-day time limit of your Demo Version\n"
				"of Stable32 has been exceeded.  Please\n"
				"consider buying the Full version of the program.\n",
				"License Expired", MB_OK | MB_ICONHAND);

			// Program return
			return 0;
		}
		// Is date order invalid?
		else if(nCurrent<nInstall)
		{
			// Display error message
			MessageBox(NULL,
				"The installation date of your Demo Version\n"
				"of Stable32 is invalid.",
				"License Invalid", MB_OK | MB_ICONHAND);

			// Program return
			return 0;
		}
		else // Demo version still OK
		{
			// Display message
			_snprintf(szBuffer, sizeof(szBuffer),
				"Your license for this Demo Version\n"
				"of Stable32 will expire in %d days.", 30+nInstall-nCurrent);
			MessageBox(NULL, szBuffer, "License Status",
				MB_OK | MB_ICONEXCLAMATION);
		}
	}
	else // Newly installed (nInstall=0)
	{
		// Encrypt install MJD
		v[0]=0;
		v[1]=nCurrent;
		Encode(v, k);
		
		// Store encrypted installation date in [Elbats] section of WIN.INI
		_snprintf(szBuffer, sizeof(szBuffer), "%u", v[0]);
		WriteProfileString("Elbats", "v0", szBuffer);
		_snprintf(szBuffer, sizeof(szBuffer), "%u", v[1]);
		WriteProfileString("Elbats", "v1", szBuffer);

		// Calc calendar date
		MJDToDate(nCurrent, &nDay, &nMonth, &nYear);
		
		// Store calendar date in Stable32.ini
		_snprintf(szBuffer, sizeof(szBuffer),
			"%02d-%02d-%04d", nMonth, nDay, nYear);
		WritePrivateProfileString("License", "InstallDate", szBuffer,
			szIniFile);
	}
	#endif

	// Display splash bitmap before Stable opens
	// Read bSplash from Preferences section of STABLE32.INI configuration file
	bSplash=GetPrivateProfileInt("Preferences", "Splash", 1, szIniFile);

	if(bSplash)
	{
		hSplashBitmap=LoadBitmap(hInstance, "SPLASH");

		// Create splash window
		hwndSplash=CreateWindow("static", NULL, WS_POPUP | WS_VISIBLE,
			0, 0, 1000, 500, NULL, NULL, hInstance, NULL);

		// Get handle to splash window device context
		hdcSplash=GetDC(hwndSplash);

		// Show splash screen
		DrawBitmap(hdcSplash, hSplashBitmap, (short)175, (short)70);

		// Add minimum delay for splash screen display
		clkDone=(clock_t)SPLASH_TIME + clock();
		while(clkDone>clock())
		{
			;
		}

		// Free device context 
		ReleaseDC(hwndSplash, hdcSplash);

		// Destroy splash screen
		DestroyWindow(hwndSplash);
 
		DeleteObject(hSplashBitmap);
	}
	// #endif
	
	// Load 32-bit DataTable DLL
	hDTLib=LoadLibrary("dtbl32.dll");
	if((UINT)hDTLib<=32)
	{
		MessageBox(NULL, "Unable to load DataTable", "System Error",
			MB_OK | MB_ICONHAND);
	}

	// Load Stable32 license DLL
	// Note: The standard version of the license DLL is called Licens32.DLL
	// the student version is called Licenses.DLL, and the lite version is
	// called Licensel.DLL.  To create a new version of the license dll, make
	// a new project directory with the desired name, copy license.c into it,
	// change the return value, and build new release dll and lib files.  You
	// cannot just change the return value in an existing version.

	#ifdef LITE_VER
	// Load Lite version of license DLL
	hLicense=LoadLibrary("Licensel.DLL");
	if((UINT)hLicense<=32)
	{
		MessageBox(NULL, "No License", "Stable Lite Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif

	#ifdef STUDENT_VER
	// Load student version of license DLL
	hLicense=LoadLibrary("Licenses.DLL");
	if((UINT)hLicense<=32)
	{
		MessageBox(NULL, "No License", "Stable32 Student Version Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	else
	{
		// TRACE_STR("Student Version License OK");
	}
	#endif

	#ifdef VITSAS_VER
	// Load V-ITSAS version of license DLL
	hLicense=LoadLibrary("LicenseV.DLL");
	if((UINT)hLicense<=32)
	{
		MessageBox(NULL, "No License", "Stable32 V-ITSAS Version Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}

	MessageBox(NULL, "\t This is a special version\n\tof Stable32 1.53"
		" for the\nV International Time Scale Algorithm Symposium\n\n"
		"            For Evaluation Purposes Only", "Stable32 Notice",
		MB_OK | MB_ICONASTERISK);
	#endif

	#ifdef DEMO_VER
	// Load demo version of license DLL
	hLicense=LoadLibrary("Licensed.DLL");
	if((UINT)hLicense<=32)
	{
		MessageBox(NULL, "No License", "Stable32 Demo Version Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif	

	#ifndef DEMO_VER
	#ifndef VITSAS_VER
	#ifdef FULL_VER
	// Load standard version of license DLL
	hLicense=LoadLibrary("Licens32.DLL");
	if((UINT)hLicense<=32)
	{
		MessageBox(NULL, "No License", "Stable32 Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif
	#endif
	#endif

	#if(0) // For testing
	// Read license validation/version code #
	i=CheckLicense();
	TRACE_INT(i);
	#endif

	// Note:  License situation as of 3/27/99 is as follows:
	// The beta version of Stable32 used a license code of 3
	// The current full version of Stable32 is 1.21 of 3/14/99
	// It, and all prev released versions, uses LICENS32.DLL which returns 3
	// We now want to create a student version of Stable32 which needs a
	// different code.  That code will be 4.
	// All CheckLicense() and Stable32 code, headers, etc.
	// are revised accordingly
	// 07/25/03: Added demo version license code
	// Stable license codes:
	//   STABLE_W_LICENSE_CODE 1
	//   STABLE32_BETA_LICENSE_CODE 3 // Note: 2 was never used!
	//   STABLE32_LICENSE_CODE 3 (Before version 1.50)
	//   STABLE32_STUDENT_LICENSE_CODE 4
	//   STABLE_LITE_LICENSE_CODE 5
	//	 STABLE_DEMO_LICENSE_CODE 6
	//	 STABLE_VITSAS_LICENSE_CODE 7
	//	 STABLE32_150_LICENSE_CODE 150 (Full Version 1.50)
	//	 STABLE32_151_LICENSE_CODE 151 (Full Version 1.51)
	//   STABLE32_152_LICENSE_CODE 152 // Version 1.52
	//   STABLE32_153_LICENSE_CODE 153 // Version 1.53
	//   STABLE32_154_LICENSE_CODE 154 // Version 1.54
	//   STABLE32_155_LICENSE_CODE 155 // Version 1.55
	//   STABLE32_156_LICENSE_CODE 156 // Version 1.56
	//   STABLE32_157_LICENSE_CODE 157 // Version 1.57
	//   STABLE32_158_LICENSE_CODE 158 // Version 1.58
	//   STABLE32_159_LICENSE_CODE 159 // Version 1.59
	// Ver # appears in About License message box for version 1.50 and higher

	#ifdef STUDENT_VER
	// Check for student license code
	if(CheckLicense()!=STABLE32_STUDENT_LICENSE_CODE)
	{
		MessageBox(NULL, "Invalid License Code",
			"Stable32 Student Version Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	else
	{
		// TRACE_INT(CheckLicense());
	}
	#endif

	#ifdef LITE_VER
	// Check for lite license code
	if(CheckLicense()!=STABLE_LITE_LICENSE_CODE)
	{
		MessageBox(NULL, "Invalid License Code", "Stable Lite Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif

	#ifdef DEMO_VER
	// Check for demo license code
	if(CheckLicense()!=STABLE_DEMO_LICENSE_CODE)
	{
		MessageBox(NULL, "Invalid License Code", "Stable Demo Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif

	#ifdef VITSAS_VER
	// Check for V-ITSAS license code
	if(CheckLicense()!=STABLE_VITSAS_LICENSE_CODE)
	{
		MessageBox(NULL, "Invalid License Code", "Stable V-ITSAS Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif

	#ifndef DEMO_VER
	#ifndef VITSAS_VER
	#ifdef FULL_VER
	// Check for standard full version license code
	// New version # license code applies to full version 1.50 and higher
	// The objective is to be able to limit how far back updates can be used
	// We promise "Free updates for at least one year"
	// so must still allow all licenses to work now
	// Eventually we can exclude old STABLE32_LICENSE_CODEs
	// and then STABLE32_###_LICENSE_CODEs whose last shipment date
	// is more than one year ago.
	// Must rebuild Licens32.dll for each new version of Stable32
	// with new STABLE32_###_LICENSE_CODE value
	// The About box License button displays the "Original Stable32
	// Licensed Version #" for new STABLE32_###_LICENSE_CODEs
	// for whatever Licens32.dll STABLE32_###_LICENSE_CODE is on user system
	// Since Licens32.dll is not distributed with updates
	// this is the one from the original installation
	// It must be checked before performing an update to verfiy that
	// the update applies - otherwise Stable32 won't run
	// Some automatic way to check that would be nice
	if((CheckLicense()!= STABLE32_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_150_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_151_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_152_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_153_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_154_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_155_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_156_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_157_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_158_LICENSE_CODE) &&
		(CheckLicense()!= STABLE32_159_LICENSE_CODE))
	{
		MessageBox(NULL, "Invalid License Code", "Stable32 Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}
	#endif
	#endif
	#endif

	// Load 32-bit FrequenC DLL
	// hFCLib=LoadLibrary("FREQUE32.DLL"); // Obsolete
	hFCLib=LoadLibrary("FREQUENC.DLL");
	if((UINT)hFCLib<=32)
	{
		MessageBox(NULL, "Unable to Load FrequenC DLL", "Stable32 Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}

	// Check FrequenC DLL version #
	if(CheckFrequenC()!=FREQUENC_DLL_VERSION_NUMBER)
	{
		MessageBox(NULL, "Invalid FrequenC DLL Version", "Stable32 Error",
			MB_OK | MB_ICONHAND);

		// Program return
		return 0;
	}

	// Initiate common controls
	InitCommonControls();
	
	// To avoid compiler unused variable warning
	lstrlen(lpszCmdParam);

	// Save instance handle in global variable
	hInst=hInstance;

	#if(0) // Test code 10/07/07
	// Get dialog box font size
	TRACE_INT(LOWORD(GetDialogBaseUnits()));
	TRACE_INT(HIWORD(GetDialogBaseUnits()));
	#endif

	// Allocate memory for minimum-sized data arrays
	if((fFreqData=(F_TYPE*)malloc(
		(MIN_ARRAY_SIZE+ARRAY_OFFSET+EXTRA_MEM)*sizeof(F_TYPE)))==NULL)
	{
		bAllocError=TRUE;
	}

	if((fPhaseData=(F_TYPE*)malloc(
		(MIN_ARRAY_SIZE+ARRAY_OFFSET+EXTRA_MEM)*sizeof(F_TYPE)))==NULL)
	{
		bAllocError=TRUE;
	}

	if((fFreqTimetags=(F_TYPE*)malloc(
		(MIN_ARRAY_SIZE+ARRAY_OFFSET+EXTRA_MEM)*sizeof(F_TYPE)))==NULL)
	{
		bAllocError=TRUE;
	}

	if((fPhaseTimetags=(F_TYPE*)malloc(
		(MIN_ARRAY_SIZE+ARRAY_OFFSET+EXTRA_MEM)*sizeof(F_TYPE)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for print message string
	if((szPrnMsg=(LPSTR)malloc((BUFFER_SIZE+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for dialog box title string
	if((szBoxTitle=(LPSTR)malloc((TITLESIZE+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for plot label string
	if((szPlotLabel=(LPSTR)malloc(	(BUFFER_SIZE+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for file text string
	if((szFileText=(LPSTR)malloc((BUFFER_SIZE+1)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for filename variables
	if((szCommandFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szNotepad=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szFileTitle=(LPSTR)malloc((FILE_TITLE_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPhaseFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPhaseFileTitle=(LPSTR)malloc((FILE_TITLE_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szFreqFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szFreqFileTitle=(LPSTR)malloc((FILE_TITLE_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szStabFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPSDFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szAutoFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szStabFileTitle=(LPSTR)malloc((FILE_TITLE_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPrevStabFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPrevStabFileTitle=(LPSTR)malloc((FILE_TITLE_SIZE)*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((szArcIndexFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szHelpFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szCornFileA=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szCornFileB=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szCornFileC=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szPhasePlotInsertFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((szFreqPlotInsertFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((szStabPlotInsertFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((szACFPlotInsertFile=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((szWaveFilename=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((szAudioPlayer=(LPSTR)malloc((FILE_NAME_SIZE)*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for mask data arrays
	for(i=0; i<SLINE_NUMLINES; i++)
	{
		fMaskSigma[i]=(float*)realloc(fMaskSigma[i], (MASKSIZE)*sizeof(float));
		fMaskTau[i]=(float*)realloc(fMaskTau[i], (MASKSIZE)*sizeof(float));
	}

	// Initialize filename variables
	strlcpy(szFile, "", FILE_NAME_SIZE);
	strlcpy(szFileTitle, "", FILE_TITLE_SIZE);
	strlcpy(szPhaseFile, "            ", FILE_NAME_SIZE);
	strlcpy(szPhaseFileTitle, "", FILE_TITLE_SIZE);
	strlcpy(szFreqFile, "            ", FILE_NAME_SIZE);
	strlcpy(szFreqFileTitle, "", FILE_TITLE_SIZE);
	strlcpy(szStabFile, "", FILE_NAME_SIZE);
	strlcpy(szPSDFile, "", FILE_NAME_SIZE);
	strlcpy(szAutoFile, "", FILE_NAME_SIZE);
	strlcpy(szStabFileTitle, "", FILE_TITLE_SIZE);
	strlcpy(szCornFileA, "", FILE_NAME_SIZE);
	strlcpy(szCornFileB, "", FILE_NAME_SIZE);
	strlcpy(szCornFileC, "", FILE_NAME_SIZE);
	strlcpy(szPhasePlotInsertFile, "None", FILE_NAME_SIZE);
	strlcpy(szFreqPlotInsertFile, "None", FILE_NAME_SIZE);
	strlcpy(szStabPlotInsertFile, "None", FILE_NAME_SIZE);
	strlcpy(szACFPlotInsertFile, "None", FILE_NAME_SIZE);

	// Allocate memory for frequency plot annotation text strings
	for(i=0; i<FNOTE_NUMNOTES; i++)
	{
		if((sFNote[i].szText=(LPSTR)malloc((2)*sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}

		// Initialize to empty string
		strlcpy(sFNote[i].szText, "", 2);
	}

	// Allocate memory for phase plot annotation text strings
	for(i=0; i<PNOTE_NUMNOTES; i++)
	{
		if((sPNote[i].szText=(LPSTR)malloc((2)*sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}

		// Initialize to empty string
		strlcpy(sPNote[i].szText, "", 2);
	}

	// Allocate memory for sigma plot annotation text strings
	for(i=0; i<SNOTE_NUMNOTES; i++)
	{
		if((sSNote[i].szText=(LPSTR)malloc((2)*sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}

		// Initialize to empty string
		strlcpy(sSNote[i].szText, "", 2);
	}

	// Allocate memory for previous filenames
	for(i=0; i<NUM_FILENAMES; i++)
	{
		if((szPreviousPhaseFilename[i]=(LPSTR)malloc((FILE_NAME_SIZE)*
			sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}

		if((szPreviousFreqFilename[i]=(LPSTR)malloc((FILE_NAME_SIZE)*
			sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}
	}

	// Allocate memory for mask filenames
	for(i=0; i<SLINE_NUMLINES; i++)
	{
		if((sSLine[i].szMaskFile=(LPSTR)malloc((FILE_NAME_SIZE)*
			sizeof(char)))==NULL)
		{
			bAllocError=TRUE;
		}
	}

	// Allocate memory for plot data text strings
	// Frequency plot data strings
	if((sFPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPlot.function=(LPSTR)malloc(FUNCTIONSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	// Frequency plot data arrays
	if((sFPlot.param=(double*)malloc(NUMPARAMS*sizeof(double)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Previous freq plot data strings
	if((sFPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sFPrev.function=(LPSTR)malloc(FUNCTIONSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	// Previous frequency plot data arrays
	if((sFPrev.param=(double*)malloc(NUMPARAMS*sizeof(double)))==NULL)
	{
		bAllocError=TRUE;
	}


	// Phase plot data strings
	if((sPPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPlot.function=(LPSTR)malloc(FUNCTIONSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	// Phase plot data arrays
	if((sPPlot.param=(double*)malloc(NUMPARAMS*sizeof(double)))==NULL)
	{
		bAllocError=TRUE;
	}


	// Previous phase plot data strings
	if((sPPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPPrev.function=(LPSTR)malloc(FUNCTIONSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	// Previous phase plot data arrays
	if((sPPrev.param=(double*)malloc(NUMPARAMS*sizeof(double)))==NULL)
	{
		bAllocError=TRUE;
	}


	// Sigma plot data strings
	if((sSPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Previous sigma plot data strings
	if((sSPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Histo plot data strings
	if((sHPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Previous histo plot data strings
	if((sHPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sHPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Power spectrum plot data strings
	if((sPSPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Previous power spectrum plot data strings
	if((sPSPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sPSPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Autocorrelation plot data strings
	if((sAPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPlot.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Previous autocorrelation plot data strings
	if((sAPrev.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.x_label=(LPSTR)malloc(XLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.left_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.right_y_label=(LPSTR)malloc(YLABELSIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAPrev.message_str=(LPSTR)malloc(MESSAGESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Dynamic stability plot data strings
	if((sDPlot.title=(LPSTR)malloc(TITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	else if((sDPlot.subtitle=(LPSTR)malloc(SUBTITLESIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	else if((sDPlot.plot_filename=(LPSTR)malloc(FILENAMESIZE*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	// Note that this message size is made x5 larger than others
	// because it allows \n to support larger messages
	// and the message dialog box has the autoH scroll option activated
	else if((sDPlot.message_str=(LPSTR)malloc(5*MESSAGESIZE*sizeof(char)))==
		NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for user-defined filename extension filter string
	if((szExtensionFilter=(LPSTR)malloc(BIG_BUFFER_SIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	// Allocate memory for external filename pattern string
	if((szExternalPattern=(LPSTR)malloc(BIG_BUFFER_SIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}
	
	// Allocate memory for automation script name
	if((szScriptname=(LPSTR)malloc(BUFFER_SIZE*sizeof(char)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate memory for frequency tab titles
	for(i=0; i<FTAB_NUMTABS; i++)
	{
		if((sFTab[i].szTitle=(LPSTR)malloc(FILE_TITLE_SIZE*sizeof(char)))==
			NULL)
		{
			bAllocError=TRUE;
		}

		// Initialize to empty string
		strlcpy(sFTab[i].szTitle, "", FILE_TITLE_SIZE);
	}

	// Allocate memory for phase tab titles
	for(i=0; i<PTAB_NUMTABS; i++)
	{
		if((sPTab[i].szTitle=(LPSTR)malloc(FILE_TITLE_SIZE*sizeof(char)))==
			NULL)
		{
			bAllocError=TRUE;
		}

		// Initialize to empty string
		strlcpy(sPTab[i].szTitle, "", FILE_TITLE_SIZE);
	}

	// Allocate memory for PSD plot spur data
	if((sSpur.index=(int*)malloc(NUMSPURS*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSpur.first=(int*)malloc(NUMSPURS*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSpur.last=(int*)malloc(NUMSPURS*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSpur.freq=(float*)malloc(NUMSPURS*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sSpur.amp=(float*)malloc(NUMSPURS*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Initialize plot filenames
	strlcpy(sPPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sPPlot.plot_filename, "PHASE.TKF", FILENAMESIZE);
	strlcpy(sFPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sFPlot.plot_filename, "FREQ.TKF", FILENAMESIZE);
	strlcpy(sSPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sSPlot.plot_filename, "SIGMA.TKF", FILENAMESIZE);
	strlcpy(sHPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sHPlot.plot_filename, "HISTO.TKF", FILENAMESIZE);
	strlcpy(sPSPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sPSPlot.plot_filename, "SPECTRUM.TKF", FILENAMESIZE);
	strlcpy(sAPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sAPlot.plot_filename, "AUTO.TKF", FILENAMESIZE);
	strlcpy(sDPlot.plot_filename, szPath, FILENAMESIZE);
	strlcat(sDPlot.plot_filename, "DAVAR.TKF", FILENAMESIZE);

	// Initialize stability filename
	strlcpy(szStabFile, szPath, FILE_NAME_SIZE);
	strlcat(szStabFile, "SIGMA.TAU", FILE_NAME_SIZE);
	strlcpy(szStabFileTitle, "SIGMA.TAU", FILE_TITLE_SIZE);

	// Initialize PSD data filename
	strlcpy(szPSDFile, szPath, FILE_NAME_SIZE);
	strlcat(szPSDFile, "PSD.DAT", FILE_NAME_SIZE);

	// Initialize autocorrelation data filename
	strlcpy(szAutoFile, szPath, FILE_NAME_SIZE);
	strlcat(szAutoFile, "AUTO.DAT", FILE_NAME_SIZE);

	// Clear filename filter strings
	strlcpy(szExtensionFilter, "", BIG_BUFFER_SIZE);
	strlcpy(szExternalPattern, "", BIG_BUFFER_SIZE);

	// Dynamic allocation of sigmadata arrays
	// Note: Advantages of this method are getting space from heap and
	// allowing large stability data files.
	// The approach for handling this dynamic memory allocation is
	// to set a fixed minimum size = SIGMA_SIZE = 12 to handle the Run
	// function, then adaptively set it to a larger size if needed for the
	// Read function.
	if((sNormSigData.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.num=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.num=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.sigma=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.sigma=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.ci=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.ci=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.sig_min=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.sig_min=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.sig_max=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.sig_max=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.std_dev=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.std_dev=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.df=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.df=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.falpha=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.falpha=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.alpha=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.alpha=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.af=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.af=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sNormSigData.sign=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sModSigData.sign=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}

	// All tau sigma data items
	if((sAllNormSigData.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.num=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.num=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.sigma=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.sigma=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.ci=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.ci=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.sig_min=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.sig_min=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.sig_max=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.sig_max=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.std_dev=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.std_dev=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.df=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.df=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.falpha=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.falpha=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.alpha=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.alpha=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.af=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.af=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllNormSigData.sign=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sAllModSigData.sign=(int*)malloc((SIGMA_SIZE)*sizeof(int)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Dynamic allocation of corndata arrays
	// Note: Advantages of this method are getting space from heap and
	// allowing large stability data files.
	// The approach for handling this dynamic memory allocation is
	// to set a fixed minimum size = SIGMA_SIZE = 12
	// then adaptively set it to a larger size if needed
	if((sCornData.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.num_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.num_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.num_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_min_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_min_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_min_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_max_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_max_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.sig_max_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.df_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.df_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornData.df_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.tau=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.num_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.num_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.num_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_min_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_min_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_min_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_max_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_max_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.sig_max_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==
		NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.df_a=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.df_b=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}
	if((sCornResults.df_c=(float*)malloc((SIGMA_SIZE)*sizeof(float)))==NULL)
	{
		bAllocError=TRUE;
	}

	// Allocate minimum char arrays for storing plot option titles
	for(i=0; i<NUM_TITLES; i++)
	{
		if((szPlotTitle[i]=(LPSTR)malloc(sizeof(char*)))==NULL)
		{
			bAllocError=TRUE;
		}
	}

	// Allocate minimum char arrays for storing plot option subtitles
	for(i=0; i<NUM_SUBTITLES; i++)
	{
		if((szPlotSubtitle[i]=(LPSTR)malloc(sizeof(char*)))==NULL)
		{
			bAllocError=TRUE;
		}
	}

	// Allocate minimum char arrays for storing plot option messages
	for(i=0; i<NUM_MESSAGES; i++)
	{
		if((szPlotMessage[i]=(LPSTR)malloc(sizeof(char*)))==NULL)
		{
			bAllocError=TRUE;
		}
	}

	// Announce memory allocation error
	if(bAllocError)
	{
		AllocErrorMessage();
		return 0;
	}

	// Set up the full help file path & name
	// The help file is called via szHelpFile, which is the szPath working
	// directory path plus a backslash plus STABLE32.HLP.
	// szPath is where Stable/Win program started
	// Its program item MUST have a working directory

	// Get working directory from arg[0]
	// This is better than using the current working directory
	// because it is always the full path where program started
	// regardless of how the program's working directory is set up
	// or what directory is currently active on the computer

	_splitpath(__argv[0], szDrive, szDirectory, NULL, NULL);
	strlcpy(szPath, szDrive, FILE_NAME_SIZE);
	strlcat(szPath, szDirectory, FILE_NAME_SIZE);

	#if(0) // Obsolete code
	// Note:  szPath contains trailing backslash
	strlcpy(szHelpFile, szPath, FILE_NAME_SIZE);
	#ifdef FULL_VER
	strlcat(szHelpFile, "STABLE32.HLP", FILE_NAME_SIZE);
	#endif
	#ifdef LITE_VER
	strlcat(szHelpFile, "STABLE_L.HLP", FILE_NAME_SIZE);
	#endif
	#ifdef STUDENT_VER
	strlcat(szHelpFile, "STABLE_S.HLP", FILE_NAME_SIZE);
	#endif
	#endif

	// Note:  szPath contains trailing backslash
	strlcpy(szHelpFile, szPath, FILE_NAME_SIZE);
	#ifdef FULL_VER
	strlcat(szHelpFile, HELPFILESTRING, FILE_NAME_SIZE);
	#endif
	#ifdef LITE_VER
	strlcat(szHelpFile, HELPFILESTRING, FILE_NAME_SIZE);
	#endif
	#ifdef STUDENT_VER
	strlcat(szHelpFile, HELPFILESTRING, FILE_NAME_SIZE);
	#endif

	// Set up the full ini file path & name
	strlcpy(szIniFile, szPath, FILE_NAME_SIZE);
	#ifdef FULL_VER
	strlcat(szIniFile, "STABLE32.INI", FILE_NAME_SIZE);
	#endif
	#ifdef LITE_VER
	strlcat(szIniFile, "STABLE_L.INI", FILE_NAME_SIZE);
	#endif
	#ifdef STUDENT_VER
	strlcat(szIniFile, "STABLE32.INI", FILE_NAME_SIZE);
	#endif

	// Set up the full play file path & name
	strlcpy(szPlayFile, szPath, FILE_NAME_SIZE);
	strlcat(szPlayFile, "PlayW.exe", FILE_NAME_SIZE);

	// Set up the full archive index data file path & name
	strlcpy(szArcIndexFile, szPath, FILE_NAME_SIZE);
	strlcat(szArcIndexFile, "ARCINDEX.DAT", FILE_NAME_SIZE);

	// Set the GPCWIN environment variable to the program path szPath
	// (In addition to whatever it might already point at)
	// Note: This applies only to the environment of the current process

	// Put GPCWIN environment variable name into the string
	strlcpy(szEnvironment, "GPCWIN=", FILE_NAME_SIZE+8);

	// Get any existing such environment variable value(s)
	if(getenv("GPCWIN"))
	{
		// Put existing GPCWIN environment variable value into the string
		strlcat(szEnvironment, getenv("GPCWIN"), FILE_NAME_SIZE+8);

		// Add a semicolon as a separator
		strlcat(szEnvironment, ";", FILE_NAME_SIZE+8);
	}

	// Append our current program path
	strlcat(szEnvironment, szPath, FILE_NAME_SIZE+8);
	
	// Store the new value of the GPCWIN environment string
	_putenv(szEnvironment);

	// Read the STABLE32.INI configuration file
	ReadIni(INI_ALL);

	// Initialize array size, start and end parameters
	fFreqData[0]=(F_TYPE)MIN_ARRAY_SIZE;
	fFreqData[1]=1.0;
	fFreqData[2]=(F_TYPE)MIN_ARRAY_SIZE;
	fPhaseData[0]=(F_TYPE)MIN_ARRAY_SIZE;
	fPhaseData[1]=1.0;
	fPhaseData[2]=(F_TYPE)MIN_ARRAY_SIZE;

	// Initialize data pointers
	if(bDataType)
	{
		fData=fFreqData;
		fTags=fFreqTimetags;
	}
	else
	{
		fData=fPhaseData;
		fTags=fPhaseTimetags;
	}

	// Load hourglass wait cursor
	hWait=LoadCursor(NULL, IDC_WAIT);
	hArrow=LoadCursor(NULL, IDC_ARROW);

	// Load Bitmaps
	hUnsavedBitmap=LoadBitmap(hInstance, "UNSAVED");
	hTimetagsBitmap=LoadBitmap(hInstance, "TAGS");
	hTagSrcBitmap=LoadBitmap(hInstance, "TAGSRC");
	hTagMskBitmap=LoadBitmap(hInstance, "TAGMSK");
	hTooFewBitmap=LoadBitmap(hInstance, "TOOFEW");
	hFewSrcBitmap=LoadBitmap(hInstance, "FEWSRC");
	hFewMskBitmap=LoadBitmap(hInstance, "FEWMSK");
	hLimitsBitmap=LoadBitmap(hInstance, "LIMITS");
	hLimitSrcBitmap=LoadBitmap(hInstance, "LIMITSRC");
	hLimitMskBitmap=LoadBitmap(hInstance, "LIMITMSK");
	hSynchBitmap=LoadBitmap(hInstance, "SYNCH");
	hSynchSrcBitmap=LoadBitmap(hInstance, "SYNCHSRC");
	hSynchMskBitmap=LoadBitmap(hInstance, "SYNCHMSK");
	hUnsynchBitmap=LoadBitmap(hInstance, "UNSYNCH");

	if(!hPrevInstance) // Register class only once
	{
		// Fill WNDCLASS structure parameters for main window
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = (LPVOID)WndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = hInstance;
		wndclass.hIcon         = LoadIcon (hInstance,"StableIcon");
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
		wndclass.lpszMenuName  = "StableMenu";
		wndclass.lpszClassName = szThisAppName;

		// Register window class
		RegisterClass(&wndclass);

		// Fill WNDCLASS structure parameters for toolbar window
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = (LPVOID)ToolbarWndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = hInstance;
		wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
		wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = szToolbarName;

		// Register window class
		RegisterClass(&wndclass);
	}

	#ifdef GPC_IN
	// Register GraphicC window
	if(!GPCWINRegister(hInstance, (WNDPROC)GPCWndProc))
	{
		return TRUE;
	}
	#endif

	// Create main window
	// Lite version
	#ifdef LITE_VER
	hwndMain = CreateWindow(szThisAppName,         	// window class name
						"Stable Lite"    ,      	// window caption
						WS_OVERLAPPEDWINDOW,     	// window style
						CW_USEDEFAULT,    		    // initial x position
						CW_USEDEFAULT,				// initial y position
						CW_USEDEFAULT,				// initial x size
						CW_USEDEFAULT,				// initial y size
						NULL,					   	// parent window handle
						NULL,						// window menu handle
						hInstance,					// program instance handle
						NULL);		                // creation parameters

	#endif
	// Full version
	#ifndef DEMO_VER
	#ifdef FULL_VER
	hwndMain = CreateWindow(szThisAppName,         	// window class name
						"Stable32",      	        // window caption
						WS_OVERLAPPEDWINDOW |       // window style
						WS_CLIPSIBLINGS,     	    // added 11/16/06
						CW_USEDEFAULT,    		    // initial x position
						CW_USEDEFAULT,				// initial y position
						CW_USEDEFAULT,				// initial x size
						CW_USEDEFAULT,				// initial y size
						NULL,					   	// parent window handle
						NULL,						// window menu handle
						hInstance,					// program instance handle
						NULL);		                // creation parameters
	#endif
	#endif
	// Student version
	#ifdef STUDENT_VER
	hwndMain = CreateWindow(szThisAppName,         	// window class name
						"Stable32 Student Version", // window caption
						WS_OVERLAPPEDWINDOW |     	// window style
						WS_CLIPSIBLINGS,     	    // added 11/16/06
						CW_USEDEFAULT,    		    // initial x position
						CW_USEDEFAULT,				// initial y position
						CW_USEDEFAULT,				// initial x size
						CW_USEDEFAULT,				// initial y size
						NULL,					   	// parent window handle
						NULL,						// window menu handle
						hInstance,					// program instance handle
						NULL);		                // creation parameters
	#endif
	// Demo version
	#ifdef DEMO_VER
	hwndMain = CreateWindow(szThisAppName,         	// window class name
						"Stable32 Demo Version",    // window caption
						WS_OVERLAPPEDWINDOW,     	// window style
						CW_USEDEFAULT,    		    // initial x position
						CW_USEDEFAULT,				// initial y position
						CW_USEDEFAULT,				// initial x size
						CW_USEDEFAULT,				// initial y size
						NULL,					   	// parent window handle
						NULL,						// window menu handle
						hInstance,					// program instance handle
						NULL);		                // creation parameters
	#endif

	// Get handle to main menu
	hMenu=GetMenu(hwndMain);

	// Put window on screen
	ShowWindow(hwndMain, nCmdShow);

	// Load accererators
	hAccel=LoadAccelerators(hInstance, "StableAccel");

	// Read file info from *.INI file
	ReadFileInfo();

	// Clear previous filenames
	strlcpy(szPreviousFreqFilename[0], "", FILE_NAME_SIZE); 
	strlcpy(szPreviousPhaseFilename[0], "", FILE_NAME_SIZE);

	// Make data type same as last file opened
	bDataType=bLastOpened;

	if(bDataType==FREQ_DATA)
	{
		UpdateFileInfo(szPreviousFreqFilename);
	}
	else // Phase data
	{
		UpdateFileInfo(szPreviousPhaseFilename);
	}

	// Create new log file
	WriteLog(0, "");
	// Write argv[0] to log file
	WriteLog(82, __argv[0]);

	// Paint client area
	UpdateWindow(hwndMain);

	// Message loop for 1 modeless dlg box & accelerators
	// Permits only 1 modeless dlg box hDlgModeless
	// All modeless dialog boxes use that handle
	// Welcome dialog box will be destroyed if Edit Find or Replace is invoked
	// Edit Find and Replace have toggling action
	while(GetMessage(&msg, NULL, 0, 0))
	{
		if( (hDlgModeless==0) ||
			(!IsDialogMessage(hDlgModeless, &msg)) )
		{
			if(!TranslateAccelerator(hwndMain, hAccel, &msg))
			{
				// Do keyboard translation
				TranslateMessage(&msg);
				// Pass message back to Windows
				DispatchMessage(&msg);
			}
		}
	}

	// Invalidate the main window handle
	hwndMain=0;

	// Write the STABLE32.INI configuration file
	WriteIni(INI_ALL);
	WriteFileInfo();

	// Put info into log file
	WriteLog(25, "");

	// Remove the DataTable DLL
	if((UINT)hDTLib>32)
	{
		FreeLibrary(hDTLib);
	}

	// Remove the Stable/Win License DLL
	if((UINT)hLicense>32)
	{
		FreeLibrary(hLicense);
	}

	// Remove the FrequenC DLL
	if((UINT)hFCLib>32)
	{
		FreeLibrary(hFCLib);
	}

	// Free phase & freq data & timetag arrays
	free(fFreqData);
	free(fPhaseData);
	free(fFreqTimetags);
	free(fPhaseTimetags);

	// Delete Bitmaps
	DeleteObject(hUnsavedBitmap);
	DeleteObject(hTimetagsBitmap);
	DeleteObject(hTagSrcBitmap);
	DeleteObject(hTagMskBitmap);
	DeleteObject(hTooFewBitmap);
	DeleteObject(hFewSrcBitmap);
	DeleteObject(hFewMskBitmap);
	DeleteObject(hLimitsBitmap);
	DeleteObject(hLimitSrcBitmap);
	DeleteObject(hLimitMskBitmap);
	DeleteObject(hSynchBitmap);
	DeleteObject(hSynchSrcBitmap);
	DeleteObject(hSynchMskBitmap);
	DeleteObject(hUnsynchBitmap);
	if(hPhaseColorBitmap)
	{
		DeleteObject(hPhaseColorBitmap);
	}
	if(hPhaseMonoBitmap)
	{
		DeleteObject(hPhaseMonoBitmap);
	}
	if(hFreqColorBitmap)
	{
		DeleteObject(hFreqColorBitmap);
	}
	if(hFreqMonoBitmap)
	{
		DeleteObject(hFreqMonoBitmap);
	}

	// Delete status bar font object
	DeleteStatusBarFont();

	// Free memory used for freq plot annotation text strings
	for(i=0; i<FNOTE_NUMNOTES; i++)
	{
		free(sFNote[i].szText);
	}

	// Free memory for phase plot annotation text strings
	for(i=0; i<PNOTE_NUMNOTES; i++)
	{
		free(sPNote[i].szText);
	}

	// Free memory for stability plot annotation text strings
	for(i=0; i<PNOTE_NUMNOTES; i++)
	{
		free(sSNote[i].szText);
	}

	// Free memory for previous filenames
	for(i=0; i<NUM_FILENAMES; i++)
	{
		free(szPreviousPhaseFilename[i]);
		free(szPreviousFreqFilename[i]);
	}

	// Free memory for mask filenames
	for(i=0; i<SLINE_NUMLINES; i++)
	{
		free(sSLine[i].szMaskFile);
	}

	// Free memory for command line filename
	free(szCommandFile);

	// Free memory for notepad filename
	free(szNotepad);

	// Free memory for plot label
	free(szPlotLabel);

	// Free memory for print message string
	free(szPrnMsg);

	// Free memory for dialog box title string
	free(szBoxTitle);

	// Free memory for file text
	free(szFileText);

	// Free memory for filenames
	free(szFile);
	free(szFileTitle);
	free(szPhaseFile);
	free(szPhaseFileTitle);
	free(szFreqFile);
	free(szFreqFileTitle);
	free(szStabFile);
	free(szPSDFile);
	free(szAutoFile);
	free(szStabFileTitle);
	free(szPrevStabFile);
	free(szPrevStabFileTitle);
	free(szPath);
	free(szDrive);
	free(szIniFile);
	free(szPlayFile);
	free(szHelpFile);
	free(szDirectory);
	free(szArcIndexFile);
	free(szLogFile);
	free(sz5110CommFile);
	free(szCornFileA);
	free(szCornFileB);
	free(szCornFileC);
	free(szPhasePlotInsertFile);
	free(szFreqPlotInsertFile);
	free(szStabPlotInsertFile);
	free(szACFPlotInsertFile);
	free(szWaveFilename);
	free(szAudioPlayer);

	// Free phase & freq plotdata and sigmadata arrays
	free(sFPlot.title);
	free(sFPlot.subtitle);
	free(sFPlot.x_label);
	free(sFPlot.left_y_label);
	free(sFPlot.right_y_label);
	free(sFPlot.plot_filename);
	free(sFPlot.message_str);
	free(sFPlot.function);
	free(sFPlot.param);
	free(sFPrev.title);
	free(sFPrev.subtitle);
	free(sFPrev.x_label);
	free(sFPrev.left_y_label);
	free(sFPrev.right_y_label);
	free(sFPrev.plot_filename);
	free(sFPrev.message_str);
	free(sFPrev.function);
	free(sFPrev.param);
	free(sPPlot.title);
	free(sPPlot.subtitle);
	free(sPPlot.x_label);
	free(sPPlot.left_y_label);
	free(sPPlot.right_y_label);
	free(sPPlot.plot_filename);
	free(sPPlot.message_str);
	free(sPPlot.function);
	free(sPPlot.param);
	free(sPPrev.title);
	free(sPPrev.subtitle);
	free(sPPrev.x_label);
	free(sPPrev.left_y_label);
	free(sPPrev.right_y_label);
	free(sPPrev.plot_filename);
	free(sPPrev.message_str);
	free(sPPrev.function);
	free(sPPrev.param);
	free(sSPlot.title);
	free(sSPlot.subtitle);
	free(sSPlot.x_label);
	free(sSPlot.left_y_label);
	free(sSPlot.right_y_label);
	free(sSPlot.plot_filename);
	free(sSPlot.message_str);
	free(sSPrev.title);
	free(sSPrev.subtitle);
	free(sSPrev.x_label);
	free(sSPrev.left_y_label);
	free(sSPrev.right_y_label);
	free(sSPrev.plot_filename);
	free(sSPrev.message_str);
	free(sHPlot.title);
	free(sHPlot.subtitle);
	free(sHPlot.x_label);
	free(sHPlot.left_y_label);
	free(sHPlot.right_y_label);
	free(sHPlot.plot_filename);
	free(sHPlot.message_str);
	free(sHPrev.title);
	free(sHPrev.subtitle);
	free(sHPrev.x_label);
	free(sHPrev.left_y_label);
	free(sHPrev.right_y_label);
	free(sHPrev.plot_filename);
	free(sHPrev.message_str);
	free(sPSPlot.title);
	free(sPSPlot.subtitle);
	free(sPSPlot.x_label);
	free(sPSPlot.left_y_label);
	free(sPSPlot.right_y_label);
	free(sPSPlot.plot_filename);
	free(sPSPlot.message_str);
	free(sPSPrev.title);
	free(sPSPrev.subtitle);
	free(sPSPrev.x_label);
	free(sPSPrev.left_y_label);
	free(sPSPrev.right_y_label);
	free(sPSPrev.plot_filename);
	free(sPSPrev.message_str);
	free(sAPlot.title);
	free(sAPlot.subtitle);
	free(sAPlot.x_label);
	free(sAPlot.left_y_label);
	free(sAPlot.right_y_label);
	free(sAPlot.plot_filename);
	free(sAPlot.message_str);
	free(sAPrev.title);
	free(sAPrev.subtitle);
	free(sAPrev.x_label);
	free(sAPrev.left_y_label);
	free(sAPrev.right_y_label);
	free(sAPrev.plot_filename);
	free(sAPrev.message_str);
	free(sDPlot.title);
	free(sDPlot.subtitle);
	free(sDPlot.plot_filename);
	free(sDPlot.message_str);
	free(sNormSigData.tau);
	free(sModSigData.tau);
	free(sNormSigData.num);
	free(sModSigData.num);
	free(sNormSigData.sigma);
	free(sModSigData.sigma);
	free(sNormSigData.ci);
	free(sModSigData.ci);
	free(sNormSigData.sig_min);
	free(sModSigData.sig_min);
	free(sNormSigData.sig_max);
	free(sModSigData.sig_max);
	free(sNormSigData.std_dev);
	free(sModSigData.std_dev);
	free(sNormSigData.df);
	free(sModSigData.df);
	free(sNormSigData.falpha);
	free(sModSigData.falpha);
	free(sNormSigData.alpha);
	free(sModSigData.alpha);
	free(sNormSigData.af);
	free(sModSigData.af);
	free(sAllNormSigData.tau);
	free(sAllModSigData.tau);
	free(sAllNormSigData.num);
	free(sAllModSigData.num);
	free(sAllNormSigData.sigma);
	free(sAllModSigData.sigma);
	free(sAllNormSigData.ci);
	free(sAllModSigData.ci);
	free(sAllNormSigData.sig_min);
	free(sAllModSigData.sig_min);
	free(sAllNormSigData.sig_max);
	free(sAllModSigData.sig_max);
	free(sAllNormSigData.std_dev);
	free(sAllModSigData.std_dev);
	free(sAllNormSigData.df);
	free(sAllModSigData.df);
	free(sAllNormSigData.falpha);
	free(sAllModSigData.falpha);
	free(sAllNormSigData.alpha);
	free(sAllModSigData.alpha);
	free(sAllNormSigData.af);
	free(sAllModSigData.af);

	// Free corndata arrays
	free(sCornData.tau);
	free(sCornData.num_a);
	free(sCornData.num_b);
	free(sCornData.num_c);
	free(sCornData.sig_a);
	free(sCornData.sig_b);
	free(sCornData.sig_c);
	free(sCornData.sig_min_a);
	free(sCornData.sig_min_b);
	free(sCornData.sig_min_c);
	free(sCornData.sig_max_a);
	free(sCornData.sig_max_b);
	free(sCornData.sig_max_c);
	free(sCornData.df_a);
	free(sCornData.df_b);
	free(sCornData.df_c);
	free(sCornResults.tau);
	free(sCornResults.num_a);
	free(sCornResults.num_b);
	free(sCornResults.num_c);
	free(sCornResults.sig_a);
	free(sCornResults.sig_b);
	free(sCornResults.sig_c);
	free(sCornResults.sig_min_a);
	free(sCornResults.sig_min_b);
	free(sCornResults.sig_min_c);
	free(sCornResults.sig_max_a);
	free(sCornResults.sig_max_b);
	free(sCornResults.sig_max_c);
	free(sCornResults.df_a);
	free(sCornResults.df_b);
	free(sCornResults.df_c);
	
	// Free plot option title, subtitle & message arrays
	for(i=0; i<NUM_TITLES; i++)
	{
		free(szPlotTitle[i]);
	}

	for(i=0; i<NUM_SUBTITLES; i++)
	{
		free(szPlotSubtitle[i]);
	}

	for(i=0; i<NUM_MESSAGES; i++)
	{
		free(szPlotMessage[i]);
	}

	// Free memory for frequency tab titles
	for(i=0; i<FTAB_NUMTABS; i++)
	{
		free(sFTab[i].szTitle);
	}

	// Free memory for phase tab titles
	for(i=0; i<PTAB_NUMTABS; i++)
	{
		free(sPTab[i].szTitle);
	}

	// Free memory for mask data arrays
	for(i=0; i<SLINE_NUMLINES; i++)
	{
		free(fMaskSigma[i]);
		free(fMaskTau[i]);
	}

	// Free memory for PSD spurs
	free(sSpur.index);
	free(sSpur.first);
	free(sSpur.last);
	free(sSpur.freq);
	free(sSpur.amp);

	// Free filename filter strings
	free(szExtensionFilter);
	free(szExternalPattern);

	// Free automation script name
	free(szScriptname);

	// Free PSD data arrays
	// These are freed at end of SpectrumPlotDlgProc()
	// and the fFreq, fPSD and fAF pointers are set to 0

	#ifdef MEM_LEAK_DET
	// Check for memory leaks
	// Must compile as debug config, run in debug & look in debug window
	// 100% clean as of 02/14/07
	_CrtDumpMemoryLeaks(); 
	#endif

 	// Program return
	return msg.wParam;
}

/*****************************************************************************/
/*                                                                           */
/*                         Main Window Procedure                             */
/*                                                                           */
/*      Revision record:                                                     */
/*      	01/05/97	 Added command line parsing                          */
/*			03/25/97	 Added checks for insufficient plot range            */
/*			06/07/97	 Added code to activate menu for command line data   */
/*			01/16/98	 Added ShortenExp() usage for MSC VC++               */
/*			01/17/98	 Added code for display of analysis limit #          */
/*			01/27/98	 Added code for zooming status bar plots in & out    */
/*			07/30/07	 Added code for F2-F12 function key commands         */
/*			11/20/11	 Added code for command line automation              */
/*                                                                           */
/*****************************************************************************/

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	// Chars
	char *ptr;								// Pointer to basic filename
	char szBuffer[BUFFER_SIZE+1];			// General text buffer
	char szTitleString[DLG_TITLE_SIZE+1];	// Dialog box title string
	char szTempFilename[FILENAMESIZE+1];	// Temporary filename buffer
	char szTempFiletitle[FILENAMESIZE+1];	// Temporary filetitle buffer
	char szTempDrive[BUFFER_SIZE+1];		// Temporary drive buffer
	char szTempExt[BUFFER_SIZE+1];			// Temporary ext buffer
	char szTempDirectory[FILENAMESIZE+1];	// Temporary directory buffer
	char szTempName[FILENAMESIZE+1];		// Temporary name buffer
	char szTempPath[FILENAMESIZE+1];		// Temporary path buffer
	static char szText[BIG_BUFFER_SIZE+1]; 	// Text buffer for input data file
	//Ints
	int i; 								// Index
	int nEntry;                			// User int entry value for validation
	int nStart;               			// Analysis start point #
	int nEnd;                   		// Analysis end point #
	int nNum;                   		// # data points
	#ifndef LITE_VER
		int nRealNum;              		// Actual # of valid data points
	#endif
	int nBlanks;						// Blank toolbutton count
	int nRejects;						// # rejected lines in data file
	static int nCols=1;	    			// # columns in input data file

	// Variables for status plot zooming changes
	RECT PhasePlotRect;					// Coord of phase plot in status bar
	RECT FreqPlotRect;					// Coord of freq plot in status bar
	POINT MousePoint;					// Coordinates of mouse
	int nPoints;						// # plot points
	F_TYPE fXScale;						// Plot x scale factor

	// F_TYPEs
	F_TYPE fEntry;						// User float entry for validation
	static F_TYPE fPrev;				// Previous value
	F_TYPE fMin, fMax, fAvg;			// For range checks

	// BOOLs
	static BOOL bErrorTrap=FALSE;   	// Flag for entry error
	static BOOL bCheckFileHeader=TRUE;	// Local flag to control whether
										// data file is examined for
										// header entries
	// Misc
	RECT rect;							// Rect struct
	RECT rc;							// Another one

	// Main message switching procedure
	switch(message)
	{
		// Need a way to force status plot redraw when Stable32
		// regains focus after having another program's window on top of it
		// that may have covered part of status plot
		// This message indicates that case with wParam = TRUE
		// But this code doesn't do the trick in the case
		// where the other window is closed with its X button
		// So its still a work in progress to find fix for very minor problem
		case WM_ACTIVATEAPP:
		{
			if(wParam) // Is Stable32 being activiated?
			{
				// MessageBeep(1); // For testing

				if(hwndPhasePlot) // May not be created at startup
				{
					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));
				}
			}
			break;
		}

		case WM_CREATE:
		{
			// Make sure the global main window handle is right
			hwndMain=hwnd;

			// Set up edit control subclass function
			// Obtain far address for EditProc() function
			lpfnEditProc=MakeProcInstance((FARPROC)EditProc, hInst);

			// Create brush
			hBrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));

			// Get system metrics
			cxIcon=GetSystemMetrics(SM_CXICON);
			cyIcon=GetSystemMetrics(SM_CYICON);
			GetClientRect(hwnd, &rect);
			cxMain=rect.right;
			cyMain=rect.bottom;

			// Is ini value reasonable?  If not, use full workspace
			SystemParametersInfo(SPI_GETWORKAREA, 0, &rect, 0);	
			cxMain=rect.right;
			cyMain=rect.bottom;

			if(nMainLeft<0 || nMainRight>rect.right ||
			   nMainTop<0  || nMainBottom>rect.bottom)
			{
				MoveWindow(hwnd, 0, 0, (int)cxMain, (int)cyMain, TRUE);
			}
			else // Use stored main window position from ini file
			// RECT fields are left, top right, bottom
			// MoveWindow fields are x, y, w, h, ...)
			// General main window position requires all 4 to define 
			{
				MoveWindow(hwnd, nMainLeft, nMainTop, nMainRight-nMainLeft,
					nMainBottom-nMainTop, TRUE);
			}

			GetClientRect(hwnd, &rect);
			cxMain=rect.right;
			cyMain=rect.bottom;

			// Create toolbar window
			// Note:  May need to change height so it adjusts with text size
			// NOTE: CHECK THE hMenu PARAM - WHY IS IT 1? - CHANGED TO NULL
			hwndToolbar=CreateWindow(szToolbarName, NULL,
				WS_CHILDWINDOW | WS_VISIBLE, 0, 0, cxMain, (int)(1.45*cyIcon),
				(HWND)hwnd, (HMENU)NULL, (HINSTANCE)hInst, NULL);

			// Set global variables cxChar & cyChar
			// These values give the best status bar appearance
			// for "any" screen mode & font size
			// Really want XGA screen so status bar plots fit
			// But don't want status bar layout to change
			// with size of system font ("Big" or "Small")
			// This is better than letting them change with text metrics
			cxChar=10;
			cyChar=20;

			// Create status bar controls
			CreateStatusBar(hwnd, szPhaseFile, szFreqFile);

			// Move status bar controls to proper location at bottom of screen
			// This done only once
			// Use UpdateStatusBar() to refresh status bar
			MoveStatusBarControls(hwnd);

			// Read [Toolbuttons] section of STABLE32.INI
			// Note: Must do this after toolbar is created
			nBlanks=0;
			for(i=0; i<NUM_TOOLS; i++)
			{
				// Default value = 1
				tb[i].show_flag=GetPrivateProfileInt("Toolbuttons",
					tb[i].label, 1,	szIniFile);

				// Loop thru all toolbuttons, setting their screen positions
				if(tb[i].show_flag) // Display
				{
					tb[i].position=i-nBlanks;
				}
				else // Don't display
				{
					tb[i].position=-1; // Off screen
					nBlanks++;
				}

				// Update the icon rect
				SetRect(&tb[i].rect, tb[i].position*cxIcon, 0,
					(tb[i].position+1)*cxIcon, cyIcon);
			}

			// Clear command line filename
			strlcpy(szCommandFile, "", FILE_NAME_SIZE);
			
			// Process command line inputs
			ParseCommandLine(&bAutoload, &bCommandFileType, &bArchiveData,
				szCommandFile, &fCommandTau);

			// Automatically read data file entered on command line
			// This happens for -p or -f option
			if(bAutoload)
			{
				// Set the data type
				bDataType=bCommandFileType;

				// Set data type buttons
				Button_SetCheck(GetDlgItem(hwnd, IDC_FREQSELECT), bDataType);
				Button_SetCheck(GetDlgItem(hwnd, IDC_PHASESELECT),
					!bDataType);

				// Set tau per command line if it was found (not zero)
				if(fCommandTau)
				{
					// Set command line tau flag
					bCommandTau=TRUE;

					if(bDataType==FREQ_DATA)
					{
						fFreqTauInput=fCommandTau;
						bFreqTauDefault=FALSE;
					}
					else // Phase data
					{
						fPhaseTauInput=fCommandTau;
						bPhaseTauDefault=FALSE;
					}

					// Could skip Data File Opened dialog
					// Have all info needed
					// Can do so by setting bSkip
					// But don't - clear bShowFileOpened to skip it 
					// bSkip=TRUE;
				}

				// Load filename & title from command line arg
				strupr(szCommandFile);
				strlcpy(szFile, szCommandFile, FILE_NAME_SIZE);
				_splitpath(szCommandFile, NULL, NULL, szFileTitle, szBuffer);
				strlcat(szFileTitle, szBuffer, FILE_TITLE_SIZE);

				// Read archive file after main window opens
				// by posting message
				if(bArchiveData)
				{
					PostMessage(hwnd, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_AUTOREAD_ARCHIVE, 0, 0));
					break;
				}
				
				// Read data file
				// Note:  Oversize & multiline file reading works
				// but requires manual entry of sizing method & column #s.
				// The DataFileRead dialig box is skipped, so, with normal
				// size & columns, this operation is completely automatic.
				ReadDataFile(&nCols, &nTagCol, &nDatCol);

				// Activate controls
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));

				// Note: If the skip option was not invoked,
				// call the file opened dialog here if it is asked for
				if(!bSkip && bShowFileOpened)
				{
					// Display file opened info
					InvokeDialogBox(hInst, "OpenedBox", hwnd,
						(DLGPROC)OpenedDlgProc);
				}
				
				// Clear command tau flag
				bCommandTau=FALSE;

				// Make sure status bar selection is right
				if(bDataType==FREQ_DATA)
				{
					// Select freq data
					PostMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));
				}
				else // Phase data
				{
					// Select phase data
					PostMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));
				}
			}

			// If filename entered on command line w/o -P or -F data type
			// then invoke Open Data File dialog box with that filename
			// unless file extension is .phd or .frd
			// and have tau in file header
			// Note: This also applies when launching program with drag & drop
			// or Explorer click on data file with registered extension.
			// Rules:
			//   Open Open Data File dialog box only when data type isn't known
			//   Open Data File Opened dialog box according to bShowFileOpened
			if(strlen(szCommandFile) && !bAutoload)
			{
				// Load filename & title from command line arg
				strupr(szCommandFile);
				strlcpy(szFile, szCommandFile, FILE_NAME_SIZE);
				_splitpath(szCommandFile, NULL, NULL, szFileTitle, szBuffer);

				// Check for frequency data file
				if((strcmp(szBuffer, ".FRD")==0)||(strcmp(szBuffer, ".frd")==0))
				{
					// Set the data type
					bDataType=FREQ_DATA;

					// Set data type buttons
					Button_SetCheck(GetDlgItem(hwnd, IDC_FREQSELECT), bDataType);
					Button_SetCheck(GetDlgItem(hwnd, IDC_PHASESELECT),
						!bDataType);

					// Are we checking for a file header?
					if(bCheckFileHeader)
					{
						// Check file header for tau value
						if(TauInfo(szFile, &fCommandTau))
						{
							fFreqTauInput=fCommandTau;
						}

						#if(1) // New code 03/22/10
						// Check file header for addend value
						if(AddendInfo(szFile, &fEntry))
						{
							fFreqAddendInput=fEntry;
						}

						// Check file header for multiplier value
						if(MultiplierInfo(szFile, &fEntry))
						{
							fFreqMultiplierInput=fEntry;
						}

						// Check file header for tag scale value
						if(TagScaleInfo(szFile, &fEntry))
						{
							fFreqTagScale=fEntry;
						}

						// Check file header for tag offset value
						if(TagOffsetInfo(szFile, &fEntry))
						{
							fFreqTagOffset=fEntry;
						}
						#endif
					}

					// Bypass Open Data File dialog
					// Read data file
					// Note:  Oversize & multiline file reading works
					// but requires manual entry of sizing method & column #s.
					// The DataFileOpened dialog box is skipped,
					// so, with normal size & columns,
					// this operation is completely automatic.
					ReadDataFile(&nCols, &nTagCol, &nDatCol);

					// Activate controls
					PostMessage(hwnd, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));

					// Note: If the skip option was not invoked,
					// call the file opened dialog here if it is asked for
					if(!bSkip && bShowFileOpened)
					{
						// Display file opened info
						InvokeDialogBox(hInst, "OpenedBox", hwnd,
							(DLGPROC)OpenedDlgProc);
					}

					// Make sure status bar selection is right
					PostMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));

					// Break here to inhibit Open Data File dialog box
					// (not needed because we know data type)
					break;
				}

				// Check for phase data file
				if((strcmp(szBuffer, ".PHD")==0)||(strcmp(szBuffer, ".phd")==0))
				{
					// Set the data type
					bDataType=PHASE_DATA;

					// Set data type buttons
					Button_SetCheck(GetDlgItem(hwnd, IDC_FREQSELECT), bDataType);
					Button_SetCheck(GetDlgItem(hwnd, IDC_PHASESELECT),
						!bDataType);

					// Are we checking for a file header?
					if(bCheckFileHeader)
					{
						// Check file header for tau value
						if(TauInfo(szFile, &fCommandTau))
						{
							fPhaseTauInput=fCommandTau;
						}

						#if(1) // New code 03/22/10
						// Check file header for addend value
						if(AddendInfo(szFile, &fEntry))
						{
							fPhaseAddendInput=fEntry;
						}

						// Check file header for multiplier value
						if(MultiplierInfo(szFile, &fEntry))
						{
							fPhaseMultiplierInput=fEntry;
						}

						// Check file header for tag scale value
						if(TagScaleInfo(szFile, &fEntry))
						{
							fPhaseTagScale=fEntry;
						}

						// Check file header for tag offset value
						if(TagOffsetInfo(szFile, &fEntry))
						{
							fPhaseTagOffset=fEntry;
						}
						#endif
					}

					// Bypass Open Data File dialog
					// Read data file
					// Note:  Oversize & multiline file reading works
					// but requires manual entry of sizing method & column #s.
					// The DataFileOpened dialog box is skipped,
					// so, with normal size & columns,
					// this operation is completely automatic.
					ReadDataFile(&nCols, &nTagCol, &nDatCol);

					// Activate controls
					PostMessage(hwnd, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));

					// Note: If the skip option was not invoked,
					// call the file opened dialog here if it is asked for
					if(!bSkip && bShowFileOpened)
					{
						// Display file opened info
						InvokeDialogBox(hInst, "OpenedBox", hwnd,
							(DLGPROC)OpenedDlgProc);
					}

					// Make sure status bar selection is right
					PostMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));

					// Break here to inhibit Open Data File dialog box
					// (not needed because we know data type)
					break;
				}

				// Process general data file
				// Are we checking for a file header?
				if(bCheckFileHeader)
				{
					// Check file header for tau value
					if(TauInfo(szFile, &fCommandTau))
					{
						fPhaseTauInput=fCommandTau;
						fFreqTauInput=fCommandTau;
					}

					#if(1) // New code 03/22/10
					// Check file header for addend value
					if(AddendInfo(szFile, &fEntry))
					{
						if(bDataType==FREQ_DATA)
						{
							fFreqAddendInput=fEntry;
						}
						else // Phase data
						{
							fPhaseAddendInput=fEntry;
						}
					}

					// Check file header for multiplier value
					if(MultiplierInfo(szFile, &fEntry))
					{
						if(bDataType==FREQ_DATA)
						{
							fFreqMultiplierInput=fEntry;
						}
						else // Phase data
						{
							fPhaseMultiplierInput=fEntry;
						}
					}

					// Check file header for tag scale value
					if(TagScaleInfo(szFile, &fEntry))
					{
						if(bDataType==FREQ_DATA)
						{
							fFreqTagScale=fEntry;
						}
						else // Phase data
						{
							fPhaseTagScale=fEntry;
						}
					}

					// Check file header for tag offset value
					if(TagOffsetInfo(szFile, &fEntry))
					{
						if(bDataType==FREQ_DATA)
						{
							fFreqTagOffset=fEntry;
						}
						else // Phase data
						{
							fPhaseTagOffset=fEntry;
						}
					}
					#endif
				}

				// Activate controls
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));

				// Post message to invoke Open Data File dialog box
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_MAIN_OPEN, 0, 0));
			}

			// If -o auto# entered on command line,
			// then post a message to open
			// the corresponding dialog box - only one can be active
			if(bAuto1)
			{
				bAutoCmd=TRUE;
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_AUTO1, 0, 0));
			}
			if(bAuto2)
			{
				bAutoCmd=TRUE;
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_AUTO2, 0, 0));
			}
			if(bAuto3)
			{
				bAutoCmd=TRUE;
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_AUTO3, 0, 0));
			}

			// Trial code 11/19/11
			// Post command line function commands
			// Messages are posted for later execution after main window is created
			// All commands are posted the same way with a single IDM_X message
			// The bCmdM, bCmdT, bCmdX and bCmdZ commands do not send messages
			if(bCmdA || bCmdC || bCmdD || bCmdH ||bCmdN || bCmdO || bCmdP || bCmdR ||
				bCmdS || bCmdV || bCmdQ || bCmdU)
			{
				if(!bCmdLine) // Post only one IDM_X message
				{
					PostMessage(hwnd, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDM_X, 0, 0));
				}

				// Set command flag
				bCmdLine=TRUE;
			}
			else if(bCmdZ)
			{
				// Close the Stable32 program
				PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
			}

			#ifdef SPECIAL_VERSION
			// Activate controls
			PostMessage(hwnd, WM_COMMAND,
				GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));
			#endif

			if(fCommandTau)
			{
				// Set the tau status display
				_snprintf(szBuffer, sizeof(szBuffer), "%11.5e", fCommandTau);
				ShortenExp(szBuffer);
				if(bDataType==FREQ_DATA)
				{
					SetWindowText(hwndFreqTau, szBuffer);
				}
				else // Phase data
				{
					SetWindowText(hwndPhaseTau, szBuffer);
				}
			}

			#ifdef SPECIAL_VERSION
			// Display special version message
			PostMessage(hwnd, WM_COMMAND,
				GET_WM_COMMAND_MPS(IDM_MAIN_SPECIAL, 0, 0));
			#endif

			#ifdef WELCOME_MESSAGE
			// Display welcome message
			if(bShowWelcome)
			{
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_MAIN_WELCOME, 0, 0));
			}
			#endif

			#ifdef BETA_MESSAGE
			// Display beta message
			if(TRUE)
			{
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_MAIN_BETA, 0, 0));
			}
			#endif

			#ifdef DEMO_MESSAGE
			// Display demo message
			if(TRUE)
			{
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_MAIN_DEMO, 0, 0));
			}
			#endif

			// Display startup message (unless file loaded from cmd line)
			if(!bAutoload)
			{
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDM_MAIN_START, 0, 0));
			}

			// Make sure menus are activated if there is valid data
			if(bPhaseData || bFreqData)
			{
				PostMessage(hwnd, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDC_ACTIVATE, 0, 0));
			}

			// Make sure status bar selection is right
			if(bDataType==FREQ_DATA)
			{
				// Select freq data
				PostMessage(hwndMain, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));
			}
			else // Phase data
			{
				// Select phase data
				PostMessage(hwndMain, WM_COMMAND,
					GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));
			}
			return 0;
		}

        case WM_NOTIFY:
		{
			switch(((NMHDR*)lParam)->code)
			{ 
				case TCN_SELCHANGE:
				{ 
					// Get tab #
					nTab=TabCtrl_GetCurSel(hwndTab);

					// Get state of control key
					nDummy=GetKeyState(VK_CONTROL);
					// Check if control key is pressed
					// If so, don't read tab data
					// Just allow this tab to be selected
					if(nDummy==-127 || nDummy==-128)
					{
						break;
					}

					// Open selected file
					// bDataType determines data type
					// sPTab[nTab].fData or sFTab[nTab].fData
					// points to data array to go into
					// fPhaseData or fFreqData
					// sPTab[nTab].fTags or sFTab[nTab].fTags
					// points to timetag array (if any)

					if(bDataType==PHASE_DATA)
					{
						// Get size of tabbed phase data array
						nDummy=(int)sPTab[nTab].fData[0];

						// Reallocate fPhaseData array
						if((fNew=(F_TYPE*)realloc((char *)fPhaseData,
							(nDummy+ARRAY_OFFSET)*sizeof(F_TYPE)))==NULL)
						{
							AllocErrorMessage();
						}
						else
						{
							fPhaseData=fNew;
						}

						// Copy tabbed data into phase data array
						for(i=0; i<nDummy+ARRAY_OFFSET; i++)
						{
							fPhaseData[i]=sPTab[nTab].fData[i];
						}
						
						// Does tab have timetags?
						if(sPTab[nTab].bTags)
						{
							// Reallocate fPhaseTimetags array
							if((fNew=(F_TYPE*)realloc((char *)fPhaseTimetags,
								(nDummy+ARRAY_OFFSET)*sizeof(F_TYPE)))==NULL)
							{
								AllocErrorMessage();
							}
							else
							{
								fPhaseTimetags=fNew;
							}

							// Copy tabbed timetags into phase timetags array
							for(i=0; i<nDummy+ARRAY_OFFSET; i++)
							{
								fPhaseTimetags[i]=sPTab[nTab].fTags[i];
							}

							// Set the timetags flag
							bPhaseTimetags=TRUE;
						}
						else // No phase timetags
						{
							// Clear the timetags flag
							bPhaseTimetags=FALSE;
						}
						
						// Set the phase filename
						SetWindowText(hwndPhaseFilename, sPTab[nTab].szTitle);
						strlcpy(szPhaseFile, sPTab[nTab].szTitle,
							FILE_NAME_SIZE);
						strlcpy(szPhaseFileTitle, sPTab[nTab].szTitle,
							FILE_TITLE_SIZE);
						strlcpy(szFile, sPTab[nTab].szTitle, FILE_NAME_SIZE);
						strlcpy(szFileTitle, sPTab[nTab].szTitle,
							FILE_TITLE_SIZE);
						WriteMessage("");

						// Set the phase analysis limits & #
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)fPhaseData[1]);
						SetWindowText(hwndPhaseStart, szBuffer);
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)fPhaseData[2]);
						SetWindowText(hwndPhaseEnd, szBuffer);
						SetWindowText(hwndPhaseNum, szBuffer);

						// Set the tau status display
						_snprintf(szBuffer, sizeof(szBuffer), "%11.5e",
							sPTab[nTab].fTau);
						ShortenExp(szBuffer);
						SetWindowText(hwndPhaseTau, szBuffer);

						// Set flags
						bPhaseData=TRUE;
						bPhaseDataChanged=TRUE;
						bPhaseDataUnsaved=TRUE;
						bPhaseScaleChanged=TRUE;
						bPhaseRedraw=TRUE;
						bSynch=FALSE;

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Write log entry
						WriteLog(72, sPTab[nTab].szTitle);

						// Refresh screen
						UpdateStatusBar(hwndMain, TRUE);
						RedrawToolbar(tb, TRUE);
						ActivateFunctions(MF_ENABLED);
						SetTabMenu();
					}
					else // Freq data
					{
						// Get size of tabbed freq data array
						nDummy=(int)sFTab[nTab].fData[0];

						// Reallocate fFreqData array
						if((fNew=(F_TYPE*)realloc((char *)fFreqData,
							(nDummy+ARRAY_OFFSET)*sizeof(F_TYPE)))==NULL)
						{
							AllocErrorMessage();
						}
						else
						{
							fFreqData=fNew;
						}

						// Copy tabbed data into freq data array
						for(i=0; i<nDummy+ARRAY_OFFSET; i++)
						{
							fFreqData[i]=sFTab[nTab].fData[i];
						}

						// Does tab have timetags?
						if(sFTab[nTab].bTags)
						{
							// Reallocate fFreqTimetags array
							if((fNew=(F_TYPE*)realloc((char *)fFreqTimetags,
								(nDummy+ARRAY_OFFSET)*sizeof(F_TYPE)))==NULL)
							{
								AllocErrorMessage();
							}
							else
							{
								fFreqTimetags=fNew;
							}

							// Copy tabbed timetags into freq timetags array
							for(i=0; i<nDummy+ARRAY_OFFSET; i++)
							{
								fFreqTimetags[i]=sFTab[nTab].fTags[i];
							}

							// Set the timetags flag
							bFreqTimetags=TRUE;
						}
						else // No freq timetags
						{
							// Clear the timetags flag
							bFreqTimetags=FALSE;
						}

						// Set the freq filename
						SetWindowText(hwndFreqFilename, sFTab[nTab].szTitle);
						strlcpy(szFreqFile, sFTab[nTab].szTitle,
							FILE_NAME_SIZE);
						strlcpy(szFreqFileTitle, sFTab[nTab].szTitle,
							FILE_TITLE_SIZE);
						strlcpy(szFile, sFTab[nTab].szTitle, FILE_NAME_SIZE);
						strlcpy(szFileTitle, sFTab[nTab].szTitle,
							FILE_TITLE_SIZE);

						// Set the freq analysis limits & #
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)fFreqData[1]);
						SetWindowText(hwndFreqStart, szBuffer);
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)fFreqData[2]);
						SetWindowText(hwndFreqEnd, szBuffer);
						SetWindowText(hwndFreqNum, szBuffer);

						// Set the tau status display
						_snprintf(szBuffer, sizeof(szBuffer), "%11.5e",
							sFTab[nTab].fTau);
						ShortenExp(szBuffer);
						SetWindowText(hwndFreqTau, szBuffer);
						
						// Set flags
						bFreqData=TRUE;
						bFreqDataChanged=TRUE;
						bFreqDataUnsaved=TRUE;
						bFreqScaleChanged=TRUE;
						bFreqRedraw=TRUE;
						bSynch=FALSE;

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Write log entry
						WriteLog(73, sFTab[nTab].szTitle);

						// Refresh screen
						UpdateStatusBar(hwndMain, TRUE);
						RedrawToolbar(tb, TRUE);
						ActivateFunctions(MF_ENABLED);
						SetTabMenu();
					}

					// Update plot subtitles to new file title
					UpdatePlotSubtitles();
				} 
			} 
		}
		
		case WM_CTLCOLORMSGBOX:
		case WM_CTLCOLOREDIT:
		case WM_CTLCOLORLISTBOX:
		case WM_CTLCOLORBTN:
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSCROLLBAR:
		case WM_CTLCOLORSTATIC:
		{
			// Force phase & freq select control colors
			if(GET_WM_CTLCOLOR_HWND(wParam, lParam, message)==
				hwndPhaseSelectButton)
			{
				SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
					GetSysColor(COLOR_BTNFACE));
				SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
					GetSysColor(COLOR_WINDOWTEXT));

				return((DWORD) hBrush);
			}

			if(GET_WM_CTLCOLOR_HWND(wParam, lParam, message)==
				hwndFreqSelectButton)
			{
				SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
					GetSysColor(COLOR_BTNFACE));
				SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
					GetSysColor(COLOR_WINDOWTEXT));

				return((DWORD) hBrush);
			}

			// Force phase & freq status bar plot text colors
			if(GET_WM_CTLCOLOR_HWND(wParam, lParam, message)==
				hwndPhasePlot)
			{
				if(bDataType==PHASE_DATA)
				{
					SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNFACE));
					SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						0x000000FF);
				}
				else
				{
					SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNFACE));
					SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNTEXT));
				}
				return((DWORD) hBrush);
			}

			if(GET_WM_CTLCOLOR_HWND(wParam, lParam, message)==
				hwndFreqPlot)
			{
				if(bDataType==FREQ_DATA)
				{
					SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNFACE));
					SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						0x000000FF);
				}
				else
				{
					SetBkColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNFACE));
					SetTextColor(GET_WM_CTLCOLOR_HDC(wParam, lParam, message),
						GetSysColor(COLOR_BTNTEXT));
				}
				return((DWORD) hBrush);
			}
			break;
		}

		// This redraws the status bar by causing a WM_PAINT if flag is true.
		// It has the effect of erasing the toolbar help hint after the mouse
		// mover off the toolbar.  The flag only lets the repaint happen once
		// to avoid flicker.
		case WM_MOUSEMOVE:
		{
			if(!bPaintFlag)
			{
				break;
			}
			bPaintFlag=FALSE;
		}
		// Go into WM_PAINT

		case WM_PAINT:
		{
			// Refresh the brush color used to paint the background
			// in case the system colors have changed
			DeleteObject(hBrush);
			hBrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
			
			hdc=BeginPaint(hwnd, &ps);

			EndPaint(hwnd, &ps);

			UpdateStatusBar(hwnd, NEW_DATA);

			WriteDateMessage();

			return 0;
		}

		// Respond to WM_SIZE message to reposition the status bar controls
		case WM_SIZE:
		{
			// New code 02/10/00
			// Redetermine screen resolution
			// Size may have increased to where
			// status bar data plot is OK
			if((GetSystemMetrics(SM_CXSCREEN))>1000) // XGA is 1024
			{
				bShowPlot=TRUE; // XGA or better
			}
			else
			{
				bShowPlot=FALSE; // SVGA or lower
			}

			// Get the new main window size
			GetClientRect(hwnd, &rect);
			cxMain=rect.right;
			cyMain=rect.bottom;

            // Resize tab control - new code 11/16/06
			if(bTabs)
			{
				rc.left=0;
				rc.right=cxMain;
				rc.top=(int)(cyMain-3.25*cyChar-1-2.5*cyChar/2.5)-30;
				rc.bottom=rc.top+26;
				MoveWindow(hwndTab, 0, rc.top, rc.right, 26, TRUE);
			}
			
			// Disable the status bar data plot boxes
			// when screen is too narrow
			// (cxMain too small) even if XGA or better when main window is
			// shrunk.  A width of 950 pixels is about the min for OK plots.
			if(cxMain<950)
			{
				bShowPlot=FALSE;
			}
	
			// Redraw status bar in new location
			MoveStatusBarControls(hwnd);

			// Force redraw of status plots
			bPhaseRedraw=TRUE;
			bFreqRedraw=TRUE;
			
			// Resize the toolbar
			if(hwndToolbar) // Doesn't exist at startup
			{
				MoveWindow(hwndToolbar, 0, 0, cxMain, (int)(1.45*cyIcon),
					TRUE);
			}

			// Update status bar
			UpdateStatusBar(hwnd, NEW_DATA);
			break;
		}

		// Respond to L mouse button to select data type
		// or zoom status plot out
		case WM_LBUTTONDOWN:
		{
			// With this, a click of the L mouse button anywhere will
			// refresh the status plots
			SendMessage(hwndMain, WM_COMMAND,
				GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

			// Get freq plot window screen coordinates
			GetWindowRect(hwndFreqPlot, &FreqPlotRect);

			// Get mouse cursor position in screen coordinates
			GetCursorPos(&MousePoint);

			// Is mouse in freq plot?
			if(PtInRect(&FreqPlotRect, MousePoint))
			{
				if(bDataType==PHASE_DATA)
				{
					// Just change to freq data - no zooming out
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));
					break;
				}
				else // Freq data - zoom out
				{
					// Get freq plot location in client coordinates
					// wrt top left = (0,0)
					GetClientRect(hwndFreqPlot, &FreqPlotRect);
					
					// Convert mouse pos to freq plot window
					// client coordinates
					ScreenToClient(hwndFreqPlot, &MousePoint);
					
					// Calc point # at mouse position
					nPoints=(int)(fFreqData[2]-fFreqData[1]+1);
					fXScale=(F_TYPE)(FreqPlotRect.right-FreqPlotRect.left);
					i=(int)(MousePoint.x*nPoints/fXScale)+(int)(fFreqData[1]);

					// Zoom out freq data analysis limits by factor of 2
					if( (fFreqData[1]>1) || (fFreqData[2]<fFreqData[0]) )
					{
						// Center zoom range on mouse position
						fFreqData[1]=max((F_TYPE)(i-nPoints), 1);
						fFreqData[2]=min((F_TYPE)(i+nPoints), fFreqData[0]);
					}
					else // Fully zoomed out
					{
						MessageBeep(1);
						break;
					}

					// Update freq analysis limits
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fFreqData[1]);
					SetWindowText(hwndFreqStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fFreqData[2]);
					SetWindowText(hwndFreqEnd, szBuffer);

					// Set freq redraw flag
					bFreqRedraw=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}
			}
				
			// Get phase plot window screen coordinates
			GetWindowRect(hwndPhasePlot, &PhasePlotRect);

			// Get mouse cursor position in screen coordinates
			GetCursorPos(&MousePoint);
	
			// Is mouse in phase plot?
			if(PtInRect(&PhasePlotRect, MousePoint))
			{
				if(bDataType==FREQ_DATA)
				{
					// Just change to phase data - no zooming out
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));
					break;
				}
				else // Phase data
				{
					// Get phase plot location in client coordinates
					// wrt top left = (0,0)
					GetClientRect(hwndPhasePlot, &PhasePlotRect);
					
					// Convert mouse pos to phase plot window
					// client coordinates
					ScreenToClient(hwndPhasePlot, &MousePoint);
					
					// Calc point # at mouse position
					nPoints=(int)(fPhaseData[2]-fPhaseData[1]+1);
					fXScale=(F_TYPE)(PhasePlotRect.right-PhasePlotRect.left);
					i=(int)(MousePoint.x*nPoints/fXScale)+(int)(fPhaseData[1]);

					// Zoom out phase data analysis limits by factor of 2
					if( (fPhaseData[1]>1) || (fPhaseData[2]<fPhaseData[0]) )
					{
						// Center zoom range on mouse position
						fPhaseData[1]=max((F_TYPE)(i-nPoints), 1);
						fPhaseData[2]=min((F_TYPE)(i+nPoints), fPhaseData[0]);
					}
					else // Fully zoomed out
					{
						MessageBeep(1);
						break;
					}

					// Update phase analysis limits
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fPhaseData[1]);
					SetWindowText(hwndPhaseStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fPhaseData[2]);
					SetWindowText(hwndPhaseEnd, szBuffer);

					// Set phase redraw flag
					bPhaseRedraw=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}		
			}
		}
		break;

		// Respond to right mouse button to zoom in status bar plot
		case WM_RBUTTONDOWN:
		{
			// Ignore zooming in if no status plots
			if(!bStatusPlot)
			{
				break;
			}

			if(bDataType==FREQ_DATA)
			{
				// Get freq plot window screen coordinates
				GetWindowRect(hwndFreqPlot, &FreqPlotRect);

				// Get mouse cursor position in screen coordinates
				GetCursorPos(&MousePoint);

				// Is mouse in freq plot?
				if(PtInRect(&FreqPlotRect, MousePoint))
				{
		            // Get freq plot location in client coordinates
					// wrt top left = (0,0)
					GetClientRect(hwndFreqPlot, &FreqPlotRect);
					
					// Convert mouse pos to freq plot window
					// client coordinates
					ScreenToClient(hwndFreqPlot, &MousePoint);
					
					// Calc point # at mouse position
					nPoints=(int)(fFreqData[2]-fFreqData[1]+1);
					fXScale=(F_TYPE)(FreqPlotRect.right-FreqPlotRect.left);
					i=(int)(MousePoint.x*nPoints/fXScale)+(int)(fFreqData[1]);
						
					// Zoom in freq data analysis limits by factor of 2
					// Must have least 8 points to give least 4 zoomed points
					if(nPoints>=8) 
					{
						// Center zoom range on mouse position
						fFreqData[1]=max((F_TYPE)(i-nPoints/4), 1);
						fFreqData[2]=min((F_TYPE)(i+nPoints/4), fFreqData[0]);
					}
					else // Fully zoomed in
					{
						MessageBeep(1);
						break;
					}

					// Update freq analysis limits
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fFreqData[1]);
					SetWindowText(hwndFreqStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 
						(int)fFreqData[2]);
					SetWindowText(hwndFreqEnd, szBuffer);

					// Set freq redraw flag
					bFreqRedraw=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}
			}
			else // Phase data
			{
				// Get phase plot window screen coordinates
				GetWindowRect(hwndPhasePlot, &PhasePlotRect);

				// Get mouse cursor position in screen coordinates
				GetCursorPos(&MousePoint);
	
				// Is mouse in phase plot?
				if(PtInRect(&PhasePlotRect, MousePoint))
				{
					// Get phase plot location in client coordinates
					// wrt top left = (0,0)
					GetClientRect(hwndPhasePlot, &PhasePlotRect);
					
					// Convert mouse pos to phase plot window
					// client coordinates
					ScreenToClient(hwndPhasePlot, &MousePoint);
					
					// Calc point # at mouse position
					nPoints=(int)(fPhaseData[2]-fPhaseData[1]+1);
					fXScale=(F_TYPE)(PhasePlotRect.right-PhasePlotRect.left);
					i=(int)(MousePoint.x*nPoints/fXScale)+(int)(fPhaseData[1]);
						
					// Zoom in phase data analysis limits by factor of 2
					// Must have least 8 points to give least 4 zoomed points
					if(nPoints>=8) 
					{
						// Center zoom range on mouse position
						fPhaseData[1]=max((F_TYPE)(i-nPoints/4), 1);
						fPhaseData[2]=min((F_TYPE)(i+nPoints/4),
							fPhaseData[0]);
					}
					else
					{
						MessageBeep(1);
						break;
					}

					// Update phase analysis limits
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fPhaseData[1]);
					SetWindowText(hwndPhaseStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fPhaseData[2]);
					SetWindowText(hwndPhaseEnd, szBuffer);

					// Set phase redraw flag
					bPhaseRedraw=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}
			}		
		}
		break;

		case WM_COMMAND:
		{
			switch(GET_WM_COMMAND_ID(wParam, lParam))
			{
				// Status bar IDs
				case IDC_PHASERESET:
				{
					// Reset analysis limits
					fPhaseData[1]=1.0;
					fPhaseData[2]=fPhaseData[0];
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
					SetWindowText(hwndPhaseStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fPhaseData[0]);
					SetWindowText(hwndPhaseEnd, szBuffer);

					// Update analysis limit display
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)(fPhaseData[2]-fPhaseData[1]+1));
					SetWindowText(hwndPhaseLim, szBuffer);

					// Set phase redraw flag
					bPhaseRedraw=TRUE;

					// Force new PSD plot scale
					sPSPlot.y_tic=0;

					// Set phase data plot scale changed flag
					bPhaseScaleChanged=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}
				break;

				case IDC_FREQRESET:
				{
					// Reset analysis limits
					fFreqData[1]=1.0;
					fFreqData[2]=fFreqData[0];
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
					SetWindowText(hwndFreqStart, szBuffer);
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)fFreqData[0]);
					SetWindowText(hwndFreqEnd, szBuffer);

					// Update analysis limit display
					_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
						(int)(fFreqData[2]-fFreqData[1]+1));
					SetWindowText(hwndFreqLim, szBuffer);

					// Set freq redraw flag
					bFreqRedraw=TRUE;

					// Force new PSD plot scale
					sPSPlot.y_tic=0;

					// Set freq data plot scale changed flag
					bFreqScaleChanged=TRUE;

					// Update status bar
					UpdateStatusBar(hwnd, NEW_DATA);
				}
				break;

				case IDC_PHASETAU:
				{
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_SETFOCUS)
					{
						// Get phase tau when its control gets focus
						GetWindowText(GetDlgItem(hwnd, IDC_PHASETAU),
							szBuffer, BUFFER_SIZE);
							
						// Save its absolute value as fPrev
						fPrev=fabs(atof(szBuffer));
					}
					
					// Respond to edit control when it loses the input focus
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS)
					{
						// Get phase tau entry
						GetWindowText(GetDlgItem(hwnd, IDC_PHASETAU),
							szBuffer, BUFFER_SIZE);

						// Use its absolute value
						fEntry=fabs(atof(szBuffer));

						// Check entry - must be >0
						if(fEntry)
						{
							// New value OK
							_snprintf(szBuffer, sizeof(szBuffer),
								"%11.5e", fEntry);
							ShortenExp(szBuffer);
							SetWindowText(GetDlgItem(hwnd,IDC_PHASETAU),
								szBuffer);

							// May need new phase data plot x-axis scale
							bPhaseScaleChanged=TRUE;

							// Adjust time scale factor if not # points
							if( (nPPlotX!=X_POINT) && (nPPlotX!=X_KPOINT) )
							{
								// Scale x-scale as ratio of new
								// to previous tau.
								sPPlot.x_mult*=(float)(fEntry/fPrev);
							}
							
							// Issue warning if have timetag disagreement
							if(bPhaseTimetags)
							{
								// Find timetag interval
								fPrev=fPhaseTimetags[ARRAY_OFFSET+1]-
									fPhaseTimetags[ARRAY_OFFSET];

								// Adjust for timetag scale factor
								fPrev*=fPhaseTagScale;

								// Check if new tau not equal to
								// timetag interval
								// to within 1% tolerance
								if( ((fEntry/fPrev)>1.01) ||
									((fPrev/fEntry)>1.01) )
								{
									// Issue warning
									LoadString(hInst, IDS_MESSAGE_NEWTAU,
										szBuffer, BUFFER_SIZE);
									MessageBox(hwnd, szBuffer, "Tau",
										MB_ICONEXCLAMATION);
								}
							}
						}
						else
						{
							// Invalid entry - restore previous value
							LoadString(hInst, IDS_MESSAGE_NOZERO, szBuffer,
								BUFFER_SIZE);
							MessageBox(hwnd, szBuffer, "Invalid Entry",
								MB_ICONEXCLAMATION);
							_snprintf(szBuffer, sizeof(szBuffer), "%11.5e",
								fPrev);
							ShortenExp(szBuffer);
							SetWindowText(GetDlgItem(hwnd,IDC_PHASETAU),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_PHASETAU));
						}
					}
				}
				break;

				case IDC_PHASESTART:
				{
					if((GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS) &&
						(!bErrorTrap))
					{
						// Set error flag to avoid multiple error messages
						bErrorTrap=TRUE;

						// Save original phase start value
						nStart=(int)fPhaseData[1];

						// Get phase start entry
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=abs(atoi(szBuffer));

						// Get phase end #
						nEnd=(int)fPhaseData[2];

						// Check entry - must be between 1 and nEnd
						if(ValidateInteger(hwnd, nEntry, 1, nEnd)==TRUE)
						{
							// Valid entry - change array value
							fPhaseData[1]=nEntry;

							// May need new phase data plot x-axis scale
							bPhaseScaleChanged=TRUE;
						}
						else
						{
							// Invalid entry - restore default value
							fPhaseData[1]=1;
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
							SetWindowText(GetDlgItem(hwnd,IDC_PHASESTART),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_PHASESTART));
						}

						// Update analysis limit # display
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)(fPhaseData[2]-fPhaseData[1]+1));
						SetWindowText(hwndPhaseLim, szBuffer);

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Update status plot only if necessary
						if(fPhaseData[1]!=nStart)
						{
							// Set phase redraw flag
							bPhaseRedraw=TRUE;

							// Update status bar
							UpdateStatusBar(hwnd, NEW_DATA);
						}
					}
					else
					{
						// Reset error flag
						bErrorTrap=FALSE;
					}
				}
				break;

				case IDC_PHASEEND:
				{
					// Respond to edit control when it loses the input focus
					if((GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS) &&
						(!bErrorTrap))
					{
						// Set error flag to avoid multiple error messages
						bErrorTrap=TRUE;

						// Save original phase end value
						nEnd=(int)fPhaseData[2];

						// Get phase end entry
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=abs(atoi(szBuffer));

						// Get phase start #
						nStart=(int)fPhaseData[1];

						// Get # phase data points
						nNum=(int)fPhaseData[0];

						// Check entry - must be between nStart and nNum
						if(ValidateInteger(hwnd, nEntry, nStart, nNum)==TRUE)
						{
							// Valid entry - change array value
							fPhaseData[2]=nEntry;

							// May need new phase data plot x-axis scale
							bPhaseScaleChanged=TRUE;
						}
						else
						{
							// Invalid entry - restore default value
							fPhaseData[2]=nNum;
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
								nNum);
							SetWindowText(GetDlgItem(hwnd,IDC_PHASEEND),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_PHASEEND));
						}

						// Update analysis limit # display
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)(fPhaseData[2]-fPhaseData[1]+1));
						SetWindowText(hwndPhaseLim, szBuffer);

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Update status plot only if necessary
						if(fPhaseData[2]!=nEnd)
						{
							// Set phase redraw flag
							bPhaseRedraw=TRUE;

							// Update status bar
							UpdateStatusBar(hwnd, NEW_DATA);
						}
					}
					else
					{
						// Reset error flag
						bErrorTrap=FALSE;
					}
				}
				break;

				case IDC_FREQTAU:
				{
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_SETFOCUS)
					{
						// Get freq tau when its control gets focus
						GetWindowText(GetDlgItem(hwnd, IDC_FREQTAU),
							szBuffer, BUFFER_SIZE);
							
						// Save its absolute value as fPrev
						fPrev=fabs(atof(szBuffer));
					}
					
					// Respond to edit control when it loses the input focus
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS)
					{
						// Get freq tau entry
						GetWindowText(GetDlgItem(hwnd, IDC_FREQTAU),
							szBuffer, BUFFER_SIZE);

						// Use its absolute value
						fEntry=fabs(atof(szBuffer));

						// Check entry - must be >0
						if(fEntry)
						{
							// New value OK
							_snprintf(szBuffer, sizeof(szBuffer), "%11.5e",
								fEntry);
							ShortenExp(szBuffer);
							SetWindowText(GetDlgItem(hwnd,IDC_FREQTAU),
								szBuffer);

							// May need new freq data plot x-axis scale
							bFreqScaleChanged=TRUE;

							// Adjust time scale factor if not # points
							if( (nFPlotX!=X_POINT) && (nFPlotX!=X_KPOINT) )
							{
								// Scale x-scale as ratio of new to
								// previous tau.
								sFPlot.x_mult*=(float)(fEntry/fPrev);
							}

							// Issue warning if have timetag disagreement
							if(bFreqTimetags)
							{
								// Find timetag interval
								fPrev=fFreqTimetags[ARRAY_OFFSET+1]-
									fFreqTimetags[ARRAY_OFFSET];

								// Adjust for timetag scale factor
								fPrev*=fFreqTagScale;

								// Check if new tau not equal to
								// timetag interval
								// to within 1% tolerance
								if(((fEntry/fPrev)>1.01) ||
									((fPrev/fEntry)>1.01))
								{
									// Issue warning
									LoadString(hInst, IDS_MESSAGE_NEWTAU,
										szBuffer, BUFFER_SIZE);
									MessageBox(hwnd, szBuffer, "Tau",
										MB_ICONEXCLAMATION);
								}
							}
						}
						else
						{
							// Invalid entry - restore previous value
							LoadString(hInst, IDS_MESSAGE_NOZERO, szBuffer,
								BUFFER_SIZE);
							MessageBox(hwnd, szBuffer, "Invalid Entry",
								MB_ICONEXCLAMATION);
							_snprintf(szBuffer, sizeof(szBuffer), "%11.5e",
								fPrev);
							ShortenExp(szBuffer);
							SetWindowText(GetDlgItem(hwnd,IDC_FREQTAU),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_FREQTAU));
						}
					}
					else
					{
						// Reset error flag
						bErrorTrap=FALSE;
					}
				}
				break;

				case IDC_FREQSTART:
				{
					// Respond to edit control when it loses the input focus
					if((GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS) &&
						(!bErrorTrap))
					{
						// Set error flag to avoid multiple error messages
						bErrorTrap=TRUE;

						// Save original freq start value
						nStart=(int)fFreqData[1];

						// Get freq start entry
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Get freq end #
						nEnd=(int)fFreqData[2];

						// Check entry - must be between 1 and nEnd
						if(ValidateInteger(hwnd, nEntry, 1, nEnd)==TRUE)
						{
							// Valid entry - change array value
							fFreqData[1]=nEntry;

							// May need new freq data plot x-axis scale
							bFreqScaleChanged=TRUE;
						}
						else
						{
							// Invalid entry - restore default value
							fFreqData[1]=1;
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
							SetWindowText(GetDlgItem(hwnd,IDC_FREQSTART),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_FREQSTART));
						}

						// Update analysis limit # display
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)(fFreqData[2]-fFreqData[1]+1));
						SetWindowText(hwndFreqLim, szBuffer);

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Update status plot only if necessary
						if(fFreqData[1]!=nStart)
						{
							// Set freq redraw flag
							bFreqRedraw=TRUE;

							// Update status bar
							UpdateStatusBar(hwnd, NEW_DATA);
						}
					}
					else
					{
						// Reset error flag
						bErrorTrap=FALSE;
					}
				}
				break;

				case IDC_FREQEND:
				{
					// Respond to edit control when it loses the input focus
					if((GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS) &&
						(!bErrorTrap))
					{
						// Set error flag to avoid multiple error messages
						bErrorTrap=TRUE;

						// Save original freq end value
						nEnd=(int)fFreqData[2];

						// Get freq end entry
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=abs(atoi(szBuffer));

						// Get freq start #
						nStart=(int)fFreqData[1];

						// Get # freq data points
						nNum=(int)fFreqData[0];

						// Check entry - must be between nStart and nNum
						if(ValidateInteger(hwnd, nEntry, nStart, nNum)==TRUE)
						{
							// Valid entry - change array value
							fFreqData[2]=nEntry;

							// May need new freq data plot x-axis scale
							bFreqScaleChanged=TRUE;
						}
						else
						{
							// Invalid entry - restore default value
							fFreqData[2]=nNum;
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
								nNum);
							SetWindowText(GetDlgItem(hwnd,IDC_FREQEND),
								szBuffer);
							SetFocus(GetDlgItem(hwnd,IDC_FREQEND));
						}

						// Update analysis limit # display
						_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
							(int)(fFreqData[2]-fFreqData[1]+1));
						SetWindowText(hwndFreqLim, szBuffer);

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Update status plot only if necessary
						if(fFreqData[2]!=nEnd)
						{
							// Set freq redraw flag
							bFreqRedraw=TRUE;

							// Update status bar
							UpdateStatusBar(hwnd, NEW_DATA);
						}
					}
					else
					{
						// Reset error flag
						bErrorTrap=FALSE;
					}
				}
				break;

				//  Menu IDs
				case IDM_MAIN_OPEN:
				{
					// Write prompt message
					WritePromptMessage(TB_OPEN);

					// Set open dialog box title
					strlcpy(szTitleString, "Open Data File", DLG_TITLE_SIZE);
					strlcpy(szBoxTitle, "Open Data File", TITLESIZE);

					// Note: Custom Open dialog box can be disabled
					// by making 1st argument in next 2 calls FALSE
					// Works with old-style CustomOpenBox
					// Modified 12/06/00 for Explorer-style box
					
					// Initialize OPENFILENAME structure
					FileInitialize(TRUE, TRUE, hwnd, hInst, szTitleString, 0);

					// Invoke File Open Dialog
					// Function returns TRUE if valid result
					if(FileOpenDlg(TRUE, hwnd, szFile, szFileTitle))
					{
						#ifndef LITE_VER
						// Read database or archive file
						if(bArchiveData)
						{
							// Open dialog box
							InvokeDialogBox(hInst, "ArchiveBox", hwnd,
								(DLGPROC)ArchiveDlgProc);

							// Put info into log file
							WriteLog(5, szFile);
							break;
						}
						#endif

						// Set data type for *.phd and *.frd files
						// Split filename into its parts to get extension
						// Note: Extension includes the dot
						_splitpath(szFileTitle, NULL, NULL, NULL, szBuffer);

						// Convert extension to upper case
						strupr(szBuffer);

						// Check for phase data type
						if((strcmp(szBuffer, ".PHD"))==0)
						{
							// Set data type to phase
							bDataType=PHASE_DATA;
							Button_SetCheck(GetDlgItem(hwndMain,
								IDC_FREQSELECT), FALSE);
							Button_SetCheck(GetDlgItem(hwndMain,
								IDC_PHASESELECT), TRUE);
						}

						// Check for freq data type
						if((strcmp(szBuffer, ".FRD"))==0)
						{
							// Set data type to freq
							bDataType=FREQ_DATA;
							Button_SetCheck(GetDlgItem(hwndMain,
								IDC_FREQSELECT), TRUE);
							Button_SetCheck(GetDlgItem(hwndMain,
								IDC_PHASESELECT), FALSE);
						}
						
						// At this point, we are using the standard FileOpen
						// dialog to open a data file
						// The bPhaseData and bFreqData flags
						// tell us if there is current data of each type
						// If there is, and the bTabs and
						// bTabFile flags are set,
						// then we want to save the current data in a data tab
						// Create tab to save previous data if requested
						if(bTabs && bTabFile)
						{
							// If have current phase data
							if(bDataType==PHASE_DATA && bPhaseData)
							{
								CreateTab();
							}

							// If have current freq data
							if(bDataType==FREQ_DATA && bFreqData)
							{
								CreateTab();
							}
						}
						
						// Read data file
						if(ReadDataFile(&nCols, &nTagCol, &nDatCol))
						{
							// Update the previous file list in file menu
							if(bDataType==FREQ_DATA)
							{
								strlcpy(szPreviousFreqFilename[0], szFile,
									FILE_NAME_SIZE);
								UpdateFileInfo(szPreviousFreqFilename);
							}
							else if(bDataType==PHASE_DATA)
							{
								strlcpy(szPreviousPhaseFilename[0], szFile,
									FILE_NAME_SIZE);
								UpdateFileInfo(szPreviousPhaseFilename);
							}

							// Eliminate all sigma plot lines
							for(i=0; i<SLINE_NUMLINES; i++)
							{
								sSLine[i].nLineType=SLINE_NONE;
							}

							if(bDataType==PHASE_DATA)
							{
								// Put info into log file
								WriteLog(3, szFile);
								
								// Eliminate all phase plot lines
								for(i=0; i<PLINE_NUMLINES; i++)
								{
									sPLine[i].nLineType=PLINE_NONE;
								}
							}

							if(bDataType==FREQ_DATA)
							{
								// Put info into log file
								WriteLog(4, szFile);
								
								// Eliminate all freq plot lines
								for(i=0; i<FLINE_NUMLINES; i++)
								{
									sFLine[i].nLineType=FLINE_NONE;
								}
							}

							if(bShowFileOpened)
							{
								// Display file opened info
								InvokeDialogBox(hInst, "OpenedBox", hwnd,
									(DLGPROC)OpenedDlgProc);
							}

							// Force new PSD plot scale
							sPSPlot.y_tic=0;

							// Save data type of last data file opened
							bLastOpened=bDataType;

							// Added 09/30/12
							// Reset data synch flag
							bSynch=FALSE;

							// Added 09/30/12
							// Refresh status plots
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

							// Just in case
							UpdateStatusBar(hwnd, NEW_DATA);
						}
					}
					else // Error
					{
						#ifndef LITE_VER
						// Display error message
						if(CommonDialogError(szBuffer))
						// 0 means that user simply canceled Open - not error
						{
							MessageBox(hwndMain, szBuffer,
								"File Open Error",	MB_ICONEXCLAMATION);
						}
						#endif
					}

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					// Refresh Tabs menu
					SetTabMenu();
				}
				break;

				case IDM_FILE1:
				case IDM_FILE2:
				case IDM_FILE3:
				{
					// Write prompt message
					WritePromptMessage(TB_OPEN);

					// Copy previous filename to active file open name
					if(bDataType==FREQ_DATA)
					{
						strlcpy(szFile,
							szPreviousFreqFilename[(int)
							(GET_WM_COMMAND_ID(wParam, lParam)-IDM_FILE1+1)],
							FILE_NAME_SIZE);

						// Parse basic filename from full filename
						ptr=strrchr(
							szPreviousFreqFilename[(int)
							(GET_WM_COMMAND_ID(wParam, lParam)-IDM_FILE1+1)],
							'\\');
						if(ptr==NULL) // No drive or path
						{
							strlcpy(szFileTitle,
								szPreviousFreqFilename[
								(int)(GET_WM_COMMAND_ID(wParam, lParam)-
								IDM_FILE1+1)], FILE_TITLE_SIZE);
						}
						else
						{
							strlcpy(szFileTitle, ptr+1, FILE_TITLE_SIZE);
						}
					}
					else // Phase data
					{
						strlcpy(szFile,
							szPreviousPhaseFilename[(int)
							(GET_WM_COMMAND_ID(wParam, lParam)-IDM_FILE1+1)],
							FILE_NAME_SIZE);

						// Parse basic filename from full filename
						ptr=strrchr(
							szPreviousPhaseFilename[(int)
							(GET_WM_COMMAND_ID(wParam, lParam)-IDM_FILE1+1)],
							'\\');
						if(ptr==NULL) // No drive or path
						{
							strlcpy(szFileTitle,
								szPreviousPhaseFilename[
								(int)(GET_WM_COMMAND_ID(wParam, lParam)-
								IDM_FILE1+1)], FILE_TITLE_SIZE);
						}
						else
						{
							strlcpy(szFileTitle, ptr+1, FILE_TITLE_SIZE);
						}
					}
					
					// At this point, we are about to read a data file
					// from the list of previous ones
					// If there is current data of the same type
					// and the bTags and bTabFile flags are set
					// then we want to save the current data in a data tab
					if(bTabs && bTabFile)
					{
						// If have current phase data
						if(bDataType==PHASE_DATA && bPhaseData)
						{
							CreateTab();
						}

						// If have current freq data
						if(bDataType==FREQ_DATA && bFreqData)
						{
							CreateTab();
						}
					}
						
					// Read data file
					if(ReadDataFile(&nCols, &nTagCol, &nDatCol))
					{
							// Eliminate all sigma plot lines
						for(i=0; i<SLINE_NUMLINES; i++)
						{
							sSLine[i].nLineType=SLINE_NONE;
						}

						if(bDataType==PHASE_DATA)
						{
							// Put info into log file
							WriteLog(3, szFile);

							// Eliminate all phase plot lines
							for(i=0; i<PLINE_NUMLINES; i++)
							{
								sPLine[i].nLineType=PLINE_NONE;
							}
							bPhaseRedraw=TRUE;
						}

						if(bDataType==FREQ_DATA)
						{
							// Put info into log file
							WriteLog(4, szFile);

							// Eliminate all freq plot lines
							for(i=0; i<FLINE_NUMLINES; i++)
							{
								sFLine[i].nLineType=FLINE_NONE;
							}
							bFreqRedraw=TRUE;
						}

						// Force new PSD plot scale
						sPSPlot.y_tic=0;

						// Update status bar
						UpdateStatusBar(hwnd, NEW_DATA);

						// Refresh Tabs menu
						SetTabMenu();

						// Clear synch flag
						bSynch=FALSE;

						// Added 09/30/12
						// Refresh status plots
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

						if(bShowFileOpened)
						{
							// Display file opened info
							InvokeDialogBox(hInst, "OpenedBox", hwnd,
								(DLGPROC)OpenedDlgProc);
						}
					}
				}
				break;

				// Send # data columns to Multicolumn dlg box
				// in response to this message from that dlg box
				case IDM_MCOL_NCOL:
				{
					// Set # data columns in Multicolumn dlg box = 6
					// Note: Review for Win 32
					// Args are:	HWND	hWnd	Window to get message
					//								Taken from LOWORD of
					//								incoming message lParam
					//              WORD	wMsg	Message
					//				WORD	wParam	Command ID
					//				DWORD	lParam  LOWORD=nCols
					//								HiWORD=not used
					// nCols is determined by call to FileInfo() before this
					SendMessage((HWND)LOWORD(lParam), WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_MCOL_SETNCOL, nCols, 0));

					// Set text field in Multicolumn dlg box
					SetWindowText(GetDlgItem((HWND)LOWORD(lParam),
						IDC_MCOL_TEXT), szText);
				}
				break;

				// Receive timetag column # message
				// This message is sent by Multicolumn dlg box when it is
				// closed by its OK button
				// Note: Col #s start at 1; 0 denotes inactive col
				case IDM_MCOL_TAG:
				{
					nTagCol=LOWORD(lParam);
				}
				break;

				// Receive data column # message
				// This message is sent by Multicolumn dlg box when it is
				// closed by its OK button
				// Note: Col #s start at 1; 0 denotes inactive col
				case IDM_MCOL_DAT:
				{
					nDatCol=LOWORD(lParam);
				}
				break;

				case IDM_MAIN_SAVE:
				{
					// Write prompt message
					WritePromptMessage(TB_SAVE);

					// Set open dialog box title
					strlcpy(szTitleString, "Save Data File", DLG_TITLE_SIZE);

					if(bDataType==FREQ_DATA)
					{
						strlcpy(szFile, szFreqFile, FILE_NAME_SIZE);
						SetWindowText(hwndFreqFilename, szFileTitle);
					}
					else // Phase data
					{
						strlcpy(szFile, szPhaseFile, FILE_NAME_SIZE);
						SetWindowText(hwndPhaseFilename, szFileTitle);
					}

					// Note: Custom Save dialog box can be disbaled
					// by making 1st argument in next 2 calls FALSE
					// Works with old-style CustomSaveBox
					// Needs new template, etc. for Explorer-style box
					
					// Initialize OPENFILENAME structure
					FileInitialize(TRUE, FALSE, hwnd, hInst, szTitleString,
						0);

					// Invoke File Save Dialog
					if(FileSaveDlg(TRUE, hwnd, szFile, szFileTitle))
					{
						// Note: DataWrite handles 1 or 2 columns
						DataWrite(szFile);

						// Clear data changed flag
						if(bDataType==FREQ_DATA)
						{
							// Put info into log file
							WriteLog(7, szFile);
								
							// Reset data changed flag
							bFreqDataChanged=FALSE;
							bFreqDataUnsaved=FALSE;

							// Update filenames
							strlcpy(szFreqFile, szFile, FILE_NAME_SIZE);
							strlcpy(szFreqFileTitle, szFileTitle,
								FILE_TITLE_SIZE);
						}
						else // Phase data
						{
							// Put info into log file
							WriteLog(6, szFile);
								
							// Reset data changed flag
							bPhaseDataChanged=FALSE;
							bPhaseDataUnsaved=FALSE;

							// Update filenames
							strlcpy(szPhaseFile, szFile, FILE_NAME_SIZE);
							strlcpy(szPhaseFileTitle, szFileTitle,
								FILE_TITLE_SIZE);
						}
					}
					else // Error
					{
						#ifndef LITE_VER
						// Display error message
						if(CommonDialogError(szBuffer))
						// 0 means that user simply canceled Save - not error
						{
							MessageBox(hwndMain, szBuffer,
								"File Save Error",	MB_ICONEXCLAMATION);
						}
						#endif
					}
					break;
				}

				#ifndef LITE_VER
				case IDM_ADD:
				{
					// Set flag
					bAdd=TRUE;

					// Write prompt message
					WritePromptMessage(TB_ADD);

					// Set open dialog box title
					strlcpy(szTitleString, "Append Data File", DLG_TITLE_SIZE);

					// Note: Custom Open dialog box can be disbaled
					// by making 1st argument in next 2 calls FALSE
					// Works with old-style CustomOpenBox
					// Needs new template, etc. for Explorer-style box
					
					// Initialize OPENFILENAME structure
					FileInitialize(TRUE, TRUE, hwnd, hInst, szTitleString, 0);

					// Invoke File Open Dialog
					// Notes:	(1) Keep the original filename
					//          (2) Allow multicolumn data
					//			(3) Tau remains same

					// Function returns TRUE if valid result
					if(FileOpenDlg(TRUE, hwnd, szFile, szFileTitle))
					{
						// Get current # data points
						if(bDataType==FREQ_DATA)
						{
							nNum=(int)fFreqData[0];
						}
						else // Phase data
						{
							nNum=(int)fPhaseData[0];
						}

						// Get # data points, # data columns & 1st line
						// nDataFileSize=# additional data points
						nDataFileSize=FileInfo(szFile, &nCols, &nRejects, &nComments, szText);

						// Check for oversize data after add
						if(nNum+nDataFileSize>nMaxSize)
						{
							#if(0) // Tone down message and allow add operation to procees
							LoadString(hInst, IDS_MESSAGE_TOOBIG, szBuffer,
								BUFFER_SIZE);
							MessageBox(hwndMain, szBuffer, "Notice",
								MB_ICONEXCLAMATION);
							break;
							#endif

							// Warning message
							i=MessageBox(hwndMain,
								"Data size will exceed limit after data is added.",
								"Notice",
								MB_ICONEXCLAMATION || MB_OKCANCEL);

							// Bail out if cancel
							if(i==IDCANCEL)
							{
								break;
							}
						}

						// Insert a \n into the string at the 41th char
						// Fill in the end of the string with spaces
						for(i=strlen(szText); i<BUFFER_SIZE+1; i++)
						{
							szText[i]=' ';
						}
						// Move up the last 40 characters
						for(i=79; i>=40; i--)
						{
							szText[i+1]=szText[i];
						}
						// Set the 41th character to a newline
						szText[40]='\n';
						// Set the 81th character to a EOS
						szText[81]='\0';
						
						// Use multicolumn dialog box
						if(nCols>1)
						{
							if(nCols<9) // Use radio button column selection
							{
								InvokeDialogBox(hInst, "MulticolumnBox", hwnd,
									(DLGPROC)MulticolumnDlgProc);
							}
							else // >8 cols - use numeric column selection
							{
								InvokeDialogBox(hInst, "MultiBox", hwnd,
									(DLGPROC)MultiDlgProc);
							}

							if(bDataType==FREQ_DATA)
							{
								bFreqTimetags=TRUE;
							}
							else
							{
								bPhaseTimetags=TRUE;
							}
						}
						else
						{
							nTagCol=0;
							nDatCol=1;
						}

						// Reallocate memory
						if(bDataType==FREQ_DATA)
						{
							// Realloc freq data
							// nNum=# original data points
							// nDataFileSize=# additional data points
							if((fNew=(F_TYPE*)realloc(fFreqData,
								(nNum+nDataFileSize+ARRAY_OFFSET+EXTRA_MEM)
								*sizeof(F_TYPE)))==NULL)
							{
								AllocErrorMessage();
								break;
							}
							else
							{
								fFreqData=fNew;
							}
							fData=fFreqData;

							if(nCols>1)
							{
								// Realloc freq timetags
								if((fNew=
									(F_TYPE*)realloc(fFreqTimetags,
									(nNum+nDataFileSize+ARRAY_OFFSET+EXTRA_MEM)
									*sizeof(F_TYPE)))==NULL)
								{
									AllocErrorMessage();
									break;
								}
								else
								{
									fFreqTimetags=fNew;
								}
								fTags=fFreqTimetags;
							}
						}
						else // Phase
						{
							// Realloc phase data
							// nNum=# original data points
							// nDataFileSize=# additional data points
							if((fNew=(F_TYPE*)realloc(fPhaseData,
								(nNum+nDataFileSize+ARRAY_OFFSET+EXTRA_MEM)
								*sizeof(F_TYPE)))==NULL)
							{
								AllocErrorMessage();
								break;
							}
							else
							{
								fPhaseData=fNew;
							}
							fData=fPhaseData;

							if(nCols>1)
							{
								// Realloc phase timetags
								if((fNew=
									(F_TYPE*)realloc(fPhaseTimetags,
									(nNum+nDataFileSize+ARRAY_OFFSET+EXTRA_MEM)
									*sizeof(F_TYPE)))==NULL)
								{
									AllocErrorMessage();
									break;
								}
								else
								{
									fPhaseTimetags=fNew;
								}
								fTags=fPhaseTimetags;
							}
						}

						// Activate data-dependent functions
						ActivateFunctions(MF_ENABLED);

						// Add uses new MulticolumnDataAdd() function
						nRealNum=MulticolumnDataAdd(szFile, nTagCol, nDatCol,
							nNum, nDataFileSize);

						// nRealNum may be < nNum+nDataFileSize if some input
						// data file lines were invalid.  This leaves extra
						// mem allocated, which should be no problem.

						// Update status display
						if(bDataType==FREQ_DATA)
						{
							// Put info into log file
							WriteLog(9, szFile);
								
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
								nRealNum);
							SetWindowText(hwndFreqNum, szBuffer);
							SetWindowText(hwndFreqEnd, szBuffer);
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
							SetWindowText(hwndFreqStart, szBuffer);

							// Update analysis limit # display
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
								(int)(fFreqData[2]-fFreqData[1]+1));
							SetWindowText(hwndFreqLim, szBuffer);

							// Set flags
							bFreqData=TRUE;
							bFreqDataChanged=TRUE;
							bFreqDataUnsaved=TRUE;
							sFPlot.new_file=TRUE;
							bFreqScaleChanged=TRUE;
							bFreqRedraw=TRUE;
							bSynch=FALSE;

							// Force new PSD plot scale
							sPSPlot.y_tic=0;

							// Increment filename
							if(bIncExtension)
							{
								IncExtension(szFile, FREQ_DATA);
								IncExtension(szFileTitle, FREQ_DATA);
								IncExtension(szFreqFile, FREQ_DATA);
								IncExtension(szFreqFileTitle, FREQ_DATA);
								SetWindowText(hwndFreqFilename, szFileTitle);
							}
						}
						else // Phase data
						{
							// Put info into log file
							WriteLog(8, szFile);
								
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d",
								nRealNum);
							SetWindowText(hwndPhaseNum, szBuffer);
							SetWindowText(hwndPhaseEnd, szBuffer);
							_snprintf(szBuffer, sizeof(szBuffer), "%5.0d", 1);
							SetWindowText(hwndPhaseStart, szBuffer);

							// Update analysis limit display
							DisplayLims();

							// Set flags
							bPhaseData=TRUE;
							bPhaseDataChanged=TRUE;
							bPhaseDataUnsaved=TRUE;
							bPhaseScaleChanged=TRUE;
							bPhaseRedraw=TRUE;
							bSynch=FALSE;

							// Force new PSD plot scale
							sPSPlot.y_tic=0;

							// Increment filename
							if(bIncExtension)
							{
								IncExtension(szFile, PHASE_DATA);
								IncExtension(szFileTitle, PHASE_DATA);
								IncExtension(szPhaseFile, PHASE_DATA);
								IncExtension(szPhaseFileTitle, PHASE_DATA);
								SetWindowText(hwndPhaseFilename, szFileTitle);
							}
						}

						// Update status bar
						UpdateStatusBar(hwnd, NEW_DATA);

						// Clear plot lines
						ClearLines();

						if(bShowFileOpened)
						{
							// Display file opened info
							InvokeDialogBox(hInst, "OpenedBox", hwnd,
								(DLGPROC)OpenedDlgProc);
						}
					}
					else // Error
					{
						// Display error message
						if(CommonDialogError(szBuffer))
						// 0 means that user simply canceled Add - not error
						{
							MessageBox(hwndMain, szBuffer,
								"File Add Error",	MB_ICONEXCLAMATION);
						}
					}

					// Reset flag
					bAdd=FALSE;

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_READ:
				{
					// Write prompt message
					WritePromptMessage(TB_READ);

					// Open dialog box
					InvokeDialogBox(hInst, "ReadBox", hwnd,
						(DLGPROC)ReadDlgProc);

					break;
				}
				#endif

				case IDM_MAIN_EXIT:
				{
					// Turn IDM_EXIT into WM_DESTROY msg
					PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
					break;
				}

				case IDM_CLEAR:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "ClearBox", hwnd,
						(DLGPROC)ClearDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_STAT:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "StatsBox", hwnd,
						(DLGPROC)StatsDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_SIGMA:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					if(bSigmaDetails)
					{
						// Open dialog box
						InvokeDialogBox(hInst, "DetailedSigmaBox", hwnd,
							(DLGPROC)SigmaDlgProc);
					}
					else
					{
						// Open dialog box
						InvokeDialogBox(hInst, "SigmaBox", hwnd,
							(DLGPROC)SigmaDlgProc);
					}

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#if(1) // New code 07/17/08
				case IDM_FILTER:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "FilterBox", hwnd,
						(DLGPROC)FilterDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_FILL:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "FillBox", hwnd,
						(DLGPROC)FillDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				case IDM_NORM:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "NormBox", hwnd,
						(DLGPROC)NormDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_AVG:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "AvgBox", hwnd,
						(DLGPROC)AvgDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_STEP:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "StepBox", hwnd,
						(DLGPROC)StepDlgProc);

					break;
				}

				case IDM_CONV:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "ConvBox", hwnd,
						(DLGPROC)ConvertDlgProc);

					// Status plot of converted data updated in ConvertData()
					// Now update both status bar plots using bitmaps
					// to get color of converted from data right

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_SCALE:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "ScaleBox", hwnd,
						(DLGPROC)ScaleDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_CHECK:
				{
					if(bCheckDetails)
					{
						// Open dialog box
						InvokeDialogBox(hInst, "DetailedCheckBox", hwnd,
							(DLGPROC)CheckDlgProc);
					}
					else
					{
					// Open dialog box
					InvokeDialogBox(hInst, "CheckBox", hwnd,
						(DLGPROC)CheckDlgProc);
					}

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));
					break;
				}

				#ifndef LITE_VER
				case IDM_FILENAMES:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "FileBox", hwnd,
						(DLGPROC)FileDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_AUDIO:
				{
					// Write and play wave file for selected phase or freq data
					// Compose wave filename
					strlcpy(szWaveFilename, szPath, FILE_NAME_SIZE);
					strlcat(szWaveFilename, "Stable32.wav", FILE_NAME_SIZE);
					
					// Write wave file
					WaveWrite(szWaveFilename);

					// Wait for file to be written to disk
					Sleep(1000);

					// Play WAV file
					// If szAudioPlayer is blank, use default audio player
					// If szAudioplayer is "None",
					// just play sound w/o audio player
					// Otherwise, use szAudioPlayer to play sound 
					// Use default audio player if
					// szAudioPlayer is empty string
					if((strlen(szAudioPlayer)==0))
					{
						// Execute application associated with .wav extension
						ShellExecute(hwndMain, "open", szWaveFilename,
							NULL, szPath, SW_SHOWNORMAL);
					}
					else if((strcmp(szAudioPlayer, "None"))==0)
					{
						PlaySound(szWaveFilename, 0,
							SND_ASYNC || SND_FILENAME);
					}
					else // Use audio player named by szAudioPlayer
					{
						// Recompose wave filename with quotes
						strlcpy(szWaveFilename, "\"", FILE_NAME_SIZE);
						strlcat(szWaveFilename, szPath, FILE_NAME_SIZE);
						strlcat(szWaveFilename, "Stable32.wav\"",
							FILE_NAME_SIZE);

						// szAudioPlayer is full path/filename
						// Enclose it in double quotes
						strlcpy(szBuffer, "\"", sizeof(szBuffer));
						strlcat(szBuffer, szAudioPlayer, sizeof(szBuffer));
						strlcat(szBuffer, "\" ", sizeof(szBuffer));

						// Append wave filename
						strlcat(szBuffer, szWaveFilename, FILE_NAME_SIZE);

						// Launch specified audio player to play wave file
						WinExec(szBuffer, SW_SHOWNORMAL);
					}

					// Done
					break;
				}
				#endif

				case IDM_DRIFT:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					if(bDriftDetails)
					{
						// Open dialog box
						InvokeDialogBox(hInst, "DetailedDriftBox", hwnd,
							(DLGPROC)DriftDlgProc);
					}
					else
					{
						// Open dialog box
						InvokeDialogBox(hInst, "DriftBox", hwnd,
							(DLGPROC)DriftDlgProc);
					}

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_MAIN_ABOUT:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "StableAboutBox", hwnd,
						(DLGPROC)AboutDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				// Display beta test message
				case IDM_MAIN_BETA:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "StableBetaBox", hwnd,
						(DLGPROC)AboutDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				// Display demo version message
				case IDM_MAIN_DEMO:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "StableDemoBox", hwnd,
						(DLGPROC)AboutDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				// Display special version message
				case IDM_MAIN_SPECIAL:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "StableSpecialBox", hwnd,
						(DLGPROC)AboutDlgProc);
				
					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				// Display welcome message
				case IDM_MAIN_WELCOME:
				{
					// Open modeless dialog box
					hDlgModeless=CreateDialog(hInst, "StableWelcomeBox", hwnd,
						(DLGPROC)WelcomeDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				// Display standard startup message
				case IDM_MAIN_START:
				{
					UpdateStatusBar(hwndMain, NEW_DATA);
					#ifndef LITE_VER
					LoadString(hInst, IDS_MESSAGE_START, szBuffer,
						BUFFER_SIZE);
					#endif
					#ifdef LITE_VER
					LoadString(hInst, IDS_MESSAGE_LITE, szBuffer,
						BUFFER_SIZE);
					#endif
					WriteMessage(szBuffer);
					WriteDateMessage();
					break;
				}

				#ifndef LITE_VER
				// Autoread archive file 
				case IDC_AUTOREAD_ARCHIVE:
				{
					// Assign archive filename
					
					// Read archive file
					InvokeDialogBox(hInst, "ArchiveBox", hwnd,
						(DLGPROC)ArchiveDlgProc);
					break;
				}
				#endif				

				#ifndef LITE_VER
				case IDM_NOISE:
				{
					// Reset noise generated flag
					bNoiseGenerated=FALSE;
					
					// Open dialog box
					InvokeDialogBox(hInst, "NoiseBox", hwnd,
						(DLGPROC)NoiseDlgProc);

					if(bNoiseGenerated) // Test added 09/01/98
					{
						// Convert phase noise to frequency noise
						ConvertData(PHASE_TO_FREQ, FALSE, FALSE, FALSE,
							FALSE, FTAG_FIRST);

						// Set redraw flags to show generated noise
						bPhaseRedraw=TRUE;
						bFreqRedraw=TRUE;

						// Update status bar
						UpdateStatusBar(hwndMain, NEW_DATA);
					}
					
					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_CAL:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "CalendarBox", hwnd,
						(DLGPROC)CalendarDlgProc);

					// Put info into log file
					WriteLog(50, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_VIBRA:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "VibraBox", hwnd,
						(DLGPROC)VibraDlgProc);

					// Put info into log file
					WriteLog(77, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_PLAY:
				{
					WinExec(szPlayFile, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(54, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_5110COMM:
				{
					// Launch 5110Comm 	
					WinExec(sz5110CommFile, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(62, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_INIEDIT:
				{
					// Prepare command string
					strlcpy(szBuffer, szNotepad, sizeof(szBuffer));
					strlcat(szBuffer, " ", sizeof(szBuffer));
					strlcat(szBuffer, szPath, sizeof(szBuffer));
					strlcat(szBuffer, "Stable32.ini", sizeof(szBuffer));

					// Invoke Notepad to examine ini file
					WinExec(szBuffer, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(65, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_NOTEPAD:
				{
					// Prepare command string
					strlcpy(szBuffer, szNotepad, sizeof(szBuffer));
					strlcat(szBuffer, " ", sizeof(szBuffer));
					strlcat(szBuffer, szFile, sizeof(szBuffer));

					// Invoke Notepad to examine data file
					WinExec(szBuffer, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(55, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_LOG:
				{
					// Prepare command string
					strlcpy(szBuffer, szNotepad, sizeof(szBuffer));
					strlcat(szBuffer, " ", sizeof(szBuffer));
					strlcat(szBuffer, szPath, sizeof(szBuffer));
					strlcat(szBuffer, "Stable32.log", sizeof(szBuffer));

					// Invoke Notepad to open log file
					WinExec(szBuffer, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(66, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				case IDM_WEB:
				{
					// Code suggested by:
					// W. DePalo: depalow@compuserve.com
					ShellExecute(hwndMain, "open", szURL, NULL, NULL,
						SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(57, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_FEEDBACK:
				{
					ShellExecute(hwndMain, "open", szEMail, NULL,
						NULL, SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(58, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#ifdef LITE_VER
				case IDM_DATUM:
				{
					// Access Datum web site
					ShellExecute(hwndMain, "open",
						"http://www.datum.com", NULL, NULL,
						SW_SHOWNORMAL);

					// Put info into log file
					WriteLog(59, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif
				
				case IDM_MAIN_EDIT:
				{
					// Don't allow bWideEdit if timetag data doesn't exist
					// The data type may have been switched or
					// it may have been erased since last use of wide Edit box
					if(bDataType==FREQ_DATA)
					{
						if(!bFreqTimetags)
						{
							bWideEdit=FALSE;
						}
					}
					else
					{
						if(!bPhaseTimetags)
						{
							bWideEdit=FALSE;
						}
					}

					if(bWideEdit)
					{
						// Open dialog box
						InvokeDialogBox(hInst, "WideEditBox", hwnd,
							(DLGPROC)EditDlgProc);
					}
					else
					{
						// Open dialog box
						InvokeDialogBox(hInst, "EditBox", hwnd,
							(DLGPROC)EditDlgProc);
					}

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#ifndef LITE_VER
				case IDM_TIMETAG:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "TimetagBox", hwnd,
						(DLGPROC)TimetagDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_CORN:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "CornBox", hwnd,
						(DLGPROC)CornDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_REGULARIZE:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "RegularizeBox", hwnd,
						(DLGPROC)RegularizeDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_DOMAIN:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "DomainBox", hwnd,
						(DLGPROC)DomainDlgProc);

					// Put info into log file
					WriteLog(51, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				case IDM_INPUTS:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "InputsBox", hwnd,
						(DLGPROC)InputsDlgProc);

					// Put info into log file
					WriteLog(69, "");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_PHASE_PLOT:
				{
					if(bDataType!=PHASE_DATA)
					{
						Button_SetCheck(GetDlgItem(hwndMain, IDC_FREQSELECT),
							FALSE);
						Button_SetCheck(GetDlgItem(hwndMain, IDC_PHASESELECT),
							TRUE);
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));
					}

					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Check for too small plot range
					CalcMean(fData, &fAvg, PHASE_DATA);
					if( (fAvg) && ((fabs((fMax-fMin)/fAvg))<1e-3) )
					{
						// Must normalize plot data
						MustNormalizeMessage();

						#if(1) // Trail code 07/14/10
						// The usual user response to the must normalize message
						// is to open the normalize dialog
						// so why not do it automatically?
						// One can always cancel it (and the plot)

						// Set normalize phase plot flag
						bNormPhasePlot=TRUE;

						// Open dialog box
						InvokeDialogBox(hInst, "NormBox", hwnd,
							(DLGPROC)NormDlgProc);

						// Refresh status plots
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));
						#endif

						break;
					}

					// Set plot type
					nPlotType=PHASE_PLOT;

					#ifdef GPC_IN
					// Open dialog box
					InvokeDialogBox(hInst, "PlotBox", hwnd,
						(DLGPROC)PlotDlgProc);
					#endif

					// Save configuration info in INI file
					WriteIni(INI_PHASE);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_FREQ_PLOT:
				{
					if(bDataType!=FREQ_DATA)
					{
						Button_SetCheck(GetDlgItem(hwndMain, IDC_FREQSELECT),
							TRUE);
						Button_SetCheck(GetDlgItem(hwndMain, IDC_PHASESELECT),
							FALSE);
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));
					}

					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Check for too small plot range
					CalcMean(fData, &fAvg, FREQ_DATA);
					if( (fAvg) && ((fabs((fMax-fMin)/fAvg))<1e-3) )
					{
						// Must normalize plot data
						MustNormalizeMessage();

						#if(1) // Trail code 07/14/10
						// The usual response to the must normalize message
						// is to open the normalize dialog
						// so why not do it automatically?
						// One can always cancel it (and the plot)

						// Set normalize freq plot flag
						bNormFreqPlot=TRUE;

						// Open dialog box
						InvokeDialogBox(hInst, "NormBox", hwnd,
							(DLGPROC)NormDlgProc);

						// Refresh status plots
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));
						#endif

						break;
					}

					// Set plot type
					nPlotType=FREQ_PLOT;

					#ifdef GPC_IN
					// Open dialog box
					InvokeDialogBox(hInst, "PlotBox", hwnd,
						(DLGPROC)PlotDlgProc);
					#endif

					// Save configuration info in INI file
					WriteIni(INI_FREQ);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_RUN:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "RunBox", hwnd,
						(DLGPROC)RunDlgProc);

					// Save configuration info in INI file
					WriteIni(INI_SIGMA);


					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_DAVAR:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Open dialog box
					InvokeDialogBox(hInst, "DAVARPlotBox", hwnd,
						(DLGPROC)DynamicStabilityDlgProc);

					// Save configuration info in INI file
					WriteIni(INI_DAVAR);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#ifndef LITE_VER
				case IDM_MAIN_PRINT:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "PrintBox", hwnd,
						(DLGPROC)PrintDataDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				case IDM_PART:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "PartBox", hwnd,
						(DLGPROC)PartDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_INSERT:
				{
					// Open dialog box
					InvokeDialogBox(hInst, "PlotInsertBox", hwnd,
						(DLGPROC)PlotInsertDlgProc);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#ifndef LITE_VER
				case IDM_CONFIG:
				{
					// Open Configure property sheet
					DisplayProperties(hwnd);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				// Respond to Help Index menu item, Help toolbutton, or F1 key
				case IDM_HELP:
				{
					// Invoke help file
					// This opens the Stable32 HTML help file to its
					// table of contents
					#if(0) // Obsolete
					HtmlHelp(hwnd, "Stable32.chm", HH_DISPLAY_TOPIC, 0L);
					#endif

					#if(1) // New code 11/29/11
					HtmlHelp(hwnd, szHelpFile, HH_DISPLAY_TOPIC, 0L);
					#endif

					// Put info into log file
					WriteLog(56, "CONTENTS");

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDM_USINGHELP:
				{
					// Invoke help file
					// This opens a Microsoft HTML help file that provides
					// help on help based on MS Viewhlp.chm
					HtmlHelp(hwnd, "HonH.chm", HH_DISPLAY_TOPIC, 0L);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				#ifndef LITE_VER
				case IDM_POWER:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Set plot type
					nPlotType=SPECT_PLOT;

					// Open dialog box
					InvokeDialogBox(hInst, "SpectrumPlotBox", hwnd,
						(DLGPROC)SpectrumPlotDlgProc);


					// Save configuration info in INI file
					WriteIni(INI_SPECT);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_HIST:
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Set plot type
					nPlotType=HISTO_PLOT;

					// Open dialog box
					InvokeDialogBox(hInst, "HistoPlotBox", hwnd,
						(DLGPROC)HistoPlotDlgProc);

					// Save configuration info in INI file
					WriteIni(INI_HISTO);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				#ifndef LITE_VER
				case IDM_AUTO: // Autocorrelation Plot
				{
					// Make sure analysis limits are current ones
					if(bDataType==FREQ_DATA)
					{
						// Get freq start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQSTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQSTART, 0,
								EN_KILLFOCUS));
						}

						// Get freq end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_FREQEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fFreqData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_FREQEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to freq data
						fData=fFreqData;
					}
					else // Phase data
					{
						// Get phase start value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASESTART),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[1])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASESTART, 0,
								EN_KILLFOCUS));
						}

						// Get phase end value from edit control
						GetWindowText(GetDlgItem(hwnd, IDC_PHASEEND),
							szBuffer, BUFFER_SIZE);
						nEntry=(int)abs(atoi(szBuffer));

						// Check if it has changed
						if(nEntry!=(int)fPhaseData[2])
						{
							// Update value
							bErrorTrap=FALSE;
							SendMessage(hwndMain, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDC_PHASEEND, 0,
								EN_KILLFOCUS));
						}

						// Set general data pointer to phase data
						fData=fPhaseData;
					}

					// Check for enough analysis points - need at least 4
					if(fData[2]-fData[1]<3)
					{
						TooFewMessage();
						break;
					}

					// Check for zero range
					FindMinMax(fData, &fMin, &fMax, bDataType);
					if(fMax==fMin)
					{
						ZeroRangeMessage();
						break;
					}

					// Set plot type
					nPlotType=AUTO_PLOT;

					// Open dialog box
					InvokeDialogBox(hInst, "AutocorrelationPlotBox", hwnd,
						(DLGPROC)AutocorrelationPlotDlgProc);

					// Save configuration info in INI file
					WriteIni(INI_AUTO);

					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}
				#endif

				// Open database dialog box
				#ifndef LITE_VER
				#ifndef STUDENT_VER
				case IDM_SQL:
				{
					// Open dialog box
					// Note: Delay if can't make connection
					InvokeDialogBox(hInst, "SQLBox", hwnd,
						(DLGPROC)SQLDlgProc);
					break;
				}
				#endif
				#endif
				
				// Execute automatic procession script #1
				#ifndef LITE_VER
				#ifndef STUDENT_VER
				case IDM_AUTO1:
				{
					// Set script #
					nAuto=1;
					
					// Open dialog box
					InvokeDialogBox(hInst, "AutoBox", hwnd,
						(DLGPROC)AutoDlgProc);

					break;
				}
				#endif
				#endif
				
				// Execute automatic procession script #2
				#ifndef LITE_VER
				#ifndef STUDENT_VER
				case IDM_AUTO2:
				{
					// Set script #
					nAuto=2;

					// Open dialog box
					InvokeDialogBox(hInst, "AutoBox", hwnd,
						(DLGPROC)AutoDlgProc);

					break;
				}
				#endif
				#endif

				// Execute automatic procession script #3
				#ifndef LITE_VER
				#ifndef STUDENT_VER
				case IDM_AUTO3:
				{
					// Set script #
					nAuto=3;

					// Open dialog box
					InvokeDialogBox(hInst, "AutoBox", hwnd,
						(DLGPROC)AutoDlgProc);

					break;
				}
				#endif
				#endif

				case IDM_TABS_SHOW: // Toggle show tabs
				{
					// Set tab menu items
					if(bTabs)
					{
						// Turn tabs off
						bTabs=FALSE;
						CheckMenuItem(hMenu, IDM_TABS_SHOW,
							MF_BYCOMMAND | MF_UNCHECKED);
					}
					else // Tabs off
					{
						// Turn tabs on
						bTabs=TRUE;
						CheckMenuItem(hMenu, IDM_TABS_SHOW,
							MF_BYCOMMAND | MF_CHECKED);
					}

					// Update tab control
					UpdateTabControl();

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_FILE: // Toggle create tab when file read
				{
					if(bTabFile)
					{
						bTabFile=FALSE;
						CheckMenuItem(hMenu, IDM_TABS_FILE,
							MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bTabFile=TRUE;
						CheckMenuItem(hMenu, IDM_TABS_FILE,
							MF_BYCOMMAND | MF_CHECKED);
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_CHANGE: // Toggle create tab when file changes
				{
					if(bTabChange)
					{
						bTabChange=FALSE;
						CheckMenuItem(hMenu, IDM_TABS_CHANGE,
							MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bTabChange=TRUE;
						CheckMenuItem(hMenu, IDM_TABS_CHANGE,
							MF_BYCOMMAND | MF_CHECKED);
					}

					SetTabMenu();
					break;
				}

				case IDM_TABS_EDIT: // Toggle create tab when data edited
				{
					if(bTabEdit)
					{
						bTabEdit=FALSE;
						CheckMenuItem(hMenu, IDM_TABS_EDIT,
							MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bTabEdit=TRUE;
						CheckMenuItem(hMenu, IDM_TABS_EDIT,
							MF_BYCOMMAND | MF_CHECKED);
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_NOISE: // Toggle create tab when noise generated
				{
					if(bTabNoise)
					{
						bTabNoise=FALSE;
						CheckMenuItem(hMenu, IDM_TABS_NOISE,
							MF_BYCOMMAND | MF_UNCHECKED);
					}
					else
					{
						bTabNoise=TRUE;
						CheckMenuItem(hMenu, IDM_TABS_NOISE,
							MF_BYCOMMAND | MF_CHECKED);
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_CLEAR: // Clear selected tab
				{
					// Clear selected tab
					TabCtrl_DeleteItem(hwndTab, nTab);

					// Remove cleared tab from list
					// Shift down tab info above removed tab
					if(bDataType==PHASE_DATA)
					{
						// Free allocated memory of closed tab
						// Do this here while its data pointers
						// are still easy to find
						free(sPTab[nTab].fData);
						sPTab[nTab].fData=NULL;

						if(sPTab[nTab].bTags)
						{
							free(sPTab[nTab].fTags);
							sPTab[nTab].fTags=NULL;
						}

						// Decrement # tabs
						nNumPhaseTabs--;

						// Shift tab data downward
						for(i=nTab; i<nNumPhaseTabs; i++)
						{
							// Shift title string
							strlcpy(sPTab[i].szTitle, sPTab[i+1].szTitle,
								FILE_TITLE_SIZE);

							// Shift tau value
							sPTab[i].fTau=sPTab[i+1].fTau;

							// Shift data pointer
							sPTab[i].fData=sPTab[i+1].fData;

							// Shift timetag pointer
							sPTab[i].fTags=sPTab[i+1].fTags;
						}
					}
					else // Freq data
					{
						// Free allocated memory of closed tab
						// Do this here while its data pointers
						// are still easy to find
						free(sFTab[nTab].fData);
						sFTab[nTab].fData=NULL;

						if(sFTab[nTab].bTags)
						{
							free(sFTab[nTab].fTags);
							sFTab[nTab].fTags=NULL;
						}

						// Decrement # tabs
						nNumFreqTabs--;

						// Shift tab data downward
						for(i=nTab; i<nNumFreqTabs; i++)
						{
							// Shift title string
							strlcpy(sFTab[i].szTitle, sFTab[i+1].szTitle,
								FILE_TITLE_SIZE);

							// Shift tau value
							sFTab[i].fTau=sFTab[i+1].fTau;

							// Shift data pointer
							sFTab[i].fData=sFTab[i+1].fData;

							// Shift timetag pointer
							sFTab[i].fTags=sFTab[i+1].fTags;
						}
					}

					// Select new 1st tab
					TabCtrl_SetCurSel(hwndTab, 0);
					nTab=0;

					// If only one tab, deselect it so it can be accessed
					// by clicking on it
					// Use of the -1 argument is not documented, 
					// but seems to work OK to deselect all tabs
					if(bDataType==PHASE_DATA)
					{
						if(nNumPhaseTabs==1)
						{
							TabCtrl_SetCurSel(hwndTab, -1);
						}
					}
					else // Freq data
					{
						if(nNumFreqTabs==1)
						{
							TabCtrl_SetCurSel(hwndTab, -1);
						}
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_CLEARALL: // Clear all tabs
				{
					// Clear all tabs of current data type
					TabCtrl_DeleteAllItems(hwndTab);
					nTab=0;

					if(bDataType==PHASE_DATA)
					{

						// Free allocated phase memory
						for(i=0; i<nNumPhaseTabs; i++)
						{
							free(sPTab[i].fData);
							sPTab[i].fData=NULL;

							if(sPTab[i].bTags)
							{
								free(sPTab[i].fTags);
								sPTab[i].fTags=NULL;
							}
						}

						// Zero # phase tabs
						nNumPhaseTabs=0;
					}
					else // Freq data
					{

						// Free allocated freq memory
						for(i=0; i<nNumFreqTabs; i++)
						{
							free(sFTab[i].fData);
							sFTab[i].fData=NULL;

							if(sFTab[i].bTags)
							{
								free(sFTab[i].fTags);
								sFTab[i].fTags=NULL;
							}
						}

						// Zero # freq tabs
						nNumFreqTabs=0;
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_SAVE: // Save current data
				{
					// Are tabs active?
					if(bTabs)
					{
						// Create new tab
						CreateTab();
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				case IDM_TABS_RENAME: // Rename selected tab
				{
					// Are tabs active?
					if(bTabs)
					{
						// Open Rename Tab dialog box
						InvokeDialogBox(hInst, "RenameTabBox", hwnd,
							(DLGPROC)RenameTabDlgProc);
					}

					// Update Tab menu
					UpdateTabControl();
					SetTabMenu();
					break;
				}

				case IDM_TABS_WRITE: // Write selected tab data to disk
				{
					// Are tabs active?
					if(bTabs)
					{
						if(bDataType==PHASE_DATA)
						{
							// Write phase data to disk
							// in current folder
							// Phase data pointer must be fData
							// Timetag data pointer (if any) must be fTags
							// Set bSaveTimetags to save timetags
							DataWrite(sPTab[nTab].szTitle);

							// Write entry to log file
							strlcpy(szBuffer, szPath, sizeof(szBuffer));
							strlcat(szBuffer, sPTab[nTab].szTitle,
								sizeof(szBuffer));
							WriteLog(74, szBuffer);
						}
						else // Freq data
						{
							// Write freq data to disk
							// in current folder
							// Freq data pointer must be fData
							// Timetag data pointer (if any) must be fTags
							// Set bSaveTimetags to save timetags
							DataWrite(sFTab[nTab].szTitle);

							// Write entry to log file
							strlcpy(szBuffer, szPath, sizeof(szBuffer));
							strlcat(szBuffer, sFTab[nTab].szTitle,
								sizeof(szBuffer));
							WriteLog(75, szBuffer);
						}
					}

					// Update Tab menu
					SetTabMenu();
					break;
				}

				// Shifted Function Keys
				// Open User Manual
				case IDM_SHIFT_F1:
				{
					// Compose Stable32 user manual filename
					// Note: Update as required for new version
					// It is OK for this filename to be hard-coded
					// A new version of the manual, if any, is associated
					// with a new version of the program
					strlcpy(szBuffer, szPath, sizeof(szBuffer));
					strlcat(szBuffer, "Manual154.pdf", sizeof(szBuffer));

					// Execute application associated with .pdf extension
					ShellExecute(hwndMain, "open", szBuffer, NULL, szPath,
						SW_SHOWNORMAL);

					// Done
					break;
				}

				// Open Handbook of Frequency Stability Analysis
				case IDM_SHIFT_F2:
				{
					// Compose Handbook filename
					// It is OK for this filename to be hard-coded
					// because it is always the same
					strlcpy(szBuffer, szPath, sizeof(szBuffer));
					strlcat(szBuffer, "Handbook.pdf", sizeof(szBuffer));

					// Execute application associated with .pdf extension
					ShellExecute(hwndMain, "open", szBuffer, NULL, szPath,
						SW_SHOWNORMAL);

					// Done
					break;
				}

				// Function keys:
				// F1		F2		F3		F4		F5		F6
				// Help		#1		#2		#3		Conv  Edit
				//			|-Previous Files-|		|--Edit--|
				//
				// F7		F8		F9	   F10	   F11	   F12
				// Plot		Stats	Run	  Power	   ACF	Select
				//			|--------Analysis--------|
				//
				// Note: F1 is Help so no menu item
				// Previous Files F2-F4
				// Open Previous File #1
				case IDM_F2:
				{
					// Go to File menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_F, 0, VK_PRESS, 0);
					keybd_event(VK_F, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Open previous file #1
					keybd_event(VK_1, 0, VK_PRESS, 0);
					keybd_event(VK_1, 0, VK_RELEASE, 0);

					// Press OK
					keybd_event(VK_O, 0, VK_PRESS, 0);
					keybd_event(VK_O, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Open Previous File #2
				case IDM_F3:
				{
					// Go to File menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_F, 0, VK_PRESS, 0);
					keybd_event(VK_F, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Open previous file #2
					keybd_event(VK_2, 0, VK_PRESS, 0);
					keybd_event(VK_2, 0, VK_RELEASE, 0);

					// Press OK
					keybd_event(VK_O, 0, VK_PRESS, 0);
					keybd_event(VK_O, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Open Previous File #3
				case IDM_F4:
				{
					// Go to File menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_F, 0, VK_PRESS, 0);
					keybd_event(VK_F, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Open previous file #3
					keybd_event(VK_3, 0, VK_PRESS, 0);
					keybd_event(VK_3, 0, VK_RELEASE, 0);

					// Press OK
					keybd_event(VK_O, 0, VK_PRESS, 0);
					keybd_event(VK_O, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Edit Functions F5-F6
				// Perform phase <-> frequency conversion
				case IDM_F5:
				{
					// Go to Edit menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_E, 0, VK_PRESS, 0);
					keybd_event(VK_E, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select Convert
					keybd_event(VK_C, 0, VK_PRESS, 0);
					keybd_event(VK_C, 0, VK_RELEASE, 0);

					// Press OK
					keybd_event(VK_O, 0, VK_PRESS, 0);
					keybd_event(VK_O, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Open Edit dialog
				case IDM_F6:
				{
					// Go to Edit menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_E, 0, VK_PRESS, 0);
					keybd_event(VK_E, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select Edit
					keybd_event(VK_E, 0, VK_PRESS, 0);
					keybd_event(VK_E, 0, VK_RELEASE, 0);

					// Done
					break;
				}


				// Perform Plot
				// Note: AutoPlot should be on
				case IDM_F7:
				{
					// Go to Plot menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_P, 0, VK_PRESS, 0);
					keybd_event(VK_P, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					if(bDataType==FREQ_DATA)
					{
						// Select Freq
						keybd_event(VK_F, 0, VK_PRESS, 0);
						keybd_event(VK_F, 0, VK_RELEASE, 0);
					}
					else // Phase data
					{
						// Select Phase
						keybd_event(VK_P, 0, VK_PRESS, 0);
						keybd_event(VK_P, 0, VK_RELEASE, 0);
					}

					// Done
					break;
				}

				// Analysis Functions F8-F11
				// Open Stats dialog
				case IDM_F8:
				{
					// Go to Analysis menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_A, 0, VK_PRESS, 0);
					keybd_event(VK_A, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select Stats
					keybd_event(VK_S, 0, VK_PRESS, 0);
					keybd_event(VK_S, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Perform Run
				// Run calc & plot use previous settings
				case IDM_F9:
				{
					// Turn on auto run plot flag
					bAutoRunPlot=TRUE;

					// Go to Analysis menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_A, 0, VK_PRESS, 0);
					keybd_event(VK_A, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select Run
					keybd_event(VK_R, 0, VK_PRESS, 0);
					keybd_event(VK_R, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Open Power dialog
				// PSD calc & plot use previous settings
				case IDM_F10:
				{
					// Turn on auto PSD plot flag
					bAutoPowerPlot=TRUE;

					// Go to Analysis menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_A, 0, VK_PRESS, 0);
					keybd_event(VK_A, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select Power
					keybd_event(VK_P, 0, VK_PRESS, 0);
					keybd_event(VK_P, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Open ACF dialog
				// ACF calc & plot use previous settings
				case IDM_F11:
				{
					// Turn on auto ACF plot flag
					bAutoACFPlot=TRUE;

					// Go to Analysis menu
					keybd_event(VK_MENU, 0, VK_PRESS, 0);	
					keybd_event(VK_A, 0, VK_PRESS, 0);
					keybd_event(VK_A, 0, VK_RELEASE, 0);
					keybd_event(VK_MENU, 0, VK_RELEASE, 0);

					// Select ACF
					keybd_event(VK_A, 0, VK_PRESS, 0);
					keybd_event(VK_A, 0, VK_RELEASE, 0);

					// Done
					break;
				}

				// Switch data type
				case IDM_F12:
				{
					// Select opposite data type
					if(bDataType==FREQ_DATA)
					{
						// Select phase data
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_PHASESELECT, 0, 0));
					}
					else // Phase data
					{
						// Select freq data
						SendMessage(hwndMain, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDC_FREQSELECT, 0, 0));
					}

					// Done
					break;
				}

				// Command line function implementations
				// using keystroke sequences
				// Selected analysis functions are executed
				// in standard order regardless of their
				// order on the command line
				// This case is called for each command
				// The bCmdLine flag insures that IDM_X is called
				// only once during command parsing
				// and the PostMessage() calls to IDM_X
				// execute any additional commands
				// per their infividual bCmd# flags
				
				case IDM_X:
				{
					// Help
					if(bCmdQ)
					{
						strlcpy(szText,
							"General commands:\n"
							"    -f filename Open freq data file\n"
							"    -p filename Open phase data file\n"
							"    -a filename Open archive file\n"
							"    -t tau Set tau value\n"
							"    -o skip Skip file opening dialogs\n"
							"    -o auto# Execute automation script #\n"
							"    -? Show this help information\n\n"
							"Automation commands:\n"
							"    -xa Generate autocorrelation plot\n"
							"    -xc Convert data to opposite type\n"
							"    -xd Remove drift from data\n"
							"    -xh Generate histogram plot\n"
							"    -xn Normalize data to zero mean\n"
							"    -xm Copy plot as metafile to clipboard\n"
							"    -xo Remove outliers from frequency data\n"
							"    -xp Plot phase or frequency data\n"
							"    -xq Show this help information\n"
							"    -xr@ Perform stability run and plot\n"
							"         a=Overlapping Allan, m=Modified Allan\n"
							"         t=Time or h=Hadamard variance\n"
							"    -xs Generate power spectrum plot\n"
							"    -xt Print plot\n"
							"    -xu# # Select part of data file # to #\n"
							"    -xv# Average data by factor #\n"
							"    -xx Close plot after 1 second\n"
							"    -xz Close program after command execution\n",
							sizeof(szFirstRaw));

						MessageBox(hwnd, szText, "Stable32 Command Line Commands",
										MB_ICONINFORMATION);
							
						// Reset the help display flag
						bCmdQ=FALSE;

						// Done with command line help
						break;
					}

					// Convert data to opposite type
					// Converted data becomes current type
					if(bCmdC) // Convert function
					{
						// Go to Edit menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_E, 0, VK_PRESS, 0);
						keybd_event(VK_E, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select Convert
						keybd_event(VK_C, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_RELEASE, 0);

						// Press OK
						keybd_event(VK_O, 0, VK_PRESS, 0);
						keybd_event(VK_O, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdC=FALSE;
						bCmdLine=FALSE;

						// Execute conversion
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with convert
						break;
					}

					// Select part of data
					if(bCmdU) // Part function
					{
						// Go to edit menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_E, 0, VK_PRESS, 0);
						keybd_event(VK_E, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select part function
						keybd_event(VK_P, 0, VK_PRESS, 0);		
						keybd_event(VK_P, 0, VK_RELEASE, 0);

						// Enter start # if it is not 1
						if(atoi(szCmdStart)!=1)
						{
							// Go to start factor edit control
							keybd_event(VK_MENU, 0, VK_PRESS, 0);	
							keybd_event(VK_S, 0, VK_PRESS, 0);
							keybd_event(VK_S, 0, VK_RELEASE, 0);
							keybd_event(VK_MENU, 0, VK_RELEASE, 0);

							// Load the start point # character-by-character
							for(i=0; i<(int)strlen(szCmdStart); i++)
							{
								keybd_event((char)VkKeyScan(szCmdStart[i]), 0, VK_PRESS, 0);
								keybd_event((char)VkKeyScan(szCmdStart[i]), 0, VK_RELEASE, 0);
							}
						}

						// Enter end # if it is not 0 (the code for last point)
						if(atoi(szCmdEnd)!=0)
						{
							// Go to end factor edit control
							keybd_event(VK_MENU, 0, VK_PRESS, 0);	
							keybd_event(VK_E, 0, VK_PRESS, 0);
							keybd_event(VK_E, 0, VK_RELEASE, 0);
							keybd_event(VK_MENU, 0, VK_RELEASE, 0);

							// Load the end point # character-by-character
							for(i=0; i<(int)strlen(szCmdEnd); i++)
							{
								keybd_event((char)VkKeyScan(szCmdEnd[i]), 0, VK_PRESS, 0);
								keybd_event((char)VkKeyScan(szCmdEnd[i]), 0, VK_RELEASE, 0);
							}
						}

						// Select part of data (OK and then Close)
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_O, 0, VK_PRESS, 0);
						keybd_event(VK_O, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_C, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdU=FALSE;
						bCmdLine=FALSE;

						// Execute outlier removal
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));

						// Done with part
					}

					// Remove Outliers
					// Outlier removal applies only to frequency data
					// Uses default sigma limit as-is
					if(bCmdO) // Check function
					{
						// Skip check if phase data
						if(bDataType==PHASE_DATA)
						{
							// Clear command flags
							bCmdO=FALSE;
							bCmdLine=FALSE;

							// Execute outlier removal
							YieldControl();

							// Call any additional commands
							PostMessage(hwnd, WM_COMMAND,
								GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
							// Done with check
							break;
						}

						// Go to analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select check function
						keybd_event(VK_C, 0, VK_PRESS, 0);		
						keybd_event(VK_C, 0, VK_RELEASE, 0);

						// Choose remove all outliers
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_L, 0, VK_PRESS, 0);
						keybd_event(VK_L, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						#if(0) // Just use current or default sigma
						// Go to sigma factor edit control
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_F, 0, VK_PRESS, 0);
						keybd_event(VK_F, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Load the sigma factor character-by-character
						for(i=0; i<(int)strlen(szAutoSigmaFactor); i++)
						{
							keybd_event((char)VkKeyScan(szAutoSigmaFactor[i]), 0, VK_PRESS, 0);
							keybd_event((char)VkKeyScan(szAutoSigmaFactor[i]), 0,
								VK_RELEASE, 0);
						}
						#endif

						// Press calc button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Press close button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdO=FALSE;
						bCmdLine=FALSE;

						// Execute outlier removal
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));

						// Done with check
						break;
					}

					// Decimate or average data
					if(bCmdV) // Average function
					{
						// Go to edit menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_E, 0, VK_PRESS, 0);
						keybd_event(VK_E, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select average function
						keybd_event(VK_A, 0, VK_PRESS, 0);		
						keybd_event(VK_A, 0, VK_RELEASE, 0);

						// Go to avg factor edit control
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Set the averaging factor
						// Load the averaging factor character-by-character
						for(i=0; i<(int)strlen(szCmdAF); i++)
						{
							keybd_event((char)VkKeyScan(szCmdAF[i]), 0, VK_PRESS, 0);
							keybd_event((char)VkKeyScan(szCmdAF[i]), 0, VK_RELEASE, 0);
						}

						// Preset the busy flag to insure wait loop takes effect
						bBusy=TRUE;

						// Do averaging
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_O, 0, VK_PRESS, 0);
						keybd_event(VK_O, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdV=FALSE;
						bCmdLine=FALSE;

						// Execute average
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with average
						break;
					}

					// Renove drift
					if(bCmdD) // Drift function
					{
						// Go to analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select drift function
						keybd_event(VK_D, 0, VK_PRESS, 0);		
						keybd_event(VK_D, 0, VK_RELEASE, 0);

						// Choose remove drift
						// Note:  The drift dialog always opens with drift removal unselected 
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_R, 0, VK_PRESS, 0);
						keybd_event(VK_R, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Press calc button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);
						
						// Press close button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_PRESS, 0);
						keybd_event(VK_C, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdD=FALSE;
						bCmdLine=FALSE;

						// Execute drift removal
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with drift
						break;
					}

					// Normalize data
					if(bCmdN) // Normalize function
					{
						// Open edit menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_E, 0, VK_PRESS, 0);
						keybd_event(VK_E, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select normalize function
						keybd_event(VK_N, 0, VK_PRESS, 0);
						keybd_event(VK_N, 0, VK_RELEASE, 0);

						// Normalize (OK)
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_O, 0, VK_PRESS, 0);
						keybd_event(VK_O, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdN=FALSE;
						bCmdLine=FALSE;

						// Execute normalize
						YieldControl();

						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with normalize
						break;
					}

					// Plot current data type
					if(bCmdP) // Plot function
					{
						// Save bAutoPlot state
						bAutoPlotSave=bAutoPlot;

						// Set bAutoPlot
						bAutoPlot=TRUE;

						// Go to Plot menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_P, 0, VK_PRESS, 0);
						keybd_event(VK_P, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						if(bDataType==FREQ_DATA)
						{
							// Select Freq
							keybd_event(VK_F, 0, VK_PRESS, 0);
							keybd_event(VK_F, 0, VK_RELEASE, 0);
						}
						else // Phase data
						{
							// Select Phase
							keybd_event(VK_P, 0, VK_PRESS, 0);
							keybd_event(VK_P, 0, VK_RELEASE, 0);
						}

						// Clear command flags
						bCmdP=FALSE;
						bCmdLine=FALSE;

						// Execute plot
						YieldControl();

						// Restore bAutoPlot state
						bAutoPlot=bAutoPlotSave;

						// Close program
						if(bCmdZ)
						{
							// Close the Stable32 program
							PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
						}
						
						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));

						// Done with plot
						break;
					}

					// Run calc & stability plot using previous settings
					// Stability plot stays on screen - may change that
					if(bCmdR) // Run function
					{
						// Turn on auto run plot flag
						// bAutoRunPlot=TRUE;

						// Go to Analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select Run
						keybd_event(VK_R, 0, VK_PRESS, 0);
						keybd_event(VK_R, 0, VK_RELEASE, 0);

						// Go to variance list box
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_V, 0, VK_PRESS, 0);
						keybd_event(VK_V, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select variance type
						// Use the position of the item in list to select it
						// First move to top of list with Page Up key
						keybd_event(VK_PRIOR, 0, VK_PRESS, 0);
						keybd_event(VK_PRIOR, 0, VK_RELEASE, 0);

						// Then send a number of Down Arrows equal to its index
						for(i=0; i<nCmdVarianceType; i++)
						{
							keybd_event(VK_DOWN, 0, VK_PRESS, 0);
							keybd_event(VK_DOWN, 0, VK_RELEASE, 0);
						}

						// Press calculate button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Press plot button
						keybd_event(VK_MENU, 0, VK_PRESS, 0);
						keybd_event(VK_P, 0, VK_PRESS, 0);
						keybd_event(VK_P, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdR=FALSE;
						bCmdLine=FALSE;

						// Execute run
						YieldControl();

						// Close program
						if(bCmdZ)
						{
							// Close the Stable32 program
							PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
						}
						
						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with run
						break;
					}

					// Spectrum plot using previous settings
					// PSD plot stays on screen - may change that
					if(bCmdS) // Power spectrum function
					{
						// Turn on auto PSD plot flag
						bAutoPowerPlot=TRUE;

						// Go to Analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select Power
						keybd_event(VK_P, 0, VK_PRESS, 0);
						keybd_event(VK_P, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdS=FALSE;
						bCmdLine=FALSE;

						// Execute power
						YieldControl();

						// Close program
						if(bCmdZ)
						{
							// Close the Stable32 program
							PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
						}
						
						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with spectrum
						break;
					}

					// Autocorrelation plot using previous settings
					// ACF plot stays on screen - may change that
					if(bCmdA) // Autocorrelation function
					{
						// Turn on auto ACF plot flag
						bAutoACFPlot=TRUE;

						// Turn off lag1 plot insert flag
						// sAPlot.do_table=FALSE;

						// Go to Analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select ACF
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);

						// Execute ACF
						YieldControl();

						// Clear command flags
						bCmdA=FALSE;
						bCmdLine=FALSE;

						// Close program
						if(bCmdZ)
						{
							// Close the Stable32 program
							PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
						}
						
						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with autocorrelation
						break;
					}

					// Histogram
					if(bCmdH) // Histogram function
					{
						// Turn on auto histogram plot flag
						bAutoHistoPlot=TRUE;

						// Go to Analysis menu
						keybd_event(VK_MENU, 0, VK_PRESS, 0);	
						keybd_event(VK_A, 0, VK_PRESS, 0);
						keybd_event(VK_A, 0, VK_RELEASE, 0);
						keybd_event(VK_MENU, 0, VK_RELEASE, 0);

						// Select histogram
						keybd_event(VK_H, 0, VK_PRESS, 0);
						keybd_event(VK_H, 0, VK_RELEASE, 0);

						// Clear command flags
						bCmdH=FALSE;
						bCmdLine=FALSE;

						// Execute histogram
						YieldControl();

						// Close program
						if(bCmdZ)
						{
							// Close the Stable32 program
							PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
						}
						// Call any additional commands
						PostMessage(hwnd, WM_COMMAND,
							GET_WM_COMMAND_MPS(IDM_X, 0, 0));
						
						// Done with histogram
						break;
					}

					// Close
					if(bCmdZ) // Close function
					{
						// Close the Stable32 program
						PostMessage(hwndMain, WM_DESTROY, (WPARAM)0, (LPARAM)0);
					}

					// Done with command line functions
					break;
				}

				// Internal messages
				// Refresh status plots
				case IDC_REFRESH:
				{
					// Set redraw flags
					bPhaseRedraw=TRUE;
					bFreqRedraw=TRUE;

					// Redraw status plots from bitmap
					UpdateStatusBar(hwndMain, OLD_DATA);

					break;
				}

				case IDC_ACTIVATE:
				{
					// Activate data-dependent functions
					ActivateFunctions(MF_ENABLED);
				}
				break;

				// Control IDs
				case IDC_PHASESELECT:
				{
					// Set button states
					Button_SetCheck(hwndPhaseSelectButton, TRUE);
					Button_SetCheck(hwndFreqSelectButton, FALSE);
					
					// New code 07/21/02
					// Are we switching from freq data?
					if(bFreqFlag)
					{
						// Force PSD plot to rescale by setting y_tic to zero
						sPSPlot.y_tic=0;
					}

					// Set flags
					bPhaseFlag=TRUE;
					bFreqFlag=FALSE;
					bDataType=PHASE_DATA;

					// Make filenames phase flenames
					strlcpy(szFile, szPhaseFile, FILE_NAME_SIZE);
					strlcpy(szFileTitle, szPhaseFileTitle, FILE_TITLE_SIZE);

					// Put previous phase filename list into file menu
					UpdateFileInfo(szPreviousPhaseFilename);

					// Set data array pointer
					fData=fPhaseData;

					if(bPhaseData==TRUE)
					{
						// Activate data-dependent functions
						ActivateFunctions(MF_ENABLED);
					}
					else
					{
						// Deactivate data-dependent functions
						ActivateFunctions(MF_GRAYED);
					}

					// Update file tabs
					if(bTabs)
					{
						UpdateTabControl();
					}
					
					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDC_FREQSELECT:
				{
					// Set button states
					Button_SetCheck(hwndPhaseSelectButton, FALSE);
					Button_SetCheck(hwndFreqSelectButton, TRUE);
					
					// New code 07/21/02
					// Are we switching from phase data?
					if(bPhaseFlag)
					{
						// Force PSD plot to rescale by setting y_tic to zero
						sPSPlot.y_tic=0;
					}
					
					// Set flags
					bPhaseFlag=FALSE;
					bFreqFlag=TRUE;
					bDataType=FREQ_DATA;

					// Make filenames freq flenames
					strlcpy(szFile, szFreqFile, FILE_NAME_SIZE);
					strlcpy(szFileTitle, szFreqFileTitle, FILE_TITLE_SIZE);

					// Put previous freq file list into file menu
					UpdateFileInfo(szPreviousFreqFilename);

					// Set data array pointer
					fData=fFreqData;

					if(bFreqData==TRUE)
					{
						// Activate data-dependent functions
						ActivateFunctions(MF_ENABLED);
					}
					else
					{
						// Deactivate data-dependent functions
						ActivateFunctions(MF_GRAYED);
					}

					// Update file tabs
					if(bTabs)
					{
						UpdateTabControl();
					}
					
					// Refresh status plots
					SendMessage(hwndMain, WM_COMMAND,
						GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));

					break;
				}

				case IDC_FREQFILENAME:
				{
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS)
					{
						// Get the new freq filename (inc path if any)
						GetWindowText(hwndFreqFilename, szTempFilename,
							FILENAMESIZE);

						if(CheckFilename(szTempFilename, szTempFiletitle,
							szTempPath, szTempName, szTempExt, hwnd,
							"Freq File"))
						{
							// Did file title change?
							if(strcmp(szTempFiletitle, szFreqFileTitle))
							{
								// Reassign file title (name+ext)
								strlcpy(szFreqFileTitle, szTempFiletitle,
									FILE_TITLE_SIZE);

								// Change the title part of the full filename
								_splitpath(szFreqFile, szTempDrive, 
									szTempDirectory, NULL, NULL);
								_makepath(szFreqFile, szTempDrive, 
									szTempDirectory, szTempName,
									szTempExt);

								// Set data changed flag
								bFreqDataChanged=TRUE;
								bFreqDataUnsaved=TRUE;
								sFPlot.new_file=TRUE;
								UpdateStatusBar(hwnd, OLD_DATA);
							}

							// Is path is non-NULL?
							if(strlen(szTempPath))
							{
								// Reassign the full filename
								strlcpy(szFreqFile, szTempFilename,
									FILE_NAME_SIZE);
							}

							// Redisplay the file title
							SetWindowText(hwndFreqFilename, szFreqFileTitle);

							// Copy to general name & title if it's freq data
							if(bDataType==FREQ_DATA)
							{
								strlcpy(szFileTitle, szFreqFileTitle,
									FILE_TITLE_SIZE);
								strlcpy(szFile, szFreqFile, FILE_NAME_SIZE);
							}
						}
						else // NG filename
						{
							// Redisplay original file title
							SetWindowText(hwndFreqFilename, szFreqFileTitle);
						}

						// Update status bar filename display
						WriteMessage("");
						WriteDateMessage();
					}
					break;
				}

				case IDC_PHASEFILENAME:
				{
					if(GET_WM_COMMAND_CMD(wParam, lParam)==EN_KILLFOCUS)
					{
						// Get the new phase filename (inc path if any)
						GetWindowText(hwndPhaseFilename, szTempFilename,
							FILENAMESIZE);

						if(CheckFilename(szTempFilename, szTempFiletitle,
							szTempPath, szTempName, szTempExt, hwnd,
							"Phase File"))
						{
							// Did file title change?
							if(strcmp(szTempFiletitle, szPhaseFileTitle))
							{
								// Reassign file title (name+ext)
								strlcpy(szPhaseFileTitle, szTempFiletitle,
									FILE_TITLE_SIZE);

								// Change the title part of the full filename
								_splitpath(szPhaseFile, szTempDrive, 
									szTempDirectory, NULL, NULL);
								_makepath(szPhaseFile, szTempDrive, 
									szTempDirectory, szTempName,
									szTempExt);

								// Set data changed flag
								bPhaseDataChanged=TRUE;
								bPhaseDataUnsaved=TRUE;
								UpdateStatusBar(hwnd, OLD_DATA);
							}

							// Is path is non-NULL?
							if(strlen(szTempPath))
							{
								// Reassign the full filename
								strlcpy(szPhaseFile, szTempFilename,
									FILE_NAME_SIZE);
							}

							// Redisplay the file title
							SetWindowText(hwndPhaseFilename, szPhaseFileTitle);

							// Copy to general name & title if it's phase data
							if(bDataType==PHASE_DATA)
							{
								strlcpy(szFileTitle, szPhaseFileTitle,
									FILE_TITLE_SIZE);
								strlcpy(szFile, szPhaseFile, FILE_NAME_SIZE);
							}
						}
						else // NG filename
						{
							// Redisplay original file title
							SetWindowText(hwndPhaseFilename, szPhaseFileTitle);
						}

						// Update status bar filename display
						WriteMessage("");
						WriteDateMessage();
					}
					break;
				}

				// Access phase tau edit control
				case IDC_PHASETAUSELECT:
				{
					SetFocus(hwndPhaseTau);
					break;
				}

				// Access phase start edit control
				case IDC_PHASESTARTSELECT:
				{
					SetFocus(hwndPhaseStart);
					break;
				}

				// Access phase end edit control
				case IDC_PHASEENDSELECT:
				{
					SetFocus(hwndPhaseEnd);
					break;
				}

				// Access phase filename edit control
				case IDC_PHASEFILESELECT:
				{
					SetFocus(hwndPhaseFilename);
					break;
				}

				// Access freq tau edit control
				case IDC_FREQTAUSELECT:
				{
					SetFocus(hwndFreqTau);
					break;
				}

				// Access freq start edit control
				case IDC_FREQSTARTSELECT:
				{
					SetFocus(hwndFreqStart);
					break;
				}

				// Access freq end edit control
				case IDC_FREQENDSELECT:
				{
					SetFocus(hwndFreqEnd);
					break;
				}

				// Access freq filename edit control
				case IDC_FREQFILESELECT:
				{
					SetFocus(hwndFreqFilename);
					break;
				}

				// Use specific code instead of default
				case IDC_TOOLBUTTON:
				{
					switch(GET_WM_COMMAND_CMD(wParam, lParam))
					{
						case BN_CLICKED:
						{
							switch(LOWORD(lParam)-1)
							{
								#ifndef LITE_VER
								case TB_CONF:
								{
									// Turn TB_CONF into IDM_CONFIG msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_CONFIG,
										hwndToolbar, IDM_CONFIG));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_FILE:
								{
									// Turn TB_FILE into IDM_FILENAMES msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_FILENAMES,
										hwndToolbar, IDM_FILENAMES));
									break;
								}
								#endif

								case TB_STAT:
								{
									// Turn TB_STAT into IDM_STAT msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_STAT,
										hwndToolbar, IDM_STAT));
									break;
								}

								case TB_CHECK:
								{
									// Turn TB_CHECK into IDM_CHECK msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_CHECK,
										hwndToolbar, IDM_CHECK));
									break;
								}

								case TB_SIGMA:
								{
									// Turn TB_SIGMA into IDM_SIGMA msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_SIGMA,
										hwndToolbar, IDM_SIGMA));
									break;
								}

								case TB_FILTER:
								{
									// Turn TB_FILTER into IDM_FILTER msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_FILTER,
										hwndToolbar, IDM_FILTER));
									break;
								}

								case TB_RUN:
								{
									// Turn TB_RUN into IDM_RUN msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_RUN,
										hwndToolbar, IDM_RUN));
									break;
								}

								case TB_DAVAR:
								{
									// Turn TB_DAVAR into IDM_DAVAR msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_DAVAR,
										hwndToolbar, IDM_DAVAR));
									break;
								}

								case TB_PLOT:
								{
									// Turn TB_PLOT into IDM_PHASE_PLOT
									// or IDM_FREQ_PLOT msg
									if(bDataType)
									{
										PostMessage(hwndMain, WM_COMMAND,
											GET_WM_COMMAND_MPS(IDM_FREQ_PLOT,
											hwndToolbar, IDM_FREQ_PLOT));
									}
									else
									{
										PostMessage(hwndMain, WM_COMMAND,
											GET_WM_COMMAND_MPS(IDM_PHASE_PLOT,
											hwndToolbar, IDM_PHASE_PLOT));
									}
									break;
								}

								case TB_DRIFT:
								{
									// Turn TB_DRIFT into IDM_DRIFT msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_DRIFT,
										hwndToolbar, IDM_DRIFT));
									break;
								}

								#ifndef LITE_VER
								case TB_POWER:
								{
									// Turn TB_POWER into IDM_POWER msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_POWER,
										hwndToolbar, IDM_POWER));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_HIST:
								{
									// Turn TB_HIST into IDM_HISTOGRAM msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_HIST,
										hwndToolbar, IDM_HIST));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_CAL:
								{
									// Turn TB_CAL into IDM_CAL msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_CAL,
										hwndToolbar, IDM_CAL));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_VIBRA:
								{
									// Turn TB_VIBRA into IDM_VIBRA msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_VIBRA,
										hwndToolbar, IDM_VIBRA));
									break;
								}
								#endif

								case TB_PART:
								{
									// Turn TB_PART into IDM_PART msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_PART,
										hwndToolbar, IDM_PART));
									break;
								}

								#ifndef LITE_VER
								case TB_NOISE:
								{
									// Turn TB_NOISE into IDM_GENERATE msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_NOISE,
										hwndToolbar, IDM_NOISE));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_FILL:
								{
									// Turn TB_FILL into IDM_FILL msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_FILL,
										hwndToolbar, IDM_FILL));
									break;
								}
								#endif

								case TB_SCALE:
								{
									// Turn TB_SCALE into IDM_SCALE msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_SCALE,
										hwndToolbar, IDM_SCALE));
									break;
								}

								case TB_OPEN:
								{
									// Turn TB_OPEN into IDM_MAIN_OPEN msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_MAIN_OPEN,
										hwndToolbar, IDM_MAIN_OPEN));
									break;
								}

								case TB_SAVE:
								{
									// Turn TB_SAVE into IDM_MAIN_SAVE msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_MAIN_SAVE,
										hwndToolbar, IDM_MAIN_SAVE));
									break;
								}

								#ifndef LITE_VER
								case TB_ADD:
								{
									// Turn TB_ADD into IDM_ADD msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_ADD,
										hwndToolbar, IDM_ADD));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_READ:
								{
									// Turn TB_READ into IDM_READ msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_READ,
										hwndToolbar, IDM_READ));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_PRINT:
								{
									// Turn TB_PRN into IDM_PRINT msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_MAIN_PRINT,
										hwndToolbar, IDM_MAIN_PRINT));
									break;
								}
								#endif

								case TB_EDIT:
								{
									// Turn TB_EDIT into IDM_MAIN_EDIT msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_MAIN_EDIT,
										hwndToolbar, IDM_MAIN_EDIT));
									break;
								}

								case TB_CONV:
								{
									// Turn TB_CONV into IDM_CONVERT msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_CONV,
										hwndToolbar, IDM_CONV));
									break;
								}

								case TB_NORM:
								{
									// Turn TB_NORM into IDM_NORMALIZE msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_NORM,
										hwndToolbar, IDM_NORM));
									break;
								}

								case TB_AVG:
								{
									// Turn TB_AVG into IDM_AVERAGE msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_AVG,
										hwndToolbar, IDM_AVG));
									break;
								}

								case TB_STEP:
								{
									// Turn TB_STEP into IDM_STEP msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_STEP,
										hwndToolbar, IDM_STEP));
									break;
								}

								#ifndef LITE_VER
								#ifndef STUDENT_VER
								case TB_PLAY:
								{
									// Turn TB_PLAY into IDM_PLAY msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_PLAY,
										hwndToolbar, IDM_PLAY));
									break;
								}
								#endif
								#endif

								#ifndef LITE_VER
								#ifndef STUDENT_VER
								case TB_SQL:
								{
									// Turn TB_SQL into IDM_SQL msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_SQL,
										hwndToolbar, IDM_SQL));
									break;
								}
								#endif
								#endif

								#ifndef LITE_VER

								case TB_TAB:
								{
									// Turn tabs on (if not already on)
									if(!bTabs)
									{
										// Turn tabs on
										bTabs=TRUE;
										CheckMenuItem(hMenu, IDM_TABS_SHOW,
											MF_BYCOMMAND | MF_CHECKED);
									}

									// Save current data in new tab
									CreateTab();

									// Update tab control
									UpdateTabControl();

									// Update Tab menu
									SetTabMenu();
									break;
								}
								#endif

								case TB_CLEAR:
								{
									// Turn TB_CLEAR into IDM_CLEAR msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_CLEAR,
										hwndToolbar, IDM_CLEAR));
									break;
								}

								#ifndef LITE_VER
								case TB_TIMETAG:
								{
									// Turn TB_TIMETAG into IDM_TIMETAG msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_TIMETAG,
										hwndToolbar, IDM_TIMETAG));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_REGULARIZE:
								{
									// Turn TB_REGULARIZE into IDM_REGULARIZE
									// msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_REGULARIZE,
										hwndToolbar, IDM_REGULARIZE));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_DOMAIN:
								{
									// Turn TB_DOMAIN into IDM_DOMAIN msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_DOMAIN,
										hwndToolbar, IDM_DOMAIN));
									break;
								}
								#endif

								#ifndef LITE_VER
								case TB_NOTEPAD:
								{
									// Turn TB_NOTEPAD into IDM_NOTEPAD msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_NOTEPAD,
										hwndToolbar, IDM_NOTEPAD));
									break;
								}
								#endif

								#ifndef LITE_VER
								#ifndef STUDENT_VER
								case TB_COMM:
								{
									// Turn TB_COMM into IDM_5110COMM msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_5110COMM,
										hwndToolbar, IDM_5110COMM));
									break;
								}
								#endif
								#endif

								#ifndef LITE_VER
								//#ifndef STUDENT_VER - Removed 5/13/04
								case TB_ACS: // Autocorrelation
								{
									// Turn TB_AUTO into IDM_AUTO msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_AUTO,
										hwndToolbar, IDM_AUTO));
									break;
								}
								//#endif
								#endif

								#ifndef LITE_VER
								#ifndef STUDENT_VER
								case TB_AUTO1:
								{
									// Turn TB_AUTO1 into IDM_AUTO1 msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_AUTO1,
										hwndToolbar, IDM_AUTO1));
									break;
								}

								case TB_AUTO2:
								{
									// Turn TB_AUTO2 into IDM_AUTO2 msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_AUTO2,
										hwndToolbar, IDM_AUTO2));
									break;
								}

								case TB_AUTO3:
								{
									// Turn TB_AUTO3 into IDM_AUTO3 msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_AUTO3,
										hwndToolbar, IDM_AUTO3));
									break;
								}
								#endif
								#endif

								case TB_HELP:
								{
									// Turn TB_HELP into IDM_HELP msg
									PostMessage(hwndMain, WM_COMMAND,
										GET_WM_COMMAND_MPS(IDM_HELP,
										hwndToolbar, IDM_HELP));
									break;
								}

								default:
								{
									LoadString(hInst, IDS_MESSAGE_NEVER,
										szBuffer, BUFFER_SIZE);
									MessageBox(hwnd, szBuffer, "Notice",
										MB_ICONEXCLAMATION);

								} // End default
							}     // End switch(wParam-1)
						}         // End case BN_CLICKED:
					}             // End switch GET_WM_COMMAND_CMD
				}                 // End default
			}                     // End switch(wParam)
			return 0;             // Return w/o calling DefWindowProc()
		}                         // End case WM_COMMAND:

		case WM_DESTROY:
		{
			// Save main window position
			GetWindowRect(hwnd, &rect);
			nMainLeft=rect.left;
			nMainTop=rect.top;
			nMainRight=rect.right;
			nMainBottom=rect.bottom;

			DeleteObject(hBrush);
			PostQuitMessage(0); // Tell Windows app is terminating
			return 0;
		}
	}

	// Call DefWindowProc to process other messages
	return DefWindowProc(hwnd, message, wParam, lParam);
}

/*****************************************************************************/
/*                                                                           */
/*                   Command Line Parsing Procedure                          */
/*                                                                           */
/*		-P and -F set bDataType to phase or frequency data and put command   */
/*      line filename into szComandFile.                                     */
/*                                                                           */
/*      -T puts command line tau value into fCommandTau.                     */
/*                                                                           */
/*      -O allows entry of options.  Only one so far is LOGAGE to set        */
/*      bLogage flag for special log aging fit on frequency data plot.       */
/*		Note: Option parsing is inactivated.                                 */
/*                                                                           */
/*      Parameters:                                                          */
/*      	BOOL	*bAutoload 		Flag to automatically load data file     */
/*          BOOL	*bDataType		Type of data file to be loaded           */
/*          BOOL	*bArchiveData	Flag to automatically load archive data  */
/*          char	*szFile			Filename of data file to be loaded       */
/*          F_TYPE	*fTau           Tau of data file to be loaded            */
/*                                                                           */
/*      Usage:	Use data type and filename if bAutoload is TRUE              */
/*              Use tau if it is non-zero                                    */
/*                                                                           */
/*		Revision record:                                                     */
/*			01/05/97	Adapted from Stable/DOS                              */
/*			06/20/98	Added -A option                                      */
/*			06/23/98	Added *bArchiveData argument                         */
/*                                                                           */
/*****************************************************************************/
void ParseCommandLine(BOOL *bAutoload, BOOL *bDataType, BOOL *bArchiveData,
	char *szFile, F_TYPE *fTau)
{
	// Local macros
	// Set complier-specific command line argument global variables
	#ifdef _MSC_VER // For Visual C++
	#define ARGC __argc
	#define ARGV  __argv
	#else
	#define ARGC _argc
	#define ARGV _argv
	#endif

	// Local variables
	int i;	// General index
	char szOption[BUFFER_SIZE+1];

	// Initializations
	*bAutoload=FALSE;
	*fTau=0.0;

	// Parse command line
	if(ARGC>1)
	{
		for(i=1; i<ARGC; i++)
		{
			if(ARGV[i][0]=='-')
			{
				switch(ARGV[i][1])
				{
					// Help
					case '?':
					{
						// Set help display flag
						bCmdQ=TRUE;
						break;
					}

					// Special diagnostic command
					case '*':
					{
						// Set help display flag
						bSpecialCmd=TRUE;
						break;
					}

					// Phase data
					case 'p':
					case 'P':
					{
						*bDataType=PHASE_DATA;
						if( (i+1<ARGC) && (ARGV[i+1][0]!='-') )
						{
							strlcpy(szFile, ARGV[++i], FILE_NAME_SIZE);
							// TRACE_STR(szFile);
							*bAutoload=TRUE;
						}
						break;
					}

					// Frequency data
					case 'f':
					case 'F':
					{
						*bDataType=FREQ_DATA;
						if( (i+1<ARGC) && (ARGV[i+1][0]!='-') )
						{
							strlcpy(szFile, ARGV[++i], FILE_NAME_SIZE);
							*bAutoload=TRUE;
						}

						// TRACE_STR(szFile);

						break;
					}

					// Archive data
					case 'a':
					case 'A':
					{
						*bArchiveData=TRUE;
						if( (i+1<ARGC) && (ARGV[i+1][0]!='-') )
						{
							strlcpy(szFile, ARGV[++i], FILE_NAME_SIZE);
							*bAutoload=TRUE;
						}
						break;
					}

					// Options
					// Note: can have multiple options
					// but they each must be entered with an -o in front
					case 'o':
					case 'O':
					{
						if( (i+1<ARGC) && (ARGV[i+1][0]!='-') )
						{
							strlcpy(szOption, ARGV[++i], sizeof(szOption));
							strupr(szOption);
						}

						// Skip multicolumn & file opened dialogs
						if(strcmp(szOption, "SKIP")==0)
						{
							bSkip=TRUE;
						}

						// Automatic processing
						if(strcmp(szOption, "AUTO1")==0)
						{
							bAuto1=TRUE;
							bAuto2=FALSE;
							bAuto3=FALSE;
						}

						// Automatic processing
						if(strcmp(szOption, "AUTO2")==0)
						{
							bAuto1=FALSE;
							bAuto2=TRUE;
							bAuto3=FALSE;
						}

						// Automatic processing
						if(strcmp(szOption, "AUTO3")==0)
						{
							bAuto1=FALSE;
							bAuto2=FALSE;
							bAuto3=TRUE;
						}

						// Note: add additional option parsing here
						break;
					}

					// Tau
					case 't':
					case 'T':
					{
						*fTau=fabs(atof(ARGV[++i]));
						break;
					}

					// Trial code 11/19/11
					// The X command causes Stable32 to execute some function
					// from the command line
					// The command line sequence is -X#
					// where -X is the execute command
					// and # is a function code
					// which may be followed by additional arguments
					case 'x':
					case 'X':
					{
						// Parse function code
						switch(ARGV[i][2])
						{
							// Command line help
							case 'q':
							case 'Q':
							{
								bCmdQ=TRUE;
							}
							break;

							// Autocorrelation function
							case 'a':
							case 'A':
							{
								bCmdA=TRUE;
							}
							break;

							// Convert function
							case 'c':
							case 'C':
							{
								bCmdC=TRUE;
							}
							break;

							// Drift function
							case 'd':
							case 'D':
							{
								bCmdD=TRUE;
							}
							break;

							// Histogram function
							case 'h':
							case 'H':
							{
								bCmdH=TRUE;
							}
							break;

							// Copy function
							case 'm':
							case 'M':
							{
								bCmdM=TRUE;
							}
							break;

							// Normalize function
							case 'n':
							case 'N':
							{
								bCmdN=TRUE;
							}
							break;

							// Check function
							case 'o':
							case 'O':
							{
								bCmdO=TRUE;
							}
							break;

							// Plot function
							case 'p':
							case 'P':
							{
								bCmdP=TRUE;
							}
							break;

							// Run function
							case 'r':
							case 'R':
							{
								bCmdR=TRUE;

								// Parse variance type
								// nCmdVariance is initialized to 0
								// It represents the number of places down
								// it is in list in Run dialog box
								if((ARGV[i][3]=='a')||(ARGV[i][3]=='A'))
								{
									// Overlapping Allan variance
									nCmdVarianceType=1;
								}
								else if((ARGV[i][3]=='m')||(ARGV[i][3]=='M'))
								{
									// Modified Allan variance
									nCmdVarianceType=2;
								}
								else if((ARGV[i][3]=='t')||(ARGV[i][3]=='T'))
								{
									// Time variance
									nCmdVarianceType=3;
								}
								else if((ARGV[i][3]=='h')||(ARGV[i][3]=='H'))
								{
									// Overlapping Hadamard variance
									nCmdVarianceType=5;
								}
							}
							break;

							// Spectrum function
							case 's':
							case 'S':
							{
								bCmdS=TRUE;
							}
							break;

							// Print function
							case 't':
							case 'T':
							{
								bCmdT=TRUE;
							}
							break;

							// Part function
							case 'u':
							case 'U':
							{
								bCmdU=TRUE;

								// Get start point
								strlcpy(szCmdStart, &ARGV[i][3], sizeof(szCmdStart));

								// Get end point
								// szCmdStart starts at [3]
								// so szCmdEnd starts at [3] plus space
								// plus length of szCmdStart
								strlcpy(szCmdEnd, &ARGV[i][4+strlen(szCmdStart)], sizeof(szCmdEnd));

								// Advance the argument index
								i++;

								// TRACE_STR(szCmdStart);
								// TRACE_STR(szCmdEnd);
							}
							break;

							// Average function
							case 'v':
							case 'V':
							{
								bCmdV=TRUE;

								// Get averaging factor
								strlcpy(szCmdAF, &ARGV[i][3], sizeof(szCmdAF));
							}
							break;

							// Close plot
							case 'x':
							case 'X':
							{
								bCmdX=TRUE;
							}
							break;

							// Close program
							case 'z':
							case 'Z':
							{
								bCmdZ=TRUE;
							}
							break;
						}
						break;
					}

					default:
					{
						break;
					}
				}
			}
			else
			{
				strlcpy(szFile, ARGV[i], FILE_NAME_SIZE);
				// Filename entered on command line without data type
				// Don't autoload - just invoke Open Data File dialog box
				// with this filename
				*bAutoload=FALSE; // Was TRUE until 06/19/98
			}
		}
	}
}

/*****************************************************************************/
/*                                                                           */
/*                   Create Tab Control Above Message Bar                    */
/*		                                                                     */
/*		Creates a tab control, sized to fit the main window width            */
/*		Do this only after more than one file is read or generated           */
/*		and only if bTabs flag is set                                        */
/*		Use to rapidly switch between phase or frequency data files          */
/*		and as undo feature, at expense of more RAM usage                    */
/*		Tabs are shown only for the selected data type                       */
/*		Respond to WM_SIZE message to resize tab control as necessary        */
/*		This code adds test tabs - will want to this is separate real code   */
/*		Returns the global handle of the tab control                         */ 
/*		Looks better w/o focus indication on pressed button                  */
/*                                                                           */
/*      Parameters:		HWND hwndParent		Handle to parent window          */
/*      Return:			HWND hwndTab		Global handle to tab control     */
/*                                                                           */
/*		Revision record:                                                     */
/*			11/16/06	Created                                              */
/*                                                                           */
/*****************************************************************************/
 
HWND WINAPI CreateTabControl(HWND hwndParent) 
{ 
    RECT rcClient;
	HFONT hFont;
 
    // Get dimensions of parent window client area
    // Use to determine width of tab control
    GetClientRect(hwndParent, &rcClient);

	// Create tab control
	// Y position is 30 pixels above horizontal line at top of message bar
	// cyClient and ctChar are pre-determined global variables
    // Tab height is 26 pixels
	hwndTab=CreateWindow(WC_TABCONTROL, "",
		WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE |
		TCS_BUTTONS , 0, (int)(cyClient-3.25*cyChar-1-2.5*cyChar/2.5)-30,
		rcClient.right, 26, hwndParent, NULL, hInst, NULL);
	
	// Check for OK handle
	if(hwndTab == NULL)
	{
        return NULL;
	}
 
	// Get font handle used for phase file label (as good as any to use)
	hFont=GetWindowFont(hwndPhaseFileLabel);

	// Set Tab text font
	SetWindowFont(hwndTab, hFont, TRUE);
	
	SetTabMenu();

	// Done
 	return hwndTab;
} 

/*****************************************************************************/
/*                                                                           */
/*                             Update Tab Control                            */
/*		                                                                     */
/*		Function to update tab control                                       */
/*                                                                           */
/*      Parameters:		None (void)                                          */
/*      Return:			None (void)                                          */
/*                                                                           */
/*		Revision record:                                                     */
/*			11/16/06	Created                                              */
/*                                                                           */
/*****************************************************************************/
 
void WINAPI UpdateTabControl(void) 
{ 
	//char szBuffer[BUFFER_SIZE+1];	// Text buffer
    TC_ITEM tie;
    int i; 
 
	// Destroy existing tab control (if any)
	DestroyWindow(hwndTab);
	
	// Create tab control if tabs are enabled
	if(bTabs)
	{
		CreateTabControl(hwndMain);
	}
	else // Otherwise return
	{
		return;
	}

	// Set up to display file title text
	tie.mask=TCIF_TEXT;
	tie.cchTextMax=FILE_TITLE_SIZE;

	// Show phase tabs
    if(bDataType==PHASE_DATA)
	{
		for(i=0; i<nNumPhaseTabs; i++)
		{ 
			tie.pszText=sPTab[i].szTitle;
			if(TabCtrl_InsertItem(hwndTab, i, &tie) == -1)
			{ 
				// Error
				DestroyWindow(hwndTab); 
			}
		}
	}
	else // Freq data
	{
		// Show freq tabs
		for(i=0; i<nNumFreqTabs; i++)
		{ 
			tie.pszText=sFTab[i].szTitle;
			if(TabCtrl_InsertItem(hwndTab, i, &tie) == -1)
			{ 
				// Error
				DestroyWindow(hwndTab); 
			}
		}
	}

	// If only one tab, deselect it so it can be accessed by clicking on it
	// Use of the -1 argument is not documented, 
	// but seems to work OK to deselect all tabs
    if(bDataType==PHASE_DATA)
	{
		if(nNumPhaseTabs==1)
		{
			TabCtrl_SetCurSel(hwndTab, -1);
		}
	}
	else // Freq data
	{
		if(nNumFreqTabs==1)
		{
			TabCtrl_SetCurSel(hwndTab, -1);
		}
	}
} 

/*****************************************************************************/
/*                                                                           */
/*                               Create Tab                                  */
/*                                                                           */
/*      Create a new tab in tab control                                      */
/*		                                                                     */
/*      Parameters:	  None (void)                                            */
/*      Return:		  None (void)                                            */
/*      Globals:	  Handle to tab control: hwndTab	                     */
/*                    Tab data structs: sPTab and sFTab                      */
/*                    # tabs: nNumPhaseTabs and nNumFreqTabs                 */
/*                    Data type: bDataType                                   */
/*					  Data arrays: fPhaseData and fFreqData                  */
/*					  Data file titles: szPhaseFileTitle & szFreqFileTitle   */
/*					  Tau windows: hwndPhaseTau and hwndPhaseTau             */
/*                                                                           */
/*      Note: Call only if tabs are active (bTab==TRUE)                      */
/*                                                                           */
/*		Revision record:                                                     */
/*			11/16/06	Created                                              */
/*                                                                           */
/*****************************************************************************/
 
void WINAPI CreateTab(void) 
{
	// Local variables
	char szBuffer[BUFFER_SIZE+1];	// Text buffer
	int nSize;						// Data array size

	if(bDataType==PHASE_DATA)
	{
		// Save current phase data
		// Test that the phase # tabs is not at limit
		if(nNumPhaseTabs<PTAB_NUMTABS)
		{
			// Get size of existing phase data array
			nSize=(int)fPhaseData[0];
			
			// Allocate memory for existing phase data
			// using next sPTab[nNumPhaseTabs].fData pointer
			if((sPTab[nNumPhaseTabs].fData=
				(F_TYPE*)malloc((nSize+ARRAY_OFFSET)*sizeof(F_TYPE)))==NULL)
			{
				AllocErrorMessage();
			}
			else // OK - save phase data
			{
				// Copy entire data array, including header
				for(i=0; i<nSize+ARRAY_OFFSET; i++)
				{
					sPTab[nNumPhaseTabs].fData[i]=fPhaseData[i];
				}
			}
			
			if(bPhaseTimetags)
			{
				// Allocate memory for existing phase timetags
				// using next sPTab[nNumPhaseTabs].fTags pointer
				if((sPTab[nNumPhaseTabs].fTags=
					(F_TYPE*)malloc((nSize+ARRAY_OFFSET)*sizeof(F_TYPE)))==
					NULL)
				{
					AllocErrorMessage();
				}
				else // OK - save phase timetags
				{
					// Copy entire timetag array, including header
					for(i=0; i<nSize+ARRAY_OFFSET; i++)
					{
						sPTab[nNumPhaseTabs].fTags[i]=fPhaseTimetags[i];
					}
				}

				// Set phase timetags flag
				sPTab[nNumPhaseTabs].bTags=TRUE;
			}
			else // No phase timetags
			{
				// Clear phase timetags flag
				sPTab[nNumPhaseTabs].bTags=FALSE;
			}
			
			// Put filename into tab title
			strlcpy(sPTab[nNumPhaseTabs].szTitle, szPhaseFileTitle,
				FILE_TITLE_SIZE);

			// Get tau value
			GetWindowText(hwndPhaseTau, szBuffer, BUFFER_SIZE);

			// Put tau into tab tau
			sPTab[nNumPhaseTabs].fTau=(F_TYPE)atof(szBuffer);

			// Increment # phase tabs
			nNumPhaseTabs++;
		}
		else // # tabs at limit
		{
			// Display message
			_snprintf(szBuffer, sizeof(szBuffer),
				"# phase tabs limit (%d) exceeded.\n"
				"Close an existing tab to create new one.", PTAB_NUMTABS);
			MessageBox(NULL, szBuffer, "Data Tabs",
				MB_OK | MB_ICONEXCLAMATION);
		}
	}
	else // Freq data
	{
		// Save current freq data
		// Test that the # freq tabs is not at limit
		if(nNumFreqTabs<FTAB_NUMTABS)
		{
			// Get size of existing phase data array
			nSize=(int)fFreqData[0];
								
			// Allocate memory for existing freq data
			// using next sFTab[nNumFreqTabs].fData pointer
			if((sFTab[nNumFreqTabs].fData=
				(F_TYPE*)malloc((nSize+ARRAY_OFFSET)*sizeof(F_TYPE)))==
				NULL)
			{
				AllocErrorMessage();
			}
			else // OK - save freq data
			{
				// Copy entire data array, including header
				for(i=0; i<nSize+ARRAY_OFFSET; i++)
				{
					sFTab[nNumFreqTabs].fData[i]=fFreqData[i];
				}
			}

			if(bFreqTimetags)
			{
				// Allocate memory for existing freq timetags
				// using next sFTab[nNumFreqeTabs].fTags pointer
				if((sFTab[nNumFreqTabs].fTags=
					(F_TYPE*)malloc((nSize+ARRAY_OFFSET)*sizeof(F_TYPE)))==
					NULL)
				{
					AllocErrorMessage();
				}
				else // OK - save freq timetags
				{
					// Copy entire timetag array, including header
					for(i=0; i<nSize+ARRAY_OFFSET; i++)
					{
						sFTab[nNumFreqTabs].fTags[i]=fFreqTimetags[i];
					}
				}

				// Set freq timetags flag
				sFTab[nNumFreqTabs].bTags=TRUE;
			}
			else // No freq timetags
			{
				// Clear freq timetags flag
				sFTab[nNumFreqTabs].bTags=FALSE;
			}

			// Put filename into tab title
			strlcpy(sFTab[nNumFreqTabs].szTitle, szFreqFileTitle,
				FILE_TITLE_SIZE);

			// Get tau value
			GetWindowText(hwndFreqTau, szBuffer, BUFFER_SIZE);

			// Put tau into tab tau
			sFTab[nNumFreqTabs].fTau=(F_TYPE)atof(szBuffer);

			// Increment # freq tabs
			nNumFreqTabs++;
		}
		else // # tabs at limit
		{
			// Display message
			_snprintf(szBuffer, sizeof(szBuffer),
				"# frequency tabs limit (%d) exceeded.\n"
				"Close an existing tab to create new one.", FTAB_NUMTABS);
			MessageBox(NULL, szBuffer, "Data Tabs",
				MB_OK | MB_ICONEXCLAMATION);
		}
	}

	// Update tab control
	UpdateTabControl();

	// Refresh status plots
	SendMessage(hwndMain, WM_COMMAND,
		GET_WM_COMMAND_MPS(IDC_REFRESH, 0, 0));
} 

/*****************************************************************************/
/*                                                                           */
/*                               SetTabMenu                                  */
/*                                                                           */
/*      Set state of items in Tab menu                                       */
/*		                                                                     */
/*      Parameters:	  None (void)                                            */
/*      Return:		  None (void)                                            */
/*      Globals:	  Handle to main menu: hMenu    	                     */
/*                    # tabs open: nNumPhaseTabs and nNumFreqTabs            */
/*                    Data type: bDataType                                   */
/*					  MENUITEMINFO struct mii                                */
/*                    Tab state flags: bTabs, bTabFile, bTabChange,          */
/*                    bTabEdit, bTabNoise                                    */
/*                                                                           */
/*		Revision record:                                                     */
/*			11/19/06	Created                                              */
/*                                                                           */
/*****************************************************************************/
 
void WINAPI SetTabMenu(void) 
{
	// Set members of mii struct
	mii.cbSize=sizeof(MENUITEMINFO);
	mii.fMask=MIIM_STATE;

	if(bTabs)
	{
		mii.fState=MFS_ENABLED;
	}
	else // No tabs
	{
		mii.fState=MFS_GRAYED;
	}

	// Set tabs menu items that follow bTabs state
	SetMenuItemInfo(hMenu, IDM_TABS_FILE, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_CHANGE, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_NOISE, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_EDIT, FALSE, &mii);

	// Save tab menu item follows bTabs state
	// and for which there must be current data
	if(bDataType==PHASE_DATA)
	{
		// Check for tabs and phase data
		if(bTabs && bPhaseData)
		{
			mii.fState=MFS_ENABLED;
		}
		else // No phase tabs open
		{
			mii.fState=MFS_GRAYED;
		}
	}
	else // Freq data
	{
		// Check for tabs and freq data
		if(bTabs && bFreqData)
		{
			mii.fState=MFS_ENABLED;
		}
		else // No freq tabs open
		{
			mii.fState=MFS_GRAYED;
		}
	}
	
	// Set save menu item
	SetMenuItemInfo(hMenu, IDM_TABS_SAVE, FALSE, &mii);

	// Set tabs menu items that follow auto tab create flags
	// Auto file tab create
	if(bTabFile)
	{
		CheckMenuItem(hMenu, IDM_TABS_FILE, MF_BYCOMMAND | MF_CHECKED);
	}
	else // Off
	{
		CheckMenuItem(hMenu, IDM_TABS_FILE, MF_BYCOMMAND | MF_UNCHECKED);
	}

	// Auto change tab create
	if(bTabChange)
	{
		CheckMenuItem(hMenu, IDM_TABS_CHANGE, MF_BYCOMMAND | MF_CHECKED);
	}
	else // Off
	{
		CheckMenuItem(hMenu, IDM_TABS_CHANGE, MF_BYCOMMAND | MF_UNCHECKED);
	}

	// Auto edit tab create
	if(bTabEdit)
	{
		CheckMenuItem(hMenu, IDM_TABS_EDIT, MF_BYCOMMAND | MF_CHECKED);
	}
	else // Off
	{
		CheckMenuItem(hMenu, IDM_TABS_EDIT, MF_BYCOMMAND | MF_UNCHECKED);
	}

	// Auto noise tab create
	if(bTabNoise)
	{
		CheckMenuItem(hMenu, IDM_TABS_NOISE, MF_BYCOMMAND | MF_CHECKED);
	}
	else // Off
	{
		CheckMenuItem(hMenu, IDM_TABS_NOISE, MF_BYCOMMAND | MF_UNCHECKED);
	}

	// Check if any tabs open
	if(bDataType==PHASE_DATA)
	{
		// Check # open phase tabs
		if(nNumPhaseTabs)
		{
			mii.fState=MFS_ENABLED;
		}
		else // No phase tabs open
		{
			mii.fState=MFS_GRAYED;
		}
	}
	else // Freq data
	{
		// Check # open freq tabs
		if(nNumFreqTabs)
		{
			mii.fState=MFS_ENABLED;
		}
		else // No freq tabs open
		{
			mii.fState=MFS_GRAYED;
		}
	}

	// Set tabs menu items that follow # open tabs
	SetMenuItemInfo(hMenu, IDM_TABS_RENAME, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_WRITE, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_CLEAR, FALSE, &mii);
	SetMenuItemInfo(hMenu, IDM_TABS_CLEARALL, FALSE, &mii);
}

/*****************************************************************************/
/*                                                                           */
/*                                 CallHelp                                  */
/*                                                                           */
/*      Function to call context-sensitive HTML help file                    */
/*		                                                                     */
/*		Typical call: CallHelp(hDlg, "VIBRA");                               */
/*		                                                                     */
/*		Note: This method of calling a help topic works but has not beem     */
/*		      widely utilized.  See VibraDlgProc() for example.              */
/*		      Much tedious editing required to fully use.                    */
/*		      The advantage of this function is that a different help file   */
/*		      type can be used without changing other code.                  */
/*		      It also writes a line to the log file.                         */
/*		                                                                     */
/*      Parameters:	  HWND hDlg			Dialog box window handle             */
/*					  char * szTopic	Help topic identifier string         */
/*		                                without .HTM extension               */
/*      Return:		  None (void)                                            */
/*      Globals:	  szHelpFile		Help filename	                     */
/*                                                                           */
/*		Revision record:                                                     */
/*			11/30/11	Created                                              */
/*                                                                           */
/*****************************************************************************/
 
void WINAPI CallHelp(HWND hDlg, char *szTopic) 
{
	// Local variables
	char szBuffer[BUFFER_SIZE+1];	// Text buffer

	// Compose help file command
	strlcpy(szBuffer, szHelpFile, sizeof(szBuffer));
	strlcat(szBuffer, "::", sizeof(szBuffer));
	strlcat(szBuffer, szTopic, sizeof(szBuffer));
	strlcat(szBuffer, ".HTM", sizeof(szBuffer));
	
	// Invoke help file
	HtmlHelp(hDlg, szBuffer, HH_DISPLAY_TOPIC, 0L);

	// Put info into log file
	WriteLog(56, szTopic);
}